from arcgisscripting import na as cna  # pylint:disable=no-name-in-module
from enum import IntEnum
from typing import Iterable, Union
from arcpy import gp

# List of names exported from this module
__all__ = ["NetworkDatasetQuery", "NetworkEdgeAttributeEvaluator",  "NetworkJunctionAttributeEvaluator",   "NetworkTurnAttributeEvaluator", "NetworkAttributeValue", "NetworkAttributeId", "NetworkElementId", "NetworkSourceId", "NetworkSourceObjectId", "FromPosition", "ToPosition", "FromAzimuthValue", "ToAzimuthValue", "OleDateTime", "NetworkTimeUsage", "NetworkAttributeUsageType", "NetworkAttributeParameterUsageType", "NetworkEdgeDirection"]

NetworkDatasetQuery = cna.NetworkDatasetQuery
NetworkEdgeAttributeEvaluator = cna.NetworkEdgeAttributeEvaluator
NetworkJunctionAttributeEvaluator = cna.NetworkJunctionAttributeEvaluator
NetworkTurnAttributeEvaluator = cna.NetworkTurnAttributeEvaluator

NetworkAttributeValue = Union[int, float, bool]
NetworkAttributeId = int
NetworkElementId = int
NetworkSourceId = int
NetworkSourceObjectId = int
FromPosition = float
ToPosition = float
FromAzimuthValue = float
ToAzimuthValue = float
OleDateTime = float

class NetworkTimeUsage(IntEnum):
    '''Describes various time usage types.'''

    BeforeTraversal = 1
    AfterTraversal = 2

class NetworkAttributeUsageType(IntEnum):
    '''Describes various network attribute usage types.'''

    Cost = 0
    Descriptor = 1
    Restriction = 2
    Hierarchy = 3

class NetworkAttributeParameterUsageType(IntEnum):
    '''Describes various network attribute parameter usage types.'''

    General = 0
    Restriction = 1

class NetworkEdgeDirection(IntEnum):
    '''Describes various network edge directions.'''
    Undefined = 0
    Along = 1
    Against = 2
