﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIMBAVariableListVariable():
    """
      Represents variable of at variable list.
    """
    def __init__(self, *args, **Kwargs):
        self.names = []
        self.valueTypes = []
    
class CIMHuffModelAttractivenessVariable():
    """
      Represents attractiveness variable used in Huff Model.
    """
    def __init__(self, *args, **Kwargs):
        self.name = str()
        self.exponent = 0
    
class CIMHuffModelDistanceParameters():
    """
      Distance properties of the Huff Model calibration item.
    """
    def __init__(self, *args, **Kwargs):
        self.exponent = 0
        self.dataSource = str()
        self.distanceUnits = str()
        self.useTimeUnits = False
        self.timeUnits = esriTimeUnits.esriTimeUnitsMinutes
        self.useNetworkDistance = False
        self.travelModeId = str()
        self.towardsFacility = True
        self.timeOfDay = GetPythonClass('datetime', 'datetime')
        self.timeZone = str()
    
class CIMSegmentationProfile():
    """
      Business Analyst segmentation profile. Segmentation profile represents 
      distribution
    /// of the market (e.g. people or households) 
      between the segments of the segmentation system.
    /// For example, 
      it could represent the distribution of the customer base between 
      the segments.
    /// Segmentation profile can include the volumetric 
      information in addition to the counts,
    /// e.g. it could also 
      provide the distribution of the sales between segments.
    """
    def __init__(self, *args, **Kwargs):
        self.name = str()
        self.segmentationSystem = str()
        self.segmentationBase = str()
        self.hasVolumetricData = False
        self.author = str()
        self.creationDate = GetPythonClass('datetime', 'datetime')
        self.lastRevisionDate = GetPythonClass('datetime', 'datetime')
        self.counts = []
        self.volumetricValues = []
    
class CIMSegmentationTarget():
    """
      Business Analyst segmentation target. Target is a collection of 
      market segments
  /// that are treated as a whole. A user might 
      apply the same marketing strategy to
  /// all segments in a target, 
      for example.
    """
    def __init__(self, *args, **Kwargs):
        self.name = str()
        self.segmentIDs = []
        self.color = 'CIMColor'
    
class CIMSegmentationTargetGroup():
    """
      Business Analyst target group. Target group represents a collection 
      of targets.
    """
    def __init__(self, *args, **Kwargs):
        self.name = str()
        self.segmentationSystem = str()
        self.description = str()
        self.author = str()
        self.creationDate = GetPythonClass('datetime', 'datetime')
        self.lastRevisionDate = GetPythonClass('datetime', 'datetime')
        self.targets = []
        self.visualizationProperties = 'CIMSegmentationTargetGroupVisualizationProperties'
    
class CIMSegmentationTargetGroupVisualizationProperties():
    """
      Visualization properties of Business Analyst Segmentation target 
      group.
    """
    def __init__(self, *args, **Kwargs):
        self.targetProfile = 'CIMSegmentationProfile'
        self.baseProfile = 'CIMSegmentationProfile'
        self.thresholdIndex = 0
        self.thresholdComposition = 0
    
from .CIMDocument import CIMVersion
class CIMBAVariableList(CIMVersion):
    """
      Represents Business Analyst variable list.
    """
    def __init__(self, *args, **Kwargs):
        super().__init__()
        self.name = str()
        self.iconData = str()
        self.author = str()
        self.tags = str()
        self.dataSource = str()
        self.creationDate = GetPythonClass('datetime', 'datetime')
        self.lastRevisionDate = GetPythonClass('datetime', 'datetime')
        self.variables = []
    
class CIMHuffModelCalibrationDocument(CIMVersion):
    """
      Represents a Huff Model calibration.
    """
    def __init__(self, *args, **Kwargs):
        super().__init__()
        self.rMSError = 0
        self.rMSErrorLinear = 0
        self.attractivenessVariables = []
        self.distanceParameters = 'CIMHuffModelDistanceParameters'
        self.facilities = 'CIMDataConnection'
        self.facilitiesIDFieldName = str()
        self.customers = 'CIMDataConnection'
        self.customersIDFieldName = str()
        self.customerWeightFieldName = str()
        self.salesPotential = 'CIMDataConnection'
        self.salesPotentialIDFieldName = str()
        self.author = str()
        self.creationDate = GetPythonClass('datetime', 'datetime')
        self.lastRevisionDate = GetPythonClass('datetime', 'datetime')
    
class CIMSegmentationProfileDocument(CIMVersion):
    """
      Represents a document used for saving segmentation profile.
    """
    def __init__(self, *args, **Kwargs):
        super().__init__()
        self.profile = 'CIMSegmentationProfile'
    
class CIMSegmentationTargetGroupDocument(CIMVersion):
    """
      Represents a document used for saving target group.
    """
    def __init__(self, *args, **Kwargs):
        super().__init__()
        self.targetGroup = 'CIMSegmentationTargetGroup'
    
