﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIMKnowledgeGraphDataLoadingConfiguration():
    """
      Represents a Knowledge Graph Data Loading Configuration.
    """
    def __init__(self, *args, **Kwargs):
        self.name = str()
        self.entities = []
        self.relationships = []
    
class CIMKnowledgeGraphDataLoadingEntity():
    """
      Represents a Knowledge Graph Data Loading Entity.
    """
    def __init__(self, *args, **Kwargs):
        self.name = str()
        self.entityType = str()
        self.typeIsFieldName = False
        self.properties = []
        self.merge = False
    
class CIMKnowledgeGraphDataLoadingRelationship():
    """
      Represents a Knowledge Graph Data Loading Relationship.
    """
    def __init__(self, *args, **Kwargs):
        self.sourceEntityName = str()
        self.relationshipType = str()
        self.typeIsFieldName = False
        self.targetEntityName = str()
        self.properties = []
        self.merge = False
    
class CIMKnowledgeGraphLinkChartCentralityConfiguration():
    """
      Represents the Centrality computation options in a Knowledge Graph 
      Link Chart.
    """
    def __init__(self, *args, **Kwargs):
        self.relationshipsInterpretation = CentralityRelationshipInterpretation.Undirected
        self.multiedgeFactor = 1.0
        self.normalization = CentralityScoresNormalization.eNone
    
class CIMKnowledgeGraphLinkChartProperties():
    """
      Represents a Knowledge Graph Link Chart Properties object.
    """
    def __init__(self, *args, **Kwargs):
        self.nodesURI = str()
        self.linksURI = str()
        self.aggregatedNodesURI = str()
        self.aggregatedLinksURI = str()
        self.autoCollapseRelationships = True
        self.centralityConfiguration = 'CIMKnowledgeGraphLinkChartCentralityConfiguration'
        self.centralityIsUpToDate = True
        self.lastUsedLayout = 'CIMKnowledgeLinkChartLayout'
    
class CIMKnowledgeGraphProperty():
    """
      Represents a Knowledge Graph Data Loading Property used for entities 
      and relationships.
    """
    def __init__(self, *args, **Kwargs):
        self.name = str()
        self.propertyType = esriFieldType.esriFieldTypeSmallInteger
        self.value = 'CIMKnowledgeGraphPropertyValue'
        self.merge = False
    
class CIMKnowledgeGraphPropertyValue():
    """
      Base (indicator) class for all CIMKnowledgeGraphXXXPropertyValue.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKnowledgeLinkChartLayout():
    """
      Represents a Knowledge Link Chart Layout Info object.
    """
    def __init__(self, *args, **Kwargs):
        self.algorithm = KnowledgeLinkChartLayoutAlgorithm.Organic_Standard
    
from .CIMVectorLayers import CIMDataConnection
class CIMKnowledgeGraphDataConnection(CIMDataConnection):
    """
      Represents a Knowledge Graph data connection.
    """
    """
      Represents a Knowledge Graph data connection.
    """
    def __init__(self, *args, **Kwargs):
        super().__init__()
        self.workspaceConnectionString = str()
        self.workspaceFactory = WorkspaceFactory.SDE
        self.customWorkspaceFactoryCLSID = str()
        self.dataset = str()
        self.datasetType = esriDatasetType.esriDTAny
        self.definitionQuery = str()
    
from .CIMCore import CIMDefinition
class CIMKnowledgeGraphInvestigation(CIMDefinition):
    """
      Represents a Knowledge Graph Investigation.
    """
    def __init__(self, *args, **Kwargs):
        super().__init__()
        self.dataConnection = 'CIMDataConnection'
        self.dataLoadingConfigurations = []
    
from .CIMLayer import CIMBaseLayer
class CIMKnowledgeGraphLayer(CIMBaseLayer):
    """
      Provides access to properties of a Knowledge Graph layer.
    """
    """
      Provides access to properties of a Knowledge Graph layer.
    """
    def __init__(self, *args, **Kwargs):
        super().__init__()
        self.standaloneTables = []
        self.dataConnection = 'CIMDataConnection'
        self.layers = []
    
class CIMKnowledgeGraphTableDataConnection(CIMDataConnection):
    """
      Represents a Knowledge Graph data connection.
    """
    """
      Represents a Knowledge Graph data connection.
    """
    """
      Represents a Knowledge Graph data connection.
    """
    def __init__(self, *args, **Kwargs):
        super().__init__()
        self.workspaceConnectionString = str()
        self.workspaceFactory = WorkspaceFactory.SDE
        self.customWorkspaceFactoryCLSID = str()
        self.dataset = str()
        self.datasetType = esriDatasetType.esriDTAny
        self.definitionQuery = str()
        self.inclusionSetURI = str()
    
from .CIMVectorLayers import CIMGeoFeatureLayerBase
class CIMLinkChartFeatureLayer(CIMGeoFeatureLayerBase):
    """
      Represents a Link Chart Feature Layer.
    """
    def __init__(self, *args, **Kwargs):
        super().__init__()
        self.aggregationLayerURI = str()
    
class CIMKnowledgeGraphCoordinatePropertyValue(CIMKnowledgeGraphPropertyValue):
    """
      Represents a coordinate property value.
    """
    def __init__(self, *args, **Kwargs):
        super().__init__()
        self.fieldNames = []
        self.spatialReference = GetPythonClass('arcpy', 'SpatialReference')
        self.interpretAsLongitudeLatitude = False
    
class CIMKnowledgeGraphFieldPropertyValue(CIMKnowledgeGraphPropertyValue):
    """
      Represents a property value from a specific import field.
    """
    def __init__(self, *args, **Kwargs):
        super().__init__()
        self.fieldName = str()
    
class CIMKnowledgeGraphFixedPropertyValue(CIMKnowledgeGraphPropertyValue):
    """
      Represents a fixed string property value.
    """
    def __init__(self, *args, **Kwargs):
        super().__init__()
        self.fixedValue = str()
    
class CIMKnowledgeGraphNonspatialProperty(CIMKnowledgeGraphProperty):
    """
      Represents a Knowledge Graph Data Loading Property used by entities 
      and relationships.
    """
    def __init__(self, *args, **Kwargs):
        super().__init__()
    
class CIMKnowledgeGraphSpatialProperty(CIMKnowledgeGraphProperty):
    """
      Represents a Spatial Knowledge Graph Data Loading Property used 
      for entities.  This
  /// class is expected to be used only when 
      the Type of property is esriFieldTypeGeometry.
    """
    def __init__(self, *args, **Kwargs):
        super().__init__()
        self.spatialReference = GetPythonClass('arcpy', 'SpatialReference')
        self.geometryType = esriGeometryType.esriGeometryPoint
    
