﻿from .ArcpyHelper import GetPythonClass
from .CIMEnum import *
from .CIMExternal import *
from .CIMBusinessAnalyst import *
from .CIMCharts import *
from .CIMColor import *
from .CIMCore import *
from .CIMDataEngineeringView import *
from .CIMDocument import *
from .CIMEffects import *
from .CIMEnumerations import *
from .CIMGALayer import *
from .CIMGraphics import *
from .CIMImageLayers import *
from .CIMKnowledgeGraph import *
from .CIMLabelPlacement import *
from .CIMLayer import *
from .CIMLayout import *
from .CIMLinkCharts import *
from .CIMMap import *
from .CIMNetworkDiagrams import *
from .CIMNetworkLayers import *
from .CIMNumberFormat import *
from .CIMPopup import *
from .CIMServiceLayers import *
from .CIMSymbolizers import *
from .CIMSymbols import *
from .CIMTerrainLayers import *
from .CIMTimelines import *
from .CIMVectorLayers import *

def CreateCIMObjectFromClassName(cim_class_name, cim_version): 
    from .cimloader import ConstructTypeObject, GetClassFromCIM
    type_class = GetClassFromCIM(cim_class_name)
    if type_class:
        type_obj = ConstructTypeObject(type_class, False)
        return type_obj
    else:
        raise LookupError
    return None

def GetJSONForCIMObject(cim_obj, cim_version):
    import json
    from.cimloader import  CimJsonEncoder
    return json.dumps(cim_obj, cls = CimJsonEncoder)
