# -*- coding: utf-8 -*-
# COPYRIGHT 2020 ESRI
#
# TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
# Unpublished material - all rights reserved under the
# Copyright Laws of the United States.
#
# For additional information, contact:
# Environmental Systems Research Institute, Inc.
# Attn: Contracts Dept
# 380 New York Street
# Redlands, California, USA 92373
#
# email: contracts@esri.com
#
# Warning: This module is automatically generated, changes will be overwritten.
from arcgisscripting import _wrapToolRaster, _wrapLocalFunctionRaster
import arcpy
from ..sa import ParameterClasses
from ..sa import Utils

try:
    unicode
except NameError:
    unicode = str


__all__ = [
    "Abs",
    "ACos",
    "ACosH",
    "AggregateMultidimensionalRaster",
    "AnalyzeChangesUsingCCDC",
    "AnalyzeChangesUsingLandTrendr",
    "ApplyGeometricTerrainCorrection",
    "ApplyOrbitCorrection",
    "ApplyRadiometricCalibration",
    "ApplyRadiometricTerrainFlattening",
    "ASin",
    "ASinH",
    "ATan",
    "ATan2",
    "ATanH",
    "BitwiseAnd",
    "BitwiseLeftShift",
    "BitwiseNot",
    "BitwiseOr",
    "BitwiseRightShift",
    "BitwiseXOr",
    "BooleanAnd",
    "BooleanNot",
    "BooleanOr",
    "BooleanXOr",
    "CellStatistics",
    "ClassifyObjectsUsingDeepLearning",
    "ClassifyPixelsUsingDeepLearning",
    "ClassifyRaster",
    "CombinatorialAnd",
    "CombinatorialOr",
    "CombinatorialXOr",
    "ComputeAccuracyForObjectDetection",
    "ComputeChangeRaster",
    "ComputeConfusionMatrix",
    "ComputeSegmentAttributes",
    "Con",
    "ConvertSARUnits",
    "Cos",
    "CosH",
    "CreateAccuracyAssessmentPoints",
    "CreateColorComposite",
    "DeepLearningModelToEcd",
    "Despeckle",
    "DetectChangeUsingChangeAnalysisRaster",
    "DetectChangeUsingDeepLearning",
    "DetectObjectsUsingDeepLearning",
    "Diff",
    "DimensionalMovingStatistics",
    "Divide",
    "DownloadOrbitFile",
    "EqualTo",
    "Exp",
    "Exp10",
    "Exp2",
    "ExportTrainingDataForDeepLearning",
    "ExtractVideoFramesToImages",
    "FindArgumentStatistics",
    "Float",
    "FocalStatistics",
    "GenerateMultidimensionalAnomaly",
    "GenerateTrainingSamplesFromSeedPoints",
    "GenerateTrendRaster",
    "GreaterThan",
    "GreaterThanEqual",
    "InList",
    "InspectTrainingSamples",
    "Int",
    "IsNull",
    "LessThan",
    "LessThanEqual",
    "LinearSpectralUnmixing",
    "Ln",
    "Log10",
    "Log2",
    "Minus",
    "Mod",
    "MultidimensionalPrincipalComponents",
    "Negate",
    "NonMaximumSuppression",
    "NotEqual",
    "Over",
    "Pick",
    "Plus",
    "Power",
    "PredictUsingRegressionModel",
    "PredictUsingTrendRaster",
    "RemoveRasterSegmentTilingArtifacts",
    "RemoveThermalNoise",
    "RoundDown",
    "RoundUp",
    "Sample",
    "SegmentMeanShift",
    "SetNull",
    "Sin",
    "SinH",
    "Square",
    "SquareRoot",
    "SummarizeCategoricalRaster",
    "Tan",
    "TanH",
    "Test",
    "Times",
    "TrainDeepLearningModel",
    "TrainIsoClusterClassifier",
    "TrainKNearestNeighborClassifier",
    "TrainMaximumLikelihoodClassifier",
    "TrainRandomTreesClassifier",
    "TrainRandomTreesRegressionModel",
    "TrainSupportVectorMachineClassifier",
    "UpdateAccuracyAssessmentPoints",
    "VideoMetadataToFeatureClass",
    "VideoMultiplexer",
    "WeightedSum",
    "ZonalStatistics",
    "ZonalStatisticsAsTable",
    "ApplyEnvironment",
    "FloatDivide",
    "FloorDivide"
]


def Abs(
        in_raster_or_constant):
    """Abs_ia(in_raster_or_constant)

    Calculates the absolute value of the cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Abs_sa",
            ["Abs", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Abs.__esri_toolname__ = "Abs_ia"
Abs.__esri_toolinfo__ = [
    "::::1"
]


def ACos(
        in_raster_or_constant):
    """ACos_ia(in_raster_or_constant)

    Calculates the inverse cosine of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ACos_sa",
            ["ACos", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ACos.__esri_toolname__ = "ACos_ia"
ACos.__esri_toolinfo__ = [
    "::::1"
]


def ACosH(
        in_raster_or_constant):
    """ACosH_ia(in_raster_or_constant)

    Calculates the inverse hyperbolic cosine of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ACosH_sa",
            ["ACosH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ACosH.__esri_toolname__ = "ACosH_ia"
ACosH.__esri_toolinfo__ = [
    "::::1"
]


def AggregateMultidimensionalRaster(
        in_multidimensional_raster,
        dimension,
        aggregation_method="#",
        variables="#",
        aggregation_def="#",
        interval_keyword="#",
        interval_value="#",
        interval_unit="#",
        interval_ranges="#",
        aggregation_function="#",
        ignore_nodata="#",
        dimensionless="#",
        percentile_value="#",
        percentile_interpolation_type="#"):
    """AggregateMultidimensionalRaster_ia(in_multidimensional_raster, dimension, {aggregation_method}, {[variable,...]}, {aggregation_def}, {interval_keyword}, {interval_value}, {interval_unit}, {interval_ranges}, {aggregation_function}, {ignore_nodata}, {dimensionless}, {percentile_value}, {percentile_interpolation_type})

    Generates a multidimensional raster dataset by combining existing multidimensional raster variables along a dimension.

    Arguments:
    in_multidimensional_raster -- 
    dimension -- 
    aggregation_method -- 
    variable -- 
    aggregation_def -- 
    interval_keyword -- 
    interval_value -- 
    interval_unit -- 
    interval_ranges -- 
    aggregation_function -- 
    ignore_nodata -- 
    dimensionless -- 
    percentile_value -- 
    percentile_interpolation_type -- 

    Results:
    out_multidimensional_raster -- Output Multidimensional Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_multidimensional_raster,
            dimension,
            aggregation_method,
            variables,
            aggregation_def,
            interval_keyword,
            interval_value,
            interval_unit,
            interval_ranges,
            aggregation_function,
            ignore_nodata,
            dimensionless,
            percentile_value,
            percentile_interpolation_type):
        out_multidimensional_raster = "#"
        result = arcpy.gp.AggregateMultidimensionalRaster_ia(
            in_multidimensional_raster,
            dimension,
            out_multidimensional_raster,
            aggregation_method,
            variables,
            aggregation_def,
            interval_keyword,
            interval_value,
            interval_unit,
            interval_ranges,
            aggregation_function,
            ignore_nodata,
            dimensionless,
            percentile_value,
            percentile_interpolation_type)
        return _wrapToolRaster(u"AggregateMultidimensionalRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_multidimensional_raster,
        dimension,
        aggregation_method,
        variables,
        aggregation_def,
        interval_keyword,
        interval_value,
        interval_unit,
        interval_ranges,
        aggregation_function,
        ignore_nodata,
        dimensionless,
        percentile_value,
        percentile_interpolation_type)
AggregateMultidimensionalRaster.__esri_toolname__ = "AggregateMultidimensionalRaster_ia"
AggregateMultidimensionalRaster.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14",
    "::::15"
]


def AnalyzeChangesUsingCCDC(
        in_multidimensional_raster,
        bands="#",
        tmask_bands="#",
        chi_squared_threshold="#",
        min_anomaly_observations="#",
        update_frequency="#"):
    """AnalyzeChangesUsingCCDC_ia(in_multidimensional_raster, {[band,...]}, {[tmask_band,...]}, {chi_squared_threshold}, {min_anomaly_observations}, {update_frequency})

    Evaluates changes in pixel values over time using the Continuous Change Detection and Classification (CCDC) method and generates a change analysis raster containing the model results.

    Arguments:
    in_multidimensional_raster -- 
    band -- 
    tmask_band -- 
    chi_squared_threshold -- 
    min_anomaly_observations -- 
    update_frequency -- 

    Results:
    out_ccdc_result -- Output CCDC Analysis Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_multidimensional_raster,
            bands,
            tmask_bands,
            chi_squared_threshold,
            min_anomaly_observations,
            update_frequency):
        out_ccdc_result = "#"
        result = arcpy.gp.AnalyzeChangesUsingCCDC_ia(
            in_multidimensional_raster,
            out_ccdc_result,
            bands,
            tmask_bands,
            chi_squared_threshold,
            min_anomaly_observations,
            update_frequency)
        return _wrapToolRaster(u"AnalyzeChangesUsingCCDC_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_multidimensional_raster,
        bands,
        tmask_bands,
        chi_squared_threshold,
        min_anomaly_observations,
        update_frequency)
AnalyzeChangesUsingCCDC.__esri_toolname__ = "AnalyzeChangesUsingCCDC_ia"
AnalyzeChangesUsingCCDC.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def AnalyzeChangesUsingLandTrendr(
        in_multidimensional_raster,
        processing_band="#",
        snapping_date="#",
        max_num_segments="#",
        vertex_count_overshoot="#",
        spike_threshold="#",
        recovery_threshold="#",
        prevent_one_year_recovery="#",
        recovery_trend="#",
        min_num_observations="#",
        best_model_proportion="#",
        pvalue_threshold="#",
        output_other_bands="#"):
    """AnalyzeChangesUsingLandTrendr_ia(in_multidimensional_raster, {processing_band}, {snapping_date}, {max_num_segments}, {vertex_count_overshoot}, {spike_threshold}, {recovery_threshold}, {prevent_one_year_recovery}, {recovery_trend}, {min_num_observations}, {best_model_proportion}, {pvalue_threshold}, {output_other_bands})

    Evaluates changes in pixel values over time using the Landsat-based detection of trends in disturbance and recovery (LandTrendr) method and generates a change analysis raster containing the model results.

    Arguments:
    in_multidimensional_raster -- 
    processing_band -- 
    snapping_date -- 
    max_num_segments -- 
    vertex_count_overshoot -- 
    spike_threshold -- 
    recovery_threshold -- 
    prevent_one_year_recovery -- 
    recovery_trend -- 
    min_num_observations -- 
    best_model_proportion -- 
    pvalue_threshold -- 
    output_other_bands -- 

    Results:
    out_multidimensional_raster -- Output Multidimensional Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_multidimensional_raster,
            processing_band,
            snapping_date,
            max_num_segments,
            vertex_count_overshoot,
            spike_threshold,
            recovery_threshold,
            prevent_one_year_recovery,
            recovery_trend,
            min_num_observations,
            best_model_proportion,
            pvalue_threshold,
            output_other_bands):
        out_multidimensional_raster = "#"
        result = arcpy.gp.AnalyzeChangesUsingLandTrendr_ia(
            in_multidimensional_raster,
            out_multidimensional_raster,
            processing_band,
            snapping_date,
            max_num_segments,
            vertex_count_overshoot,
            spike_threshold,
            recovery_threshold,
            prevent_one_year_recovery,
            recovery_trend,
            min_num_observations,
            best_model_proportion,
            pvalue_threshold,
            output_other_bands)
        return _wrapToolRaster(u"AnalyzeChangesUsingLandTrendr_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_multidimensional_raster,
        processing_band,
        snapping_date,
        max_num_segments,
        vertex_count_overshoot,
        spike_threshold,
        recovery_threshold,
        prevent_one_year_recovery,
        recovery_trend,
        min_num_observations,
        best_model_proportion,
        pvalue_threshold,
        output_other_bands)
AnalyzeChangesUsingLandTrendr.__esri_toolname__ = "AnalyzeChangesUsingLandTrendr_ia"
AnalyzeChangesUsingLandTrendr.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14"
]


def ApplyGeometricTerrainCorrection(
        in_radar_data,
        polarization_bands="#",
        in_dem_raster="#",
        geoid="#"):
    """ApplyGeometricTerrainCorrection_ia(in_radar_data, {[polarization_band,...]}, {in_dem_raster}, {geoid})

    Orthorectifies the input synthetic aperture radar (SAR) data using a range-Doppler backgeocoding algorithm.

    Arguments:
    in_radar_data -- 
    polarization_band -- 
    in_dem_raster -- 
    geoid -- 

    Results:
    out_radar_data -- Output Radar Data"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_radar_data,
            polarization_bands,
            in_dem_raster,
            geoid):
        out_radar_data = "#"
        result = arcpy.gp.ApplyGeometricTerrainCorrection_ia(
            in_radar_data,
            out_radar_data,
            polarization_bands,
            in_dem_raster,
            geoid)
        return _wrapToolRaster(u"ApplyGeometricTerrainCorrection_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_radar_data,
        polarization_bands,
        in_dem_raster,
        geoid)
ApplyGeometricTerrainCorrection.__esri_toolname__ = "ApplyGeometricTerrainCorrection_ia"
ApplyGeometricTerrainCorrection.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5"
]


def ApplyOrbitCorrection(
        in_radar_data,
        in_orbit_file="#"):
    """ApplyOrbitCorrection_ia(in_radar_data, {in_orbit_file})

    Updates the orbital information in the synthetic aperture radar (SAR) dataset using a more accurate orbit state vector file.

    Arguments:
    in_radar_data -- 
    in_orbit_file -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_radar_data,
            in_orbit_file):
        result = arcpy.gp.ApplyOrbitCorrection_ia(
            in_radar_data,
            in_orbit_file)
        return result
    return Wrapper(
        in_radar_data,
        in_orbit_file)
ApplyOrbitCorrection.__esri_toolname__ = "ApplyOrbitCorrection_ia"
ApplyOrbitCorrection.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def ApplyRadiometricCalibration(
        in_radar_data,
        polarization_bands="#",
        calibration_type="#"):
    """ApplyRadiometricCalibration_ia(in_radar_data, {[polarization_band,...]}, {calibration_type})

    Corrects systematic errors in the input synthetic aperture radar (SAR) data  and transforms radar reflectivity into radar backscatter on a reference plane.

    Arguments:
    in_radar_data -- 
    polarization_band -- 
    calibration_type -- 

    Results:
    out_radar_data -- Output Radar Data"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_radar_data,
            polarization_bands,
            calibration_type):
        out_radar_data = "#"
        result = arcpy.gp.ApplyRadiometricCalibration_ia(
            in_radar_data,
            out_radar_data,
            polarization_bands,
            calibration_type)
        return _wrapToolRaster(u"ApplyRadiometricCalibration_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_radar_data,
        polarization_bands,
        calibration_type)
ApplyRadiometricCalibration.__esri_toolname__ = "ApplyRadiometricCalibration_ia"
ApplyRadiometricCalibration.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4"
]


def ApplyRadiometricTerrainFlattening(
        in_radar_data,
        in_dem_raster,
        geoid="#",
        polarization_bands="#",
        calibration_type="#",
        out_scattering_area="#",
        out_geometric_distortion="#",
        out_geometric_distortion_mask="#"):
    """ApplyRadiometricTerrainFlattening_ia(in_radar_data, in_dem_raster, {geoid}, {[polarization_band,...]}, {calibration_type}, {out_scattering_area}, {out_geometric_distortion}, {out_geometric_distortion_mask})

    Corrects the input synthetic aperture radar (SAR) data for radiometric distortions due to topography.

    Arguments:
    in_radar_data -- 
    in_dem_raster -- 
    geoid -- 
    polarization_band -- 
    calibration_type -- 
    out_scattering_area -- 
    out_geometric_distortion -- 
    out_geometric_distortion_mask -- 

    Results:
    out_radar_data -- Output Radar Data"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_radar_data,
            in_dem_raster,
            geoid,
            polarization_bands,
            calibration_type,
            out_scattering_area,
            out_geometric_distortion,
            out_geometric_distortion_mask):
        out_radar_data = "#"
        result = arcpy.gp.ApplyRadiometricTerrainFlattening_ia(
            in_radar_data,
            out_radar_data,
            in_dem_raster,
            geoid,
            polarization_bands,
            calibration_type,
            out_scattering_area,
            out_geometric_distortion,
            out_geometric_distortion_mask)
        return _wrapToolRaster(u"ApplyRadiometricTerrainFlattening_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_radar_data,
        in_dem_raster,
        geoid,
        polarization_bands,
        calibration_type,
        out_scattering_area,
        out_geometric_distortion,
        out_geometric_distortion_mask)
ApplyRadiometricTerrainFlattening.__esri_toolname__ = "ApplyRadiometricTerrainFlattening_ia"
ApplyRadiometricTerrainFlattening.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9"
]


def ASin(
        in_raster_or_constant):
    """ASin_ia(in_raster_or_constant)

    Calculates the inverse sine of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ASin_sa",
            ["ASin", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ASin.__esri_toolname__ = "ASin_ia"
ASin.__esri_toolinfo__ = [
    "::::1"
]


def ASinH(
        in_raster_or_constant):
    """ASinH_ia(in_raster_or_constant)

    Calculates the inverse hyperbolic sine of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ASinH_sa",
            ["ASinH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ASinH.__esri_toolname__ = "ASinH_ia"
ASinH.__esri_toolinfo__ = [
    "::::1"
]


def ATan(
        in_raster_or_constant):
    """ATan_ia(in_raster_or_constant)

    Calculates the inverse tangent of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ATan_sa",
            ["ATan", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ATan.__esri_toolname__ = "ATan_ia"
ATan.__esri_toolinfo__ = [
    "::::1"
]


def ATan2(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """ATan2_ia(in_raster_or_constant1, in_raster_or_constant2)

    Calculates the inverse tangent (based on x,y) of cells in a raster.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"ATan2_sa",
            ["ATan2", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
ATan2.__esri_toolname__ = "ATan2_ia"
ATan2.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def ATanH(
        in_raster_or_constant):
    """ATanH_ia(in_raster_or_constant)

    Calculates the inverse hyperbolic tangent of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ATanH_sa",
            ["ATanH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ATanH.__esri_toolname__ = "ATanH_ia"
ATanH.__esri_toolinfo__ = [
    "::::1"
]


def BitwiseAnd(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BitwiseAnd_ia(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Bitwise And operation on the binary values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BitwiseAnd_sa",
            ["BitwiseAnd", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BitwiseAnd.__esri_toolname__ = "BitwiseAnd_ia"
BitwiseAnd.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BitwiseLeftShift(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BitwiseLeftShift_ia(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Bitwise Left Shift operation on the binary values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BitwiseLeftShift_sa",
            ["BitwiseLeftShift", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BitwiseLeftShift.__esri_toolname__ = "BitwiseLeftShift_ia"
BitwiseLeftShift.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BitwiseNot(
        in_raster_or_constant):
    """BitwiseNot_ia(in_raster_or_constant)

    Performs a Bitwise Not (complement) operation on the binary value of an input raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"BitwiseNot_sa",
            ["BitwiseNot", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
BitwiseNot.__esri_toolname__ = "BitwiseNot_ia"
BitwiseNot.__esri_toolinfo__ = [
    "::::1"
]


def BitwiseOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BitwiseOr_ia(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Bitwise Or operation on the binary values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BitwiseOr_sa",
            ["BitwiseOr", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BitwiseOr.__esri_toolname__ = "BitwiseOr_ia"
BitwiseOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BitwiseRightShift(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BitwiseRightShift_ia(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Bitwise Right Shift operation on the binary values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BitwiseRightShift_sa",
            ["BitwiseRightShift", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BitwiseRightShift.__esri_toolname__ = "BitwiseRightShift_ia"
BitwiseRightShift.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BitwiseXOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BitwiseXOr_ia(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Bitwise eXclusive Or operation on the binary values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BitwiseXOr_sa",
            ["BitwiseXOr", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BitwiseXOr.__esri_toolname__ = "BitwiseXOr_ia"
BitwiseXOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BooleanAnd(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BooleanAnd_ia(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Boolean And operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BooleanAnd_sa",
            ["BooleanAnd", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BooleanAnd.__esri_toolname__ = "BooleanAnd_ia"
BooleanAnd.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BooleanNot(
        in_raster_or_constant):
    """BooleanNot_ia(in_raster_or_constant)

    Performs a Boolean Not (complement) operation on the cell values of the input raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"BooleanNot_sa",
            ["BooleanNot", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
BooleanNot.__esri_toolname__ = "BooleanNot_ia"
BooleanNot.__esri_toolinfo__ = [
    "::::1"
]


def BooleanOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BooleanOr_ia(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Boolean Or operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BooleanOr_sa",
            ["BooleanOr", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BooleanOr.__esri_toolname__ = "BooleanOr_ia"
BooleanOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BooleanXOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BooleanXOr_ia(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Boolean eXclusive Or operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BooleanXOr_sa",
            ["BooleanXOr", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BooleanXOr.__esri_toolname__ = "BooleanXOr_ia"
BooleanXOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def CellStatistics(
        in_rasters_or_constants,
        statistics_type="#",
        ignore_nodata="#",
        process_as_multiband="#",
        percentile_value="#",
        percentile_interpolation_type="#"):
    """CellStatistics_ia([in_rasters_or_constant,...], {statistics_type}, {ignore_nodata}, {process_as_multiband}, {percentile_value}, {percentile_interpolation_type})

    Calculates a per-cell statistic from multiple rasters.

    Arguments:
    in_rasters_or_constant -- 
    statistics_type -- 
    ignore_nodata -- 
    process_as_multiband -- 
    percentile_value -- 
    percentile_interpolation_type -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_rasters_or_constants,
            statistics_type,
            ignore_nodata,
            process_as_multiband,
            percentile_value,
            percentile_interpolation_type):
        statisticsTypes = {
            "MAJORITY": "Majority",
            "MAXIMUM": "Max",
            "MEAN": "Mean",
            "MEDIAN": "Med",
            "MINIMUM": "Min",
            "MINORITY": "Minority",
            "PERCENTILE": "Percentile",
            "RANGE": "Range",
            "STD": "Std",
            "SUM": "Sum",
            "VARIETY": "Variety"
        }
        interpolationTypes = {
            "AUTO_DETECT" : 1,
            "NEAREST" : 2,
            "LINEAR" : 3,
        }
        if Utils.useDefaultArgumentValue(statistics_type):
            statistics_type = "MEAN"
        if not statistics_type in statisticsTypes:
            raise arcpy.ExecuteError("ERROR 000864: Overlay statistic: The input is not within the defined domain.\nERROR 000800: The value is not a member of MEAN | MAJORITY | MAXIMUM | MEDIAN | MINIMUM | MINORITY | PERCENTILE | RANGE | STD | SUM | VARIETY.\n")
        function = statisticsTypes[statistics_type]
        if Utils.useDefaultArgumentValue(ignore_nodata):
            ignore_nodata = "DATA"
        if ignore_nodata not in ["DATA", "NODATA"]:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (CellStatistics). Parameters are not valid.\nERROR 000621: Input to parameter ignore_nodata not within domain.\n")
        if Utils.useDefaultArgumentValue(process_as_multiband):
            process_as_multiband = "SINGLE_BAND"
        if process_as_multiband not in ["SINGLE_BAND", "MULTI_BAND"]:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (CellStatistics). Parameters are not valid.\nERROR 000621: Input to parameter process_as_multiband not within domain.\n")
        if Utils.argumentValueEqualsString(ignore_nodata, "DATA"):
            function += "ContinueOnNoData"
        if Utils.useDefaultArgumentValue(percentile_value):
            percentile_value = 90.0
        if Utils.useDefaultArgumentValue(percentile_interpolation_type):
            percentile_interpolation_type = "AUTO_DETECT"
        if percentile_interpolation_type.upper() not in interpolationTypes:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (CellStatistics). Parameters are not valid.\nERROR 000621: Input to parameter percentile_interpolation_type not within domain.\n")
        return _wrapLocalFunctionRaster(
            u"CellStatistics_sa",
            [function] + Utils.flattenLists(in_rasters_or_constants),
            {
                "flattenBands" : process_as_multiband.upper() == "SINGLE_BAND",
                "PercentileValue" : float(percentile_value),
                "PercentileInterpolationType" : int(interpolationTypes[percentile_interpolation_type]),
            })
    return Wrapper(
        in_rasters_or_constants,
        statistics_type,
        ignore_nodata,
        process_as_multiband,
        percentile_value,
        percentile_interpolation_type)
CellStatistics.__esri_toolname__ = "CellStatistics_ia"
CellStatistics.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def ClassifyObjectsUsingDeepLearning(
        in_raster,
        out_feature_class,
        in_model_definition,
        in_features="#",
        class_label_field="#",
        processing_mode="#",
        model_arguments="#",
        caption_field="#"):
    """ClassifyObjectsUsingDeepLearning_ia(in_raster, out_feature_class, in_model_definition, {in_features}, {class_label_field}, {processing_mode}, {model_arguments}, {caption_field})

    Runs a trained deep learning model on an input raster and an optional feature class to produce a feature class or table in which each input object or feature has an assigned class or category label.

    Arguments:
    in_raster -- 
    out_feature_class -- 
    in_model_definition -- 
    in_features -- 
    class_label_field -- 
    processing_mode -- 
    model_arguments -- 
    caption_field -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            out_feature_class,
            in_model_definition,
            in_features,
            class_label_field,
            processing_mode,
            model_arguments,
            caption_field):
        result = arcpy.gp.ClassifyObjectsUsingDeepLearning_ia(
            in_raster,
            out_feature_class,
            in_model_definition,
            in_features,
            class_label_field,
            processing_mode,
            model_arguments,
            caption_field)
        return result
    return Wrapper(
        in_raster,
        out_feature_class,
        in_model_definition,
        in_features,
        class_label_field,
        processing_mode,
        model_arguments,
        caption_field)
ClassifyObjectsUsingDeepLearning.__esri_toolname__ = "ClassifyObjectsUsingDeepLearning_ia"
ClassifyObjectsUsingDeepLearning.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8"
]


def ClassifyPixelsUsingDeepLearning(
        in_raster,
        in_model_definition,
        arguments="#",
        processing_mode="#",
        out_classified_folder="#"):
    """ClassifyPixelsUsingDeepLearning_ia(in_raster, in_model_definition, {arguments}, {processing_mode}, {out_classified_folder})

    Runs a trained deep learning model on an input raster to produce a classified raster, with each valid pixel having an assigned class label.

    Arguments:
    in_raster -- 
    in_model_definition -- 
    arguments -- 
    processing_mode -- 
    out_classified_folder -- 

    Results:
    out_classified_raster -- Output Classified Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_model_definition,
            arguments,
            processing_mode,
            out_classified_folder):
        out_classified_raster = "#"
        result = arcpy.gp.ClassifyPixelsUsingDeepLearning_ia(
            in_raster,
            out_classified_raster,
            in_model_definition,
            arguments,
            processing_mode,
            out_classified_folder)
        return _wrapToolRaster(u"ClassifyPixelsUsingDeepLearning_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_model_definition,
        arguments,
        processing_mode,
        out_classified_folder)
ClassifyPixelsUsingDeepLearning.__esri_toolname__ = "ClassifyPixelsUsingDeepLearning_ia"
ClassifyPixelsUsingDeepLearning.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def ClassifyRaster(
        in_raster,
        in_classifier_definition,
        in_additional_raster="#"):
    """ClassifyRaster_ia(in_raster, in_classifier_definition, {in_additional_raster})

    Classifies a raster dataset based on an Esri classifier definition file (.ecd) and raster dataset inputs.

    Arguments:
    in_raster -- 
    in_classifier_definition -- 
    in_additional_raster -- 

    Results:
    out_raster_dataset -- Output Classified Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_classifier_definition,
            in_additional_raster):
        out_raster_dataset = "#"
        result = arcpy.gp.ClassifyRaster_ia(
            in_raster,
            in_classifier_definition,
            out_raster_dataset,
            in_additional_raster)
        return _wrapToolRaster(u"ClassifyRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_classifier_definition,
        in_additional_raster)
ClassifyRaster.__esri_toolname__ = "ClassifyRaster_ia"
ClassifyRaster.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def CombinatorialAnd(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """CombinatorialAnd_ia(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Combinatorial And operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        out_raster = "#"
        result = arcpy.gp.CombinatorialAnd_ia(
            in_raster_or_constant1,
            in_raster_or_constant2,
            out_raster)
        return _wrapToolRaster(u"CombinatorialAnd_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
CombinatorialAnd.__esri_toolname__ = "CombinatorialAnd_ia"
CombinatorialAnd.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def CombinatorialOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """CombinatorialOr_ia(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Combinatorial Or operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        out_raster = "#"
        result = arcpy.gp.CombinatorialOr_ia(
            in_raster_or_constant1,
            in_raster_or_constant2,
            out_raster)
        return _wrapToolRaster(u"CombinatorialOr_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
CombinatorialOr.__esri_toolname__ = "CombinatorialOr_ia"
CombinatorialOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def CombinatorialXOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """CombinatorialXOr_ia(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Combinatorial eXclusive Or operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        out_raster = "#"
        result = arcpy.gp.CombinatorialXOr_ia(
            in_raster_or_constant1,
            in_raster_or_constant2,
            out_raster)
        return _wrapToolRaster(u"CombinatorialXOr_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
CombinatorialXOr.__esri_toolname__ = "CombinatorialXOr_ia"
CombinatorialXOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def ComputeAccuracyForObjectDetection(
        detected_features,
        ground_truth_features,
        out_accuracy_table,
        out_accuracy_report="#",
        detected_class_value_field="#",
        ground_truth_class_value_field="#",
        min_iou="#",
        mask_features="#"):
    """ComputeAccuracyForObjectDetection_ia(detected_features, ground_truth_features, out_accuracy_table, {out_accuracy_report}, {detected_class_value_field}, {ground_truth_class_value_field}, {min_iou}, {mask_features})

    Calculates the accuracy of a deep learning model by comparing the detected objects from the Detect Objects Using Deep Learning tool to ground truth data.

    Arguments:
    detected_features -- 
    ground_truth_features -- 
    out_accuracy_table -- 
    out_accuracy_report -- 
    detected_class_value_field -- 
    ground_truth_class_value_field -- 
    min_iou -- 
    mask_features -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            detected_features,
            ground_truth_features,
            out_accuracy_table,
            out_accuracy_report,
            detected_class_value_field,
            ground_truth_class_value_field,
            min_iou,
            mask_features):
        result = arcpy.gp.ComputeAccuracyForObjectDetection_ia(
            detected_features,
            ground_truth_features,
            out_accuracy_table,
            out_accuracy_report,
            detected_class_value_field,
            ground_truth_class_value_field,
            min_iou,
            mask_features)
        return result
    return Wrapper(
        detected_features,
        ground_truth_features,
        out_accuracy_table,
        out_accuracy_report,
        detected_class_value_field,
        ground_truth_class_value_field,
        min_iou,
        mask_features)
ComputeAccuracyForObjectDetection.__esri_toolname__ = "ComputeAccuracyForObjectDetection_ia"
ComputeAccuracyForObjectDetection.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8"
]


def ComputeChangeRaster(
        from_raster,
        to_raster,
        compute_change_method="#",
        from_classes="#",
        to_classes="#",
        filter_method="#",
        define_transition_colors="#",
        from_classname_field="#",
        to_classname_field="#"):
    """ComputeChangeRaster_ia(from_raster, to_raster, {compute_change_method}, {[from_classe,...]}, {[to_classe,...]}, {filter_method}, {define_transition_colors}, {from_classname_field}, {to_classname_field})

    Calculates the absolute, relative, categorical, or spectral difference between two raster datasets.

    Arguments:
    from_raster -- 
    to_raster -- 
    compute_change_method -- 
    from_classe -- 
    to_classe -- 
    filter_method -- 
    define_transition_colors -- 
    from_classname_field -- 
    to_classname_field -- 

    Results:
    out_raster_dataset -- Output Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            from_raster,
            to_raster,
            compute_change_method,
            from_classes,
            to_classes,
            filter_method,
            define_transition_colors,
            from_classname_field,
            to_classname_field):
        out_raster_dataset = "#"
        result = arcpy.gp.ComputeChangeRaster_ia(
            from_raster,
            to_raster,
            out_raster_dataset,
            compute_change_method,
            from_classes,
            to_classes,
            filter_method,
            define_transition_colors,
            from_classname_field,
            to_classname_field)
        return _wrapToolRaster(u"ComputeChangeRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        from_raster,
        to_raster,
        compute_change_method,
        from_classes,
        to_classes,
        filter_method,
        define_transition_colors,
        from_classname_field,
        to_classname_field)
ComputeChangeRaster.__esri_toolname__ = "ComputeChangeRaster_ia"
ComputeChangeRaster.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10"
]


def ComputeConfusionMatrix(
        in_accuracy_assessment_points,
        out_confusion_matrix):
    """ComputeConfusionMatrix_ia(in_accuracy_assessment_points, out_confusion_matrix)

    Computes a confusion matrix with errors of omission and commission and derives a kappa index of agreement, Intersection over Union (IoU),  and an overall accuracy between the classified map and the reference data.

    Arguments:
    in_accuracy_assessment_points -- 
    out_confusion_matrix -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_accuracy_assessment_points,
            out_confusion_matrix):
        result = arcpy.gp.ComputeConfusionMatrix_ia(
            in_accuracy_assessment_points,
            out_confusion_matrix)
        return result
    return Wrapper(
        in_accuracy_assessment_points,
        out_confusion_matrix)
ComputeConfusionMatrix.__esri_toolname__ = "ComputeConfusionMatrix_ia"
ComputeConfusionMatrix.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def ComputeSegmentAttributes(
        in_segmented_raster,
        in_additional_raster="#",
        used_attributes="#"):
    """ComputeSegmentAttributes_ia(in_segmented_raster, {in_additional_raster}, {[used_attribute,...]})

    Computes a set of attributes associated with the segmented image. The input raster can be a single-band or 3-band, 8-bit segmented image.

    Arguments:
    in_segmented_raster -- 
    in_additional_raster -- 
    used_attribute -- 

    Results:
    out_index_raster_dataset -- Output Segment Index Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_segmented_raster,
            in_additional_raster,
            used_attributes):
        out_index_raster_dataset = "#"
        result = arcpy.gp.ComputeSegmentAttributes_ia(
            in_segmented_raster,
            out_index_raster_dataset,
            in_additional_raster,
            used_attributes)
        return _wrapToolRaster(u"ComputeSegmentAttributes_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_segmented_raster,
        in_additional_raster,
        used_attributes)
ComputeSegmentAttributes.__esri_toolname__ = "ComputeSegmentAttributes_ia"
ComputeSegmentAttributes.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4"
]


def Con(
        in_conditional_raster,
        in_true_raster_or_constant,
        in_false_raster_or_constant="#",
        where_clause="#"):
    """Con_ia(in_conditional_raster, in_true_raster_or_constant, {in_false_raster_or_constant}, {where_clause})

    Performs a conditional if/else evaluation on each of the input cells of an input raster.

    Arguments:
    in_conditional_raster -- 
    in_true_raster_or_constant -- 
    in_false_raster_or_constant -- 
    where_clause -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_conditional_raster,
            in_true_raster_or_constant,
            in_false_raster_or_constant,
            where_clause):
        if Utils.useDefaultArgumentValue(where_clause):
            if Utils.useDefaultArgumentValue(in_false_raster_or_constant):
                return _wrapLocalFunctionRaster(u"Con_sa",
                    ["IfThen", in_conditional_raster, in_true_raster_or_constant])
            else:
                return _wrapLocalFunctionRaster(u"Con_sa",
                    ["IfThenElse", in_conditional_raster, in_true_raster_or_constant, in_false_raster_or_constant])
        out_raster = "#"
        result = arcpy.gp.Con_ia(
            in_conditional_raster,
            in_true_raster_or_constant,
            out_raster,
            in_false_raster_or_constant,
            where_clause)
        return _wrapToolRaster(u"Con_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_conditional_raster,
        in_true_raster_or_constant,
        in_false_raster_or_constant,
        where_clause)
Con.__esri_toolname__ = "Con_ia"
Con.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5"
]


def ConvertSARUnits(
        in_radar_data,
        conversion_type="#"):
    """ConvertSARUnits_ia(in_radar_data, {conversion_type})

    Converts the scaling of the input synthetic aperture radar (SAR) data between amplitude and power and between  linear and decibels (dB).

    Arguments:
    in_radar_data -- 
    conversion_type -- 

    Results:
    out_radar_data -- Output Radar Data"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_radar_data,
            conversion_type):
        out_radar_data = "#"
        result = arcpy.gp.ConvertSARUnits_ia(
            in_radar_data,
            out_radar_data,
            conversion_type)
        return _wrapToolRaster(u"ConvertSARUnits_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_radar_data,
        conversion_type)
ConvertSARUnits.__esri_toolname__ = "ConvertSARUnits_ia"
ConvertSARUnits.__esri_toolinfo__ = [
    "::::1",
    "::::3"
]


def Cos(
        in_raster_or_constant):
    """Cos_ia(in_raster_or_constant)

    Calculates the cosine of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Cos_sa",
            ["Cos", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Cos.__esri_toolname__ = "Cos_ia"
Cos.__esri_toolinfo__ = [
    "::::1"
]


def CosH(
        in_raster_or_constant):
    """CosH_ia(in_raster_or_constant)

    Calculates the hyperbolic cosine of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"CosH_sa",
            ["CosH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
CosH.__esri_toolname__ = "CosH_ia"
CosH.__esri_toolinfo__ = [
    "::::1"
]


def CreateAccuracyAssessmentPoints(
        in_class_data,
        out_points,
        target_field="#",
        num_random_points="#",
        sampling="#",
        polygon_dimension_field="#"):
    """CreateAccuracyAssessmentPoints_ia(in_class_data, out_points, {target_field}, {num_random_points}, {sampling}, {polygon_dimension_field})

    Creates randomly sampled points for post-classification accuracy assessment.

    Arguments:
    in_class_data -- 
    out_points -- 
    target_field -- 
    num_random_points -- 
    sampling -- 
    polygon_dimension_field -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_class_data,
            out_points,
            target_field,
            num_random_points,
            sampling,
            polygon_dimension_field):
        result = arcpy.gp.CreateAccuracyAssessmentPoints_ia(
            in_class_data,
            out_points,
            target_field,
            num_random_points,
            sampling,
            polygon_dimension_field)
        return result
    return Wrapper(
        in_class_data,
        out_points,
        target_field,
        num_random_points,
        sampling,
        polygon_dimension_field)
CreateAccuracyAssessmentPoints.__esri_toolname__ = "CreateAccuracyAssessmentPoints_ia"
CreateAccuracyAssessmentPoints.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def CreateColorComposite(
        in_raster,
        method,
        red_expression,
        green_expression,
        blue_expression):
    """CreateColorComposite_ia(in_raster, method, red_expression, green_expression, blue_expression)

    Creates a three-band raster dataset from a multiband raster dataset.

    Arguments:
    in_raster -- 
    method -- 
    red_expression -- 
    green_expression -- 
    blue_expression -- 

    Results:
    out_raster -- Output Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            method,
            red_expression,
            green_expression,
            blue_expression):
        out_raster = "#"
        result = arcpy.gp.CreateColorComposite_ia(
            in_raster,
            out_raster,
            method,
            red_expression,
            green_expression,
            blue_expression)
        return _wrapToolRaster(u"CreateColorComposite_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        method,
        red_expression,
        green_expression,
        blue_expression)
CreateColorComposite.__esri_toolname__ = "CreateColorComposite_ia"
CreateColorComposite.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def DeepLearningModelToEcd(
        in_deep_learning_model,
        in_classification_info_json,
        out_classifier_definition):
    """DeepLearningModelToEcd_ia(in_deep_learning_model, in_classification_info_json, out_classifier_definition)

    Converts a deep learning model to an Esri classifier definition file (.ecd).

    Arguments:
    in_deep_learning_model -- 
    in_classification_info_json -- 
    out_classifier_definition -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_deep_learning_model,
            in_classification_info_json,
            out_classifier_definition):
        result = arcpy.gp.DeepLearningModelToEcd_ia(
            in_deep_learning_model,
            in_classification_info_json,
            out_classifier_definition)
        return result
    return Wrapper(
        in_deep_learning_model,
        in_classification_info_json,
        out_classifier_definition)
DeepLearningModelToEcd.__esri_toolname__ = "DeepLearningModelToEcd_ia"
DeepLearningModelToEcd.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3"
]


def Despeckle(
        in_radar_data,
        polarization_bands="#",
        filter_type="#",
        filter_size="#",
        noise_model="#",
        noise_variance="#",
        add_noise_mean="#",
        mult_noise_mean="#",
        number_of_looks="#",
        damp_factor="#"):
    """Despeckle_ia(in_radar_data, {[polarization_band,...]}, {filter_type}, {filter_size}, {noise_model}, {noise_variance}, {add_noise_mean}, {mult_noise_mean}, {number_of_looks}, {damp_factor})

    Corrects the input synthetic aperture radar (SAR) data for speckle, which is high-frequency noise that resembles a salt and pepper effect.

    Arguments:
    in_radar_data -- 
    polarization_band -- 
    filter_type -- 
    filter_size -- 
    noise_model -- 
    noise_variance -- 
    add_noise_mean -- 
    mult_noise_mean -- 
    number_of_looks -- 
    damp_factor -- 

    Results:
    out_radar_data -- Output Radar Data"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_radar_data,
            polarization_bands,
            filter_type,
            filter_size,
            noise_model,
            noise_variance,
            add_noise_mean,
            mult_noise_mean,
            number_of_looks,
            damp_factor):
        out_radar_data = "#"
        result = arcpy.gp.Despeckle_ia(
            in_radar_data,
            out_radar_data,
            polarization_bands,
            filter_type,
            filter_size,
            noise_model,
            noise_variance,
            add_noise_mean,
            mult_noise_mean,
            number_of_looks,
            damp_factor)
        return _wrapToolRaster(u"Despeckle_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_radar_data,
        polarization_bands,
        filter_type,
        filter_size,
        noise_model,
        noise_variance,
        add_noise_mean,
        mult_noise_mean,
        number_of_looks,
        damp_factor)
Despeckle.__esri_toolname__ = "Despeckle_ia"
Despeckle.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11"
]


def DetectChangeUsingChangeAnalysisRaster(
        in_change_analysis_raster,
        change_type,
        max_number_changes="#",
        segment_date="#",
        change_direction="#",
        filter_by_year="#",
        min_year="#",
        max_year="#",
        filter_by_duration="#",
        min_duration="#",
        max_duration="#",
        filter_by_magnitude="#",
        min_magnitude="#",
        max_magnitude="#",
        filter_by_start_value="#",
        min_start_value="#",
        max_start_value="#",
        filter_by_end_value="#",
        min_end_value="#",
        max_end_value="#"):
    """DetectChangeUsingChangeAnalysisRaster_ia(in_change_analysis_raster, change_type, {max_number_changes}, {segment_date}, {change_direction}, {filter_by_year}, {min_year}, {max_year}, {filter_by_duration}, {min_duration}, {max_duration}, {filter_by_magnitude}, {min_magnitude}, {max_magnitude}, {filter_by_start_value}, {min_start_value}, {max_start_value}, {filter_by_end_value}, {min_end_value}, {max_end_value})

    Generates a raster containing pixel change information using the output change analysis raster from the Analyze Changes Using CCDC tool or the Analyze Changes Using LandTrendr tool.

    Arguments:
    in_change_analysis_raster -- 
    change_type -- 
    max_number_changes -- 
    segment_date -- 
    change_direction -- 
    filter_by_year -- 
    min_year -- 
    max_year -- 
    filter_by_duration -- 
    min_duration -- 
    max_duration -- 
    filter_by_magnitude -- 
    min_magnitude -- 
    max_magnitude -- 
    filter_by_start_value -- 
    min_start_value -- 
    max_start_value -- 
    filter_by_end_value -- 
    min_end_value -- 
    max_end_value -- 

    Results:
    out_raster -- Output Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_change_analysis_raster,
            change_type,
            max_number_changes,
            segment_date,
            change_direction,
            filter_by_year,
            min_year,
            max_year,
            filter_by_duration,
            min_duration,
            max_duration,
            filter_by_magnitude,
            min_magnitude,
            max_magnitude,
            filter_by_start_value,
            min_start_value,
            max_start_value,
            filter_by_end_value,
            min_end_value,
            max_end_value):
        out_raster = "#"
        result = arcpy.gp.DetectChangeUsingChangeAnalysisRaster_ia(
            in_change_analysis_raster,
            out_raster,
            change_type,
            max_number_changes,
            segment_date,
            change_direction,
            filter_by_year,
            min_year,
            max_year,
            filter_by_duration,
            min_duration,
            max_duration,
            filter_by_magnitude,
            min_magnitude,
            max_magnitude,
            filter_by_start_value,
            min_start_value,
            max_start_value,
            filter_by_end_value,
            min_end_value,
            max_end_value)
        return _wrapToolRaster(u"DetectChangeUsingChangeAnalysisRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_change_analysis_raster,
        change_type,
        max_number_changes,
        segment_date,
        change_direction,
        filter_by_year,
        min_year,
        max_year,
        filter_by_duration,
        min_duration,
        max_duration,
        filter_by_magnitude,
        min_magnitude,
        max_magnitude,
        filter_by_start_value,
        min_start_value,
        max_start_value,
        filter_by_end_value,
        min_end_value,
        max_end_value)
DetectChangeUsingChangeAnalysisRaster.__esri_toolname__ = "DetectChangeUsingChangeAnalysisRaster_ia"
DetectChangeUsingChangeAnalysisRaster.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14",
    "::::15",
    "::::16",
    "::::17",
    "::::18",
    "::::19",
    "::::20",
    "::::21"
]


def DetectChangeUsingDeepLearning(
        from_raster,
        to_raster,
        in_model_definition,
        arguments="#"):
    """DetectChangeUsingDeepLearning_ia(from_raster, to_raster, in_model_definition, {arguments})

    Runs a trained deep learning model to detect change between two rasters.

    Arguments:
    from_raster -- 
    to_raster -- 
    in_model_definition -- 
    arguments -- 

    Results:
    out_classified_raster -- Output Classified Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            from_raster,
            to_raster,
            in_model_definition,
            arguments):
        out_classified_raster = "#"
        result = arcpy.gp.DetectChangeUsingDeepLearning_ia(
            from_raster,
            to_raster,
            out_classified_raster,
            in_model_definition,
            arguments)
        return _wrapToolRaster(u"DetectChangeUsingDeepLearning_sa", unicode(result.getOutput(0)))
    return Wrapper(
        from_raster,
        to_raster,
        in_model_definition,
        arguments)
DetectChangeUsingDeepLearning.__esri_toolname__ = "DetectChangeUsingDeepLearning_ia"
DetectChangeUsingDeepLearning.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5"
]


def DetectObjectsUsingDeepLearning(
        in_raster,
        out_detected_objects,
        in_model_definition,
        arguments="#",
        run_nms="#",
        confidence_score_field="#",
        class_value_field="#",
        max_overlap_ratio="#",
        processing_mode="#"):
    """DetectObjectsUsingDeepLearning_ia(in_raster, out_detected_objects, in_model_definition, {arguments}, {run_nms}, {confidence_score_field}, {class_value_field}, {max_overlap_ratio}, {processing_mode})

    Runs a trained deep learning model on an input raster to produce a feature class containing the objects it finds. The features can be bounding boxes or polygons around the objects found or points at the centers of the objects.

    Arguments:
    in_raster -- 
    out_detected_objects -- 
    in_model_definition -- 
    arguments -- 
    run_nms -- 
    confidence_score_field -- 
    class_value_field -- 
    max_overlap_ratio -- 
    processing_mode -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            out_detected_objects,
            in_model_definition,
            arguments,
            run_nms,
            confidence_score_field,
            class_value_field,
            max_overlap_ratio,
            processing_mode):
        result = arcpy.gp.DetectObjectsUsingDeepLearning_ia(
            in_raster,
            out_detected_objects,
            in_model_definition,
            arguments,
            run_nms,
            confidence_score_field,
            class_value_field,
            max_overlap_ratio,
            processing_mode)
        return result
    return Wrapper(
        in_raster,
        out_detected_objects,
        in_model_definition,
        arguments,
        run_nms,
        confidence_score_field,
        class_value_field,
        max_overlap_ratio,
        processing_mode)
DetectObjectsUsingDeepLearning.__esri_toolname__ = "DetectObjectsUsingDeepLearning_ia"
DetectObjectsUsingDeepLearning.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9"
]


def Diff(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Diff_ia(in_raster_or_constant1, in_raster_or_constant2)

    Determines which values from the first input are logically different from the values of the second input on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Diff_sa",
            ["Diff", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Diff.__esri_toolname__ = "Diff_ia"
Diff.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def DimensionalMovingStatistics(
        in_raster,
        dimension="#",
        backward_window="#",
        forward_window="#",
        nodata_handling="#",
        statistics_type="#",
        percentile_value="#",
        percentile_interpolation_type="#",
        circular_wrap_value="#"):
    """DimensionalMovingStatistics_ia(in_raster, {dimension}, {backward_window}, {forward_window}, {nodata_handling}, {statistics_type}, {percentile_value}, {percentile_interpolation_type}, {circular_wrap_value})

    Calculates statistics over a moving window on multidimensional data along a specified dimension.

    Arguments:
    in_raster -- 
    dimension -- 
    backward_window -- 
    forward_window -- 
    nodata_handling -- 
    statistics_type -- 
    percentile_value -- 
    percentile_interpolation_type -- 
    circular_wrap_value -- 

    Results:
    out_raster -- Output Multidimensional Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            dimension,
            backward_window,
            forward_window,
            nodata_handling,
            statistics_type,
            percentile_value,
            percentile_interpolation_type,
            circular_wrap_value):
        out_raster = Utils.UNEVALUATED_RASTER_FUNCTION_SIGNAL
        result = arcpy.gp.DimensionalMovingStatistics_ia(
            in_raster,
            out_raster,
            dimension,
            backward_window,
            forward_window,
            nodata_handling,
            statistics_type,
            percentile_value,
            percentile_interpolation_type,
            circular_wrap_value)
        import json
        rfx_args = json.loads(result.getOutput(1))
        in_raster = arcpy.Raster(in_raster)
        in_raster = ApplyEnvironment(in_raster)
        out_raster_afr = arcpy.ia.Apply(in_raster, "DimensionalMovingStatistics", rfx_args)
        out_raster_afr = ApplyEnvironment(out_raster_afr)
        # Return an unevaluated raster function chain
        return out_raster_afr
    return Wrapper(
        in_raster,
        dimension,
        backward_window,
        forward_window,
        nodata_handling,
        statistics_type,
        percentile_value,
        percentile_interpolation_type,
        circular_wrap_value)
DimensionalMovingStatistics.__esri_toolname__ = "DimensionalMovingStatistics_ia"
DimensionalMovingStatistics.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10"
]


def Divide(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Divide_ia(in_raster_or_constant1, in_raster_or_constant2)

    Divides the values of two rasters on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Divide_sa",
            ["Divide", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Divide.__esri_toolname__ = "Divide_ia"
Divide.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def DownloadOrbitFile(
        in_radar_data,
        orbit_type="#",
        username="#",
        password="#"):
    """DownloadOrbitFile_ia(in_radar_data, {orbit_type}, {username}, {password})

    Downloads the updated orbit  files for the  input synthetic aperture radar (SAR) data.

    Arguments:
    in_radar_data -- 
    orbit_type -- 
    username -- 
    password -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_radar_data,
            orbit_type,
            username,
            password):
        result = arcpy.gp.DownloadOrbitFile_ia(
            in_radar_data,
            orbit_type,
            username,
            password)
        return result
    return Wrapper(
        in_radar_data,
        orbit_type,
        username,
        password)
DownloadOrbitFile.__esri_toolname__ = "DownloadOrbitFile_ia"
DownloadOrbitFile.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4"
]


def EqualTo(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """EqualTo_ia(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational equal-to operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"EqualTo_sa",
            ["EqualTo", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
EqualTo.__esri_toolname__ = "EqualTo_ia"
EqualTo.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def Exp(
        in_raster_or_constant):
    """Exp_ia(in_raster_or_constant)

    Calculates the base e exponential of the cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Exp_sa",
            ["Exp", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Exp.__esri_toolname__ = "Exp_ia"
Exp.__esri_toolinfo__ = [
    "::::1"
]


def Exp10(
        in_raster_or_constant):
    """Exp10_ia(in_raster_or_constant)

    Calculates the base 10 exponential of the cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Exp10_sa",
            ["Exp10", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Exp10.__esri_toolname__ = "Exp10_ia"
Exp10.__esri_toolinfo__ = [
    "::::1"
]


def Exp2(
        in_raster_or_constant):
    """Exp2_ia(in_raster_or_constant)

    Calculates the base 2 exponential of the cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Exp2_sa",
            ["Exp2", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Exp2.__esri_toolname__ = "Exp2_ia"
Exp2.__esri_toolinfo__ = [
    "::::1"
]


def ExportTrainingDataForDeepLearning(
        in_raster,
        out_folder,
        in_class_data="#",
        image_chip_format="#",
        tile_size_x="#",
        tile_size_y="#",
        stride_x="#",
        stride_y="#",
        output_nofeature_tiles="#",
        metadata_format="#",
        start_index="#",
        class_value_field="#",
        buffer_radius="#",
        in_mask_polygons="#",
        rotation_angle="#",
        reference_system="#",
        processing_mode="#",
        blacken_around_feature="#",
        crop_mode="#",
        in_raster2="#",
        in_instance_data="#",
        instance_class_value_field="#",
        min_polygon_overlap_ratio="#"):
    """ExportTrainingDataForDeepLearning_ia(in_raster, out_folder, {in_class_data}, {image_chip_format}, {tile_size_x}, {tile_size_y}, {stride_x}, {stride_y}, {output_nofeature_tiles}, {metadata_format}, {start_index}, {class_value_field}, {buffer_radius}, {in_mask_polygons}, {rotation_angle}, {reference_system}, {processing_mode}, {blacken_around_feature}, {crop_mode}, {in_raster2}, {in_instance_data}, {instance_class_value_field}, {min_polygon_overlap_ratio})

    Converts labeled vector or raster data into deep learning training datasets using a remote sensing image. The output will be a folder of image chips and a folder of metadata files in the specified format.

    Arguments:
    in_raster -- 
    out_folder -- 
    in_class_data -- 
    image_chip_format -- 
    tile_size_x -- 
    tile_size_y -- 
    stride_x -- 
    stride_y -- 
    output_nofeature_tiles -- 
    metadata_format -- 
    start_index -- 
    class_value_field -- 
    buffer_radius -- 
    in_mask_polygons -- 
    rotation_angle -- 
    reference_system -- 
    processing_mode -- 
    blacken_around_feature -- 
    crop_mode -- 
    in_raster2 -- 
    in_instance_data -- 
    instance_class_value_field -- 
    min_polygon_overlap_ratio -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            out_folder,
            in_class_data,
            image_chip_format,
            tile_size_x,
            tile_size_y,
            stride_x,
            stride_y,
            output_nofeature_tiles,
            metadata_format,
            start_index,
            class_value_field,
            buffer_radius,
            in_mask_polygons,
            rotation_angle,
            reference_system,
            processing_mode,
            blacken_around_feature,
            crop_mode,
            in_raster2,
            in_instance_data,
            instance_class_value_field,
            min_polygon_overlap_ratio):
        result = arcpy.gp.ExportTrainingDataForDeepLearning_ia(
            in_raster,
            out_folder,
            in_class_data,
            image_chip_format,
            tile_size_x,
            tile_size_y,
            stride_x,
            stride_y,
            output_nofeature_tiles,
            metadata_format,
            start_index,
            class_value_field,
            buffer_radius,
            in_mask_polygons,
            rotation_angle,
            reference_system,
            processing_mode,
            blacken_around_feature,
            crop_mode,
            in_raster2,
            in_instance_data,
            instance_class_value_field,
            min_polygon_overlap_ratio)
        return result
    return Wrapper(
        in_raster,
        out_folder,
        in_class_data,
        image_chip_format,
        tile_size_x,
        tile_size_y,
        stride_x,
        stride_y,
        output_nofeature_tiles,
        metadata_format,
        start_index,
        class_value_field,
        buffer_radius,
        in_mask_polygons,
        rotation_angle,
        reference_system,
        processing_mode,
        blacken_around_feature,
        crop_mode,
        in_raster2,
        in_instance_data,
        instance_class_value_field,
        min_polygon_overlap_ratio)
ExportTrainingDataForDeepLearning.__esri_toolname__ = "ExportTrainingDataForDeepLearning_ia"
ExportTrainingDataForDeepLearning.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14",
    "::::15",
    "::::16",
    "::::17",
    "::::18",
    "::::19",
    "::::20",
    "::::21",
    "::::22",
    "::::23"
]


def ExtractVideoFramesToImages(
        in_video,
        out_folder,
        image_type="#",
        image_overlap="#",
        require_fresh_metadata="#",
        min_time="#"):
    """ExtractVideoFramesToImages_ia(in_video, out_folder, {image_type}, {image_overlap}, {require_fresh_metadata}, {min_time})

    Extracts video frame images and associated metadata from a FMV-compliant video stream.  The extracted images can be added to a mosaic dataset or other tools and functions for further analysis.

    Arguments:
    in_video -- 
    out_folder -- 
    image_type -- 
    image_overlap -- 
    require_fresh_metadata -- 
    min_time -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_video,
            out_folder,
            image_type,
            image_overlap,
            require_fresh_metadata,
            min_time):
        result = arcpy.gp.ExtractVideoFramesToImages_ia(
            in_video,
            out_folder,
            image_type,
            image_overlap,
            require_fresh_metadata,
            min_time)
        return result
    return Wrapper(
        in_video,
        out_folder,
        image_type,
        image_overlap,
        require_fresh_metadata,
        min_time)
ExtractVideoFramesToImages.__esri_toolname__ = "ExtractVideoFramesToImages_ia"
ExtractVideoFramesToImages.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def FindArgumentStatistics(
        in_raster,
        dimension="#",
        dimension_def="#",
        interval_keyword="#",
        variables="#",
        statistics_type="#",
        min="#",
        max="#",
        multiple_occurrence="#",
        ignore_nodata="#",
        value="#",
        comparison="#",
        occurrence="#"):
    """FindArgumentStatistics_ia(in_raster, {dimension}, {dimension_def}, {interval_keyword}, {[variable,...]}, {statistics_type}, {min}, {max}, {multiple_occurrence}, {ignore_nodata}, {value}, {comparison}, {occurrence})

    Extracts the dimension value or band index at which a given statistic is attained for each pixel in a multidimensional or multiband raster.

    Arguments:
    in_raster -- 
    dimension -- 
    dimension_def -- 
    interval_keyword -- 
    variable -- 
    statistics_type -- 
    min -- 
    max -- 
    multiple_occurrence -- 
    ignore_nodata -- 
    value -- 
    comparison -- 
    occurrence -- 

    Results:
    out_raster -- Output Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            dimension,
            dimension_def,
            interval_keyword,
            variables,
            statistics_type,
            min,
            max,
            multiple_occurrence,
            ignore_nodata,
            value,
            comparison,
            occurrence):
        out_raster = "#"
        result = arcpy.gp.FindArgumentStatistics_ia(
            in_raster,
            out_raster,
            dimension,
            dimension_def,
            interval_keyword,
            variables,
            statistics_type,
            min,
            max,
            multiple_occurrence,
            ignore_nodata,
            value,
            comparison,
            occurrence)
        return _wrapToolRaster(u"FindArgumentStatistics_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        dimension,
        dimension_def,
        interval_keyword,
        variables,
        statistics_type,
        min,
        max,
        multiple_occurrence,
        ignore_nodata,
        value,
        comparison,
        occurrence)
FindArgumentStatistics.__esri_toolname__ = "FindArgumentStatistics_ia"
FindArgumentStatistics.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14"
]


def Float(
        in_raster_or_constant):
    """Float_ia(in_raster_or_constant)

    Converts each cell value of a raster into a floating-point representation.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Float_sa",
            ["Float", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Float.__esri_toolname__ = "Float_ia"
Float.__esri_toolinfo__ = [
    "::::1"
]


def FocalStatistics(
        in_raster,
        neighborhood="#",
        statistics_type="#",
        ignore_nodata="#",
        percentile_value="#"):
    """FocalStatistics_ia(in_raster, {neighborhood}, {statistics_type}, {ignore_nodata}, {percentile_value})

    Calculates for each input cell location a statistic of the values within a specified neighborhood around it.

    Arguments:
    in_raster -- 
    neighborhood -- 
    statistics_type -- 
    ignore_nodata -- 
    percentile_value -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            neighborhood,
            statistics_type,
            ignore_nodata,
            percentile_value):
        neighborhood = Utils.compoundParameterToString(neighborhood, ParameterClasses._Neighborhood)
        args = {}
        # Neighborhood parameter
        nbr_types = {
            # values from esriRasterNeighborhoodEnum
            "RECTANGLE": 1,
            "CIRCLE": 2,
            "ANNULUS": 3,
            "WEDGE": 4,
            "IRREGULAR": 5,
            "WEIGHT": 6,
        }
        # Set defaults
        nbr_index = nbr_types["RECTANGLE"]  # Default neighborhood type
        args["Width"] = 3
        args["Height"] = 3
        in_raster = ApplyEnvironment(in_raster)
        # Parse and validate parameters
        msgs = Utils.ParameterErrors()
        # Neighborhood type
        nbr_fields = [f for f in neighborhood.split() if f]  # discard empty fields
        cell_scale = 1.0
        def _parse_float(f):
            try:
                from locale import atof as _atof
                return _atof(f)  # localized string
            except AttributeError:
                return float(f)  # number
        if len(nbr_fields) > 0:
            nbr_string = nbr_fields[0].upper()
            if nbr_string in nbr_types.keys():
                nbr_index = nbr_types[nbr_fields[0].upper()]
            if nbr_fields[-1].upper() == "MAP":
                cell_scale = _parse_float(arcpy.GetRasterProperties_management(in_raster, "CELLSIZEX").getOutput(0))
        def _cs(field: str, scale: float = cell_scale) -> int:  # convert MAP units to CELL units
            raw = _parse_float(field)
            if raw <= 0:
                msgs.add_id_message("ERROR", 622, "FocalStatistics")
                msgs.add_id_message("ERROR", 628, "neighborhood")
                raise arcpy.ExecuteError(msgs.combine())
            result = int(0.5 + raw / float(scale))
            if result <= 0:
                msgs.add_id_message("ERROR", 10176)  # Invalid neighborhood mask
                msgs.add_id_message("INFO", 952, "FocalStatistics")  # Failed to execute (tool_name).
                raise arcpy.ExecuteError(msgs.combine())
            return result
        args["NeighborhoodType"] = nbr_index
        if nbr_index == nbr_types["ANNULUS"]:
            if len(nbr_fields) >= 3:
                args["InnerRadius"] = _cs(nbr_fields[1])
                args["OuterRadius"] = _cs(nbr_fields[2])
            else:
                args["InnerRadius"] = 1
                args["OuterRadius"] = 3
        elif nbr_index == nbr_types["CIRCLE"]:
            if len(nbr_fields) > 1:
                args["Radius"] = _cs(nbr_fields[1])
            else:
                args["Radius"] = 3
        elif nbr_index == nbr_types["RECTANGLE"]:
            if len(nbr_fields) >= 3:
                args["Width"] = _cs(nbr_fields[1])
                args["Height"] = _cs(nbr_fields[2])
            else:
                args["Width"] = 3
                args["Height"] = 3
        elif nbr_index == nbr_types["WEDGE"]:
            if len(nbr_fields) >= 4:
                args["Radius"] = _cs(nbr_fields[1])
                args["StartAngle"] = _parse_float(nbr_fields[2])
                args["EndAngle"] = _parse_float(nbr_fields[3])
            else:
                args["Radius"] = 3
                args["StartAngle"] = 0
                args["EndAngle"] = 90
        elif nbr_index in (nbr_types["WEIGHT"], nbr_types["IRREGULAR"]):
            # Parse kernel file
            assert len(nbr_fields) == 2
            file_name = nbr_fields[1].strip("\"'")
            values = []
            with open(file_name, "r") as kernel_file:
                w, h = [int(s) for s in next(kernel_file).split()]
                for row in kernel_file:
                    for col in row.split():
                        values.append(_parse_float(col))
                assert len(values) == w * h
                args["Width"] = w
                args["Height"] = h
                args["NeighborhoodValues"] = values
        # Statistics type parameter
        stat_types = {
            # values from esriGeoAnalysisStatisticsEnum
            "MAJORITY": 1,
            "MAXIMUM": 2,
            "MEAN": 3,
            "MEDIAN": 4,
            "MINIMUM": 5,
            "MINORITY": 6,
            "RANGE": 7,
            "STANDARD_DEVIATION": 8,
            "STD": 8,
            "SUM": 9,
            "VARIETY": 10,
            "PERCENTILE": 12,
        }
        args["StatisticType"] = stat_types.get(str(statistics_type).upper(), stat_types["MEAN"])
        #
        args["NoDataPolicy"] = 0 if ignore_nodata.upper() == "NODATA" else -1
        try:
            args["Percentile"] = _parse_float(percentile_value)
        except ValueError:
            args["Percentile"] = 90.0
        result = arcpy.sa.Apply(in_raster, "Focal", args)
        result = ApplyEnvironment(result)
        return result
    return Wrapper(
        in_raster,
        neighborhood,
        statistics_type,
        ignore_nodata,
        percentile_value)
FocalStatistics.__esri_toolname__ = "FocalStatistics_ia"
FocalStatistics.__esri_toolinfo__ = [
    "::::1",
    "Python::NbrAnnulus|NbrCircle|NbrIrregular|NbrRectangle|NbrWedge|NbrWeight::",
    "::::4",
    "::::5",
    "::::6"
]


def GenerateMultidimensionalAnomaly(
        in_multidimensional_raster,
        variables="#",
        method="#",
        calculation_interval="#",
        ignore_nodata="#",
        reference_mean_raster="#"):
    """GenerateMultidimensionalAnomaly_ia(in_multidimensional_raster, {[variable,...]}, {method}, {calculation_interval}, {ignore_nodata}, {reference_mean_raster})

    Computes the anomaly for each slice in an existing multidimensional raster to generate a new multidimensional raster.

    Arguments:
    in_multidimensional_raster -- 
    variable -- 
    method -- 
    calculation_interval -- 
    ignore_nodata -- 
    reference_mean_raster -- 

    Results:
    out_multidimensional_raster -- Output Multidimensional Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_multidimensional_raster,
            variables,
            method,
            calculation_interval,
            ignore_nodata,
            reference_mean_raster):
        out_multidimensional_raster = "#"
        result = arcpy.gp.GenerateMultidimensionalAnomaly_ia(
            in_multidimensional_raster,
            out_multidimensional_raster,
            variables,
            method,
            calculation_interval,
            ignore_nodata,
            reference_mean_raster)
        return _wrapToolRaster(u"GenerateMultidimensionalAnomaly_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_multidimensional_raster,
        variables,
        method,
        calculation_interval,
        ignore_nodata,
        reference_mean_raster)
GenerateMultidimensionalAnomaly.__esri_toolname__ = "GenerateMultidimensionalAnomaly_ia"
GenerateMultidimensionalAnomaly.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def GenerateTrainingSamplesFromSeedPoints(
        in_class_data,
        in_seed_points,
        out_training_feature_class,
        min_sample_area="#",
        max_sample_radius="#"):
    """GenerateTrainingSamplesFromSeedPoints_ia(in_class_data, in_seed_points, out_training_feature_class, {min_sample_area}, {max_sample_radius})

    Generates training samples from seed points, such as accuracy assessment points or training sample points. A typical use case is generating training samples from an existing source, such as a thematic raster or a feature class.

    Arguments:
    in_class_data -- 
    in_seed_points -- 
    out_training_feature_class -- 
    min_sample_area -- 
    max_sample_radius -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_class_data,
            in_seed_points,
            out_training_feature_class,
            min_sample_area,
            max_sample_radius):
        result = arcpy.gp.GenerateTrainingSamplesFromSeedPoints_ia(
            in_class_data,
            in_seed_points,
            out_training_feature_class,
            min_sample_area,
            max_sample_radius)
        return result
    return Wrapper(
        in_class_data,
        in_seed_points,
        out_training_feature_class,
        min_sample_area,
        max_sample_radius)
GenerateTrainingSamplesFromSeedPoints.__esri_toolname__ = "GenerateTrainingSamplesFromSeedPoints_ia"
GenerateTrainingSamplesFromSeedPoints.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5"
]


def GenerateTrendRaster(
        in_multidimensional_raster,
        dimension,
        variables="#",
        line_type="#",
        frequency="#",
        ignore_nodata="#",
        cycle_length="#",
        cycle_unit="#",
        rmse="#",
        r2="#",
        slope_p_value="#",
        seasonal_period="#"):
    """GenerateTrendRaster_ia(in_multidimensional_raster, dimension, {[variable,...]}, {line_type}, {frequency}, {ignore_nodata}, {cycle_length}, {cycle_unit}, {rmse}, {r2}, {slope_p_value}, {seasonal_period})

    Estimates the trend for each pixel along a dimension for one or more variables in a multidimensional raster.

    Arguments:
    in_multidimensional_raster -- 
    dimension -- 
    variable -- 
    line_type -- 
    frequency -- 
    ignore_nodata -- 
    cycle_length -- 
    cycle_unit -- 
    rmse -- 
    r2 -- 
    slope_p_value -- 
    seasonal_period -- 

    Results:
    out_multidimensional_raster -- Output Multidimensional Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_multidimensional_raster,
            dimension,
            variables,
            line_type,
            frequency,
            ignore_nodata,
            cycle_length,
            cycle_unit,
            rmse,
            r2,
            slope_p_value,
            seasonal_period):
        out_multidimensional_raster = "#"
        result = arcpy.gp.GenerateTrendRaster_ia(
            in_multidimensional_raster,
            out_multidimensional_raster,
            dimension,
            variables,
            line_type,
            frequency,
            ignore_nodata,
            cycle_length,
            cycle_unit,
            rmse,
            r2,
            slope_p_value,
            seasonal_period)
        return _wrapToolRaster(u"GenerateTrendRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_multidimensional_raster,
        dimension,
        variables,
        line_type,
        frequency,
        ignore_nodata,
        cycle_length,
        cycle_unit,
        rmse,
        r2,
        slope_p_value,
        seasonal_period)
GenerateTrendRaster.__esri_toolname__ = "GenerateTrendRaster_ia"
GenerateTrendRaster.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13"
]


def GreaterThan(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """GreaterThan_ia(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational greater-than operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"GreaterThan_sa",
            ["GreaterThan", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
GreaterThan.__esri_toolname__ = "GreaterThan_ia"
GreaterThan.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def GreaterThanEqual(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """GreaterThanEqual_ia(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational greater-than-or-equal-to operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"GreaterThanEqual_sa",
            ["GreaterThanEqual", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
GreaterThanEqual.__esri_toolname__ = "GreaterThanEqual_ia"
GreaterThanEqual.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def InList(
        in_raster_or_constant,
        in_raster_or_constants,
        process_as_multiband="#"):
    """InList_ia(in_raster_or_constant, [in_raster_or_constant,...], {process_as_multiband})

    Determines which values from the first input are contained in a set of other inputs, on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant -- 
    in_raster_or_constant -- 
    process_as_multiband -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant,
            in_raster_or_constants,
            process_as_multiband):
        if Utils.useDefaultArgumentValue(process_as_multiband):
            process_as_multiband = "SINGLE_BAND"
        if process_as_multiband not in ["SINGLE_BAND", "MULTI_BAND"]:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (InList). Parameters are not valid.\nERROR 000621: Input to parameter process_as_multiband not within domain.\n")
        return _wrapLocalFunctionRaster(u"InList_ia", ["InList", in_raster_or_constant] + Utils.flattenLists(in_raster_or_constants), {"flattenBands" : process_as_multiband.upper() == "SINGLE_BAND"})
    return Wrapper(
        in_raster_or_constant,
        in_raster_or_constants,
        process_as_multiband)
InList.__esri_toolname__ = "InList_ia"
InList.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def InspectTrainingSamples(
        in_raster,
        in_training_features,
        in_classifier_definition,
        out_training_feature_class,
        in_additional_raster="#"):
    """InspectTrainingSamples_ia(in_raster, in_training_features, in_classifier_definition, out_training_feature_class, {in_additional_raster})

    Estimates the accuracy of individual training samples. The cross validation accuracy is computed using the previously generated classification training result in an .ecd file and the training samples. Outputs include a raster dataset containing the misclassified class values and a training sample dataset with the accuracy score for each training sample.

    Arguments:
    in_raster -- 
    in_training_features -- 
    in_classifier_definition -- 
    out_training_feature_class -- 
    in_additional_raster -- 

    Results:
    out_misclassified_raster -- Output Misclassified Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_training_features,
            in_classifier_definition,
            out_training_feature_class,
            in_additional_raster):
        out_misclassified_raster = "#"
        result = arcpy.gp.InspectTrainingSamples_ia(
            in_raster,
            in_training_features,
            in_classifier_definition,
            out_training_feature_class,
            out_misclassified_raster,
            in_additional_raster)
        return _wrapToolRaster(u"InspectTrainingSamples_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_training_features,
        in_classifier_definition,
        out_training_feature_class,
        in_additional_raster)
InspectTrainingSamples.__esri_toolname__ = "InspectTrainingSamples_ia"
InspectTrainingSamples.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::6"
]


def Int(
        in_raster_or_constant):
    """Int_ia(in_raster_or_constant)

    Converts each cell value of a raster to an integer by truncation.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Int_sa",
            ["Int", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Int.__esri_toolname__ = "Int_ia"
Int.__esri_toolinfo__ = [
    "::::1"
]


def IsNull(
        in_raster):
    """IsNull_ia(in_raster)

    Determines which values from the input raster are NoData on a cell-by-cell basis.

    Arguments:
    in_raster -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster):
        return _wrapLocalFunctionRaster(u"IsNull_sa",
            ["IsNull", in_raster])
    return Wrapper(
        in_raster)
IsNull.__esri_toolname__ = "IsNull_ia"
IsNull.__esri_toolinfo__ = [
    "::::1"
]


def LessThan(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """LessThan_ia(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational less-than operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"LessThan_sa",
            ["LessThan", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
LessThan.__esri_toolname__ = "LessThan_ia"
LessThan.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def LessThanEqual(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """LessThanEqual_ia(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational less-than-or-equal-to operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"LessThanEqual_sa",
            ["LessThanEqual", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
LessThanEqual.__esri_toolname__ = "LessThanEqual_ia"
LessThanEqual.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def LinearSpectralUnmixing(
        in_raster,
        in_spectral_profile_file,
        value_option="#"):
    """LinearSpectralUnmixing_ia(in_raster, in_spectral_profile_file, {[value_option,...]})

    Performs subpixel classification and calculates the fractional abundance of different land cover types for individual pixels.

    Arguments:
    in_raster -- 
    in_spectral_profile_file -- 
    value_option -- 

    Results:
    out_raster -- Output Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_spectral_profile_file,
            value_option):
        out_raster = "#"
        result = arcpy.gp.LinearSpectralUnmixing_ia(
            in_raster,
            out_raster,
            in_spectral_profile_file,
            value_option)
        return _wrapToolRaster(u"LinearSpectralUnmixing_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_spectral_profile_file,
        value_option)
LinearSpectralUnmixing.__esri_toolname__ = "LinearSpectralUnmixing_ia"
LinearSpectralUnmixing.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4"
]


def Ln(
        in_raster_or_constant):
    """Ln_ia(in_raster_or_constant)

    Calculates the natural logarithm (base e) of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Ln_sa",
            ["Ln", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Ln.__esri_toolname__ = "Ln_ia"
Ln.__esri_toolinfo__ = [
    "::::1"
]


def Log10(
        in_raster_or_constant):
    """Log10_ia(in_raster_or_constant)

    Calculates the base 10 logarithm of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Log10_sa",
            ["Log10", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Log10.__esri_toolname__ = "Log10_ia"
Log10.__esri_toolinfo__ = [
    "::::1"
]


def Log2(
        in_raster_or_constant):
    """Log2_ia(in_raster_or_constant)

    Calculates the base 2 logarithm of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Log2_sa",
            ["Log2", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Log2.__esri_toolname__ = "Log2_ia"
Log2.__esri_toolinfo__ = [
    "::::1"
]


def Minus(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Minus_ia(in_raster_or_constant1, in_raster_or_constant2)

    Subtracts the value of the second input raster from the value of the first input raster on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Minus_sa",
            ["Minus", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Minus.__esri_toolname__ = "Minus_ia"
Minus.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def Mod(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Mod_ia(in_raster_or_constant1, in_raster_or_constant2)

    Finds the remainder (modulo) of the first raster when divided by the second raster on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Mod_sa",
            ["Mod", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Mod.__esri_toolname__ = "Mod_ia"
Mod.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def MultidimensionalPrincipalComponents(
        in_multidimensional_raster,
        mode,
        dimension,
        out_pc,
        out_loadings,
        out_eigenvalues="#",
        variable="#",
        number_of_pc="#"):
    """MultidimensionalPrincipalComponents_ia(in_multidimensional_raster, mode, dimension, out_pc, out_loadings, {out_eigenvalues}, {variable}, {number_of_pc})

    Transforms multidimensional rasters into  their principal components, loadings, and eigenvalues. The tool transforms the data into a reduced number of components that account for the variance of the data, so that spatial and temporal patterns can be readily identified.

    Arguments:
    in_multidimensional_raster -- 
    mode -- 
    dimension -- 
    out_pc -- 
    out_loadings -- 
    out_eigenvalues -- 
    variable -- 
    number_of_pc -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_multidimensional_raster,
            mode,
            dimension,
            out_pc,
            out_loadings,
            out_eigenvalues,
            variable,
            number_of_pc):
        result = arcpy.gp.MultidimensionalPrincipalComponents_ia(
            in_multidimensional_raster,
            mode,
            dimension,
            out_pc,
            out_loadings,
            out_eigenvalues,
            variable,
            number_of_pc)
        return result
    return Wrapper(
        in_multidimensional_raster,
        mode,
        dimension,
        out_pc,
        out_loadings,
        out_eigenvalues,
        variable,
        number_of_pc)
MultidimensionalPrincipalComponents.__esri_toolname__ = "MultidimensionalPrincipalComponents_ia"
MultidimensionalPrincipalComponents.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8"
]


def Negate(
        in_raster_or_constant):
    """Negate_ia(in_raster_or_constant)

    Changes the sign (multiplies by -1) of the cell values of the input raster on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Negate_sa",
            ["Negate", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Negate.__esri_toolname__ = "Negate_ia"
Negate.__esri_toolinfo__ = [
    "::::1"
]


def NonMaximumSuppression(
        in_featureclass,
        confidence_score_field,
        out_featureclass,
        class_value_field="#",
        max_overlap_ratio="#"):
    """NonMaximumSuppression_ia(in_featureclass, confidence_score_field, out_featureclass, {class_value_field}, {max_overlap_ratio})

    Identifies duplicate features from the output of the Detect Objects Using Deep Learning tool as a postprocessing step and creates a new output with no duplicate features. The Detect Objects Using Deep Learning tool can return more than one bounding box or polygon for the same object, especially as a tiling side effect. If two features overlap more than a given maximum ratio, the feature with the lower confidence value will be removed.

    Arguments:
    in_featureclass -- 
    confidence_score_field -- 
    out_featureclass -- 
    class_value_field -- 
    max_overlap_ratio -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_featureclass,
            confidence_score_field,
            out_featureclass,
            class_value_field,
            max_overlap_ratio):
        result = arcpy.gp.NonMaximumSuppression_ia(
            in_featureclass,
            confidence_score_field,
            out_featureclass,
            class_value_field,
            max_overlap_ratio)
        return result
    return Wrapper(
        in_featureclass,
        confidence_score_field,
        out_featureclass,
        class_value_field,
        max_overlap_ratio)
NonMaximumSuppression.__esri_toolname__ = "NonMaximumSuppression_ia"
NonMaximumSuppression.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5"
]


def NotEqual(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """NotEqual_ia(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational not-equal-to operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"NotEqual_sa",
            ["NotEqual", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
NotEqual.__esri_toolname__ = "NotEqual_ia"
NotEqual.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def Over(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Over_ia(in_raster_or_constant1, in_raster_or_constant2)

    For the cell values in the first input that are not 0, the output value will be that of the first input. Where the cell values are 0, the output will be that of the second input raster.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Over_sa",
            ["Over", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Over.__esri_toolname__ = "Over_ia"
Over.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def Pick(
        in_position_raster,
        in_rasters_or_constants,
        process_as_multiband="#"):
    """Pick_ia(in_position_raster, [in_rasters_or_constant,...], {process_as_multiband})

    The value from a position raster is used to determine from which raster in a list of input rasters the output cell value will be obtained.

    Arguments:
    in_position_raster -- 
    in_rasters_or_constant -- 
    process_as_multiband -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_position_raster,
            in_rasters_or_constants,
            process_as_multiband):
        if Utils.useDefaultArgumentValue(process_as_multiband):
            process_as_multiband = "SINGLE_BAND"
        if process_as_multiband not in ["SINGLE_BAND", "MULTI_BAND"]:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (Pick). Parameters are not valid.\nERROR 000621: Input to parameter process_as_multiband not within domain.\n")
        return _wrapLocalFunctionRaster(u"Pick_ia", ["Pick", in_position_raster] + Utils.flattenLists(in_rasters_or_constants), {"flattenBands" : process_as_multiband.upper() == "SINGLE_BAND"})
    return Wrapper(
        in_position_raster,
        in_rasters_or_constants,
        process_as_multiband)
Pick.__esri_toolname__ = "Pick_ia"
Pick.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def Plus(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Plus_ia(in_raster_or_constant1, in_raster_or_constant2)

    Adds (sums) the values of two rasters on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Plus_sa",
            ["Plus", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Plus.__esri_toolname__ = "Plus_ia"
Plus.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def Power(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Power_ia(in_raster_or_constant1, in_raster_or_constant2)

    Raises the cell values in a raster to the power of the values found in another raster.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Power_sa",
            ["Power", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Power.__esri_toolname__ = "Power_ia"
Power.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def PredictUsingRegressionModel(
        in_rasters,
        in_regression_definition):
    """PredictUsingRegressionModel_ia([in_raster,...], in_regression_definition)

    Predicts data values using the output from the Train Random Trees Regression Model tool.

    Arguments:
    in_raster -- 
    in_regression_definition -- 

    Results:
    out_raster_dataset -- Output predicted raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_rasters,
            in_regression_definition):
        out_raster_dataset = "#"
        result = arcpy.gp.PredictUsingRegressionModel_ia(
            in_rasters,
            in_regression_definition,
            out_raster_dataset)
        return _wrapToolRaster(u"PredictUsingRegressionModel_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_rasters,
        in_regression_definition)
PredictUsingRegressionModel.__esri_toolname__ = "PredictUsingRegressionModel_ia"
PredictUsingRegressionModel.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def PredictUsingTrendRaster(
        in_multidimensional_raster,
        variables="#",
        dimension_def="#",
        dimension_values="#",
        start="#",
        end="#",
        interval_value="#",
        interval_unit="#"):
    """PredictUsingTrendRaster_ia(in_multidimensional_raster, {[variable,...]}, {dimension_def}, {[dimension_value,...]}, {start}, {end}, {interval_value}, {interval_unit})

    Computes a forecasted multidimensional raster using the output trend raster from the Generate Trend Raster tool.

    Arguments:
    in_multidimensional_raster -- 
    variable -- 
    dimension_def -- 
    dimension_value -- 
    start -- 
    end -- 
    interval_value -- 
    interval_unit -- 

    Results:
    out_multidimensional_raster -- Output Multidimensional Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_multidimensional_raster,
            variables,
            dimension_def,
            dimension_values,
            start,
            end,
            interval_value,
            interval_unit):
        out_multidimensional_raster = "#"
        result = arcpy.gp.PredictUsingTrendRaster_ia(
            in_multidimensional_raster,
            out_multidimensional_raster,
            variables,
            dimension_def,
            dimension_values,
            start,
            end,
            interval_value,
            interval_unit)
        return _wrapToolRaster(u"PredictUsingTrendRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_multidimensional_raster,
        variables,
        dimension_def,
        dimension_values,
        start,
        end,
        interval_value,
        interval_unit)
PredictUsingTrendRaster.__esri_toolname__ = "PredictUsingTrendRaster_ia"
PredictUsingTrendRaster.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9"
]


def RemoveRasterSegmentTilingArtifacts(
        in_segmented_raster,
        tileSizeX="#",
        tileSizeY="#"):
    """RemoveRasterSegmentTilingArtifacts_ia(in_segmented_raster, {tileSizeX}, {tileSizeY})

    Corrects segments or objects cut by tile boundaries during the segmentation process performed as a raster function. This tool is helpful for some regional processes, such as image segmentation, that have inconsistencies near image tile boundaries.

    Arguments:
    in_segmented_raster -- 
    tileSizeX -- 
    tileSizeY -- 

    Results:
    out_raster_dataset -- Output Segmented Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_segmented_raster,
            tileSizeX,
            tileSizeY):
        out_raster_dataset = "#"
        result = arcpy.gp.RemoveRasterSegmentTilingArtifacts_ia(
            in_segmented_raster,
            out_raster_dataset,
            tileSizeX,
            tileSizeY)
        return _wrapToolRaster(u"RemoveRasterSegmentTilingArtifacts_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_segmented_raster,
        tileSizeX,
        tileSizeY)
RemoveRasterSegmentTilingArtifacts.__esri_toolname__ = "RemoveRasterSegmentTilingArtifacts_ia"
RemoveRasterSegmentTilingArtifacts.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4"
]


def RemoveThermalNoise(
        in_radar_data,
        polarization_bands="#"):
    """RemoveThermalNoise_ia(in_radar_data, {[polarization_band,...]})

    Corrects backscatter disturbances caused by thermal noise in the input synthetic aperture radar (SAR) data, resulting in a more seamless image.

    Arguments:
    in_radar_data -- 
    polarization_band -- 

    Results:
    out_radar_data -- Output Radar Data"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_radar_data,
            polarization_bands):
        out_radar_data = "#"
        result = arcpy.gp.RemoveThermalNoise_ia(
            in_radar_data,
            out_radar_data,
            polarization_bands)
        return _wrapToolRaster(u"RemoveThermalNoise_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_radar_data,
        polarization_bands)
RemoveThermalNoise.__esri_toolname__ = "RemoveThermalNoise_ia"
RemoveThermalNoise.__esri_toolinfo__ = [
    "::::1",
    "::::3"
]


def RoundDown(
        in_raster_or_constant):
    """RoundDown_ia(in_raster_or_constant)

    Returns the next lower integer value, just represented as a floating point, for each cell in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"RoundDown_sa",
            ["RoundDown", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
RoundDown.__esri_toolname__ = "RoundDown_ia"
RoundDown.__esri_toolinfo__ = [
    "::::1"
]


def RoundUp(
        in_raster_or_constant):
    """RoundUp_ia(in_raster_or_constant)

    Returns the next higher integer value, just represented as a floating point, for each cell in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"RoundUp_sa",
            ["RoundUp", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
RoundUp.__esri_toolname__ = "RoundUp_ia"
RoundUp.__esri_toolinfo__ = [
    "::::1"
]


def Sample(
        in_rasters,
        in_location_data,
        out_table,
        resampling_type="#",
        unique_id_field="#",
        process_as_multidimensional="#",
        acquisition_definition="#",
        statistics_type="#",
        percentile_value="#",
        buffer_distance="#",
        layout="#",
        generate_feature_class="#"):
    """Sample_ia([in_raster,...], in_location_data, out_table, {resampling_type}, {unique_id_field}, {process_as_multidimensional}, {acquisition_definition}, {statistics_type}, {percentile_value}, {buffer_distance}, {layout}, {generate_feature_class})

    Creates a table or a point feature class that shows the values of cells from a raster, or a set of rasters, for defined locations. The locations are defined by raster cells, points, polylines, or polygons.

    Arguments:
    in_raster -- 
    in_location_data -- 
    out_table -- 
    resampling_type -- 
    unique_id_field -- 
    process_as_multidimensional -- 
    acquisition_definition -- 
    statistics_type -- 
    percentile_value -- 
    buffer_distance -- 
    layout -- 
    generate_feature_class -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_rasters,
            in_location_data,
            out_table,
            resampling_type,
            unique_id_field,
            process_as_multidimensional,
            acquisition_definition,
            statistics_type,
            percentile_value,
            buffer_distance,
            layout,
            generate_feature_class):
        result = arcpy.gp.Sample_ia(
            in_rasters,
            in_location_data,
            out_table,
            resampling_type,
            unique_id_field,
            process_as_multidimensional,
            acquisition_definition,
            statistics_type,
            percentile_value,
            buffer_distance,
            layout,
            generate_feature_class)
        return result
    return Wrapper(
        in_rasters,
        in_location_data,
        out_table,
        resampling_type,
        unique_id_field,
        process_as_multidimensional,
        acquisition_definition,
        statistics_type,
        percentile_value,
        buffer_distance,
        layout,
        generate_feature_class)
Sample.__esri_toolname__ = "Sample_ia"
Sample.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12"
]


def SegmentMeanShift(
        in_raster,
        spectral_detail="#",
        spatial_detail="#",
        min_segment_size="#",
        band_indexes="#",
        max_segment_size="#"):
    """SegmentMeanShift_ia(in_raster, {spectral_detail}, {spatial_detail}, {min_segment_size}, {band_indexes}, {max_segment_size})

    Groups into segments adjacent pixels that have similar spectral characteristics.

    Arguments:
    in_raster -- 
    spectral_detail -- 
    spatial_detail -- 
    min_segment_size -- 
    band_indexes -- 
    max_segment_size -- 

    Results:
    out_raster_dataset -- Output Raster Dataset"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            spectral_detail,
            spatial_detail,
            min_segment_size,
            band_indexes,
            max_segment_size):
        out_raster_dataset = "#"
        result = arcpy.gp.SegmentMeanShift_ia(
            in_raster,
            out_raster_dataset,
            spectral_detail,
            spatial_detail,
            min_segment_size,
            band_indexes,
            max_segment_size)
        return _wrapToolRaster(u"SegmentMeanShift_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        spectral_detail,
        spatial_detail,
        min_segment_size,
        band_indexes,
        max_segment_size)
SegmentMeanShift.__esri_toolname__ = "SegmentMeanShift_ia"
SegmentMeanShift.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def SetNull(
        in_conditional_raster,
        in_false_raster_or_constant,
        where_clause="#"):
    """SetNull_ia(in_conditional_raster, in_false_raster_or_constant, {where_clause})

    Set Null sets identified cell locations to NoData based on a specified criteria. It returns NoData if a conditional evaluation is true, and returns the value specified by another raster if it is false.

    Arguments:
    in_conditional_raster -- 
    in_false_raster_or_constant -- 
    where_clause -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_conditional_raster,
            in_false_raster_or_constant,
            where_clause):
        if Utils.useDefaultArgumentValue(where_clause):
            return _wrapLocalFunctionRaster(u"SetNull_sa",
                ["SetNull", in_conditional_raster, in_false_raster_or_constant])
        out_raster = "#"
        result = arcpy.gp.SetNull_ia(
            in_conditional_raster,
            in_false_raster_or_constant,
            out_raster,
            where_clause)
        return _wrapToolRaster(u"SetNull_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_conditional_raster,
        in_false_raster_or_constant,
        where_clause)
SetNull.__esri_toolname__ = "SetNull_ia"
SetNull.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def Sin(
        in_raster_or_constant):
    """Sin_ia(in_raster_or_constant)

    Calculates the sine of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Sin_sa",
            ["Sin", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Sin.__esri_toolname__ = "Sin_ia"
Sin.__esri_toolinfo__ = [
    "::::1"
]


def SinH(
        in_raster_or_constant):
    """SinH_ia(in_raster_or_constant)

    Calculates the hyperbolic sine of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"SinH_sa",
            ["SinH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
SinH.__esri_toolname__ = "SinH_ia"
SinH.__esri_toolinfo__ = [
    "::::1"
]


def Square(
        in_raster_or_constant):
    """Square_ia(in_raster_or_constant)

    Calculates the square of the cell values in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Square_sa",
            ["Square", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Square.__esri_toolname__ = "Square_ia"
Square.__esri_toolinfo__ = [
    "::::1"
]


def SquareRoot(
        in_raster_or_constant):
    """SquareRoot_ia(in_raster_or_constant)

    Calculates the square root of the cell values in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"SquareRoot_sa",
            ["SquareRoot", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
SquareRoot.__esri_toolname__ = "SquareRoot_ia"
SquareRoot.__esri_toolinfo__ = [
    "::::1"
]


def SummarizeCategoricalRaster(
        in_raster,
        out_table,
        dimension="#",
        aoi="#",
        aoi_id_field="#"):
    """SummarizeCategoricalRaster_ia(in_raster, out_table, {dimension}, {aoi}, {aoi_id_field})

    Generates a table containing the pixel count for each class, in each slice of an input categorical raster.

    Arguments:
    in_raster -- 
    out_table -- 
    dimension -- 
    aoi -- 
    aoi_id_field -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            out_table,
            dimension,
            aoi,
            aoi_id_field):
        result = arcpy.gp.SummarizeCategoricalRaster_ia(
            in_raster,
            out_table,
            dimension,
            aoi,
            aoi_id_field)
        return result
    return Wrapper(
        in_raster,
        out_table,
        dimension,
        aoi,
        aoi_id_field)
SummarizeCategoricalRaster.__esri_toolname__ = "SummarizeCategoricalRaster_ia"
SummarizeCategoricalRaster.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5"
]


def Tan(
        in_raster_or_constant):
    """Tan_ia(in_raster_or_constant)

    Calculates the tangent of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Tan_sa",
            ["Tan", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Tan.__esri_toolname__ = "Tan_ia"
Tan.__esri_toolinfo__ = [
    "::::1"
]


def TanH(
        in_raster_or_constant):
    """TanH_ia(in_raster_or_constant)

    Calculates the hyperbolic tangent of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"TanH_sa",
            ["TanH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
TanH.__esri_toolname__ = "TanH_ia"
TanH.__esri_toolinfo__ = [
    "::::1"
]


def Test(
        in_raster,
        where_clause):
    """Test_ia(in_raster, where_clause)

    Performs a Boolean evaluation of the input raster using a logical expression.

    Arguments:
    in_raster -- 
    where_clause -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            where_clause):
        out_raster = "#"
        result = arcpy.gp.Test_ia(
            in_raster,
            where_clause,
            out_raster)
        return _wrapToolRaster(u"Test_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        where_clause)
Test.__esri_toolname__ = "Test_ia"
Test.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def Times(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Times_ia(in_raster_or_constant1, in_raster_or_constant2)

    Multiplies the values of two rasters on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Times_sa",
            ["Times", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Times.__esri_toolname__ = "Times_ia"
Times.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def TrainDeepLearningModel(
        in_folder,
        out_folder,
        max_epochs="#",
        model_type="#",
        batch_size="#",
        arguments="#",
        learning_rate="#",
        backbone_model="#",
        pretrained_model="#",
        validation_percentage="#",
        stop_training="#",
        freeze="#"):
    """TrainDeepLearningModel_ia([in_folder,...], out_folder, {max_epochs}, {model_type}, {batch_size}, {arguments}, {learning_rate}, {backbone_model}, {pretrained_model}, {validation_percentage}, {stop_training}, {freeze})

    Trains a deep learning model using the output from the Export Training Data For Deep Learning tool.

    Arguments:
    in_folder -- 
    out_folder -- 
    max_epochs -- 
    model_type -- 
    batch_size -- 
    arguments -- 
    learning_rate -- 
    backbone_model -- 
    pretrained_model -- 
    validation_percentage -- 
    stop_training -- 
    freeze -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_folder,
            out_folder,
            max_epochs,
            model_type,
            batch_size,
            arguments,
            learning_rate,
            backbone_model,
            pretrained_model,
            validation_percentage,
            stop_training,
            freeze):
        result = arcpy.gp.TrainDeepLearningModel_ia(
            in_folder,
            out_folder,
            max_epochs,
            model_type,
            batch_size,
            arguments,
            learning_rate,
            backbone_model,
            pretrained_model,
            validation_percentage,
            stop_training,
            freeze)
        return result
    return Wrapper(
        in_folder,
        out_folder,
        max_epochs,
        model_type,
        batch_size,
        arguments,
        learning_rate,
        backbone_model,
        pretrained_model,
        validation_percentage,
        stop_training,
        freeze)
TrainDeepLearningModel.__esri_toolname__ = "TrainDeepLearningModel_ia"
TrainDeepLearningModel.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12"
]


def TrainIsoClusterClassifier(
        in_raster,
        max_classes,
        out_classifier_definition,
        in_additional_raster="#",
        max_iterations="#",
        min_samples_per_cluster="#",
        skip_factor="#",
        used_attributes="#",
        max_merge_per_iter="#",
        max_merge_distance="#"):
    """TrainIsoClusterClassifier_ia(in_raster, max_classes, out_classifier_definition, {in_additional_raster}, {max_iterations}, {min_samples_per_cluster}, {skip_factor}, {[used_attribute,...]}, {max_merge_per_iter}, {max_merge_distance})

    Generates an Esri classifier definition file (.ecd) using the Iso Cluster classification definition.

    Arguments:
    in_raster -- 
    max_classes -- 
    out_classifier_definition -- 
    in_additional_raster -- 
    max_iterations -- 
    min_samples_per_cluster -- 
    skip_factor -- 
    used_attribute -- 
    max_merge_per_iter -- 
    max_merge_distance -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            max_classes,
            out_classifier_definition,
            in_additional_raster,
            max_iterations,
            min_samples_per_cluster,
            skip_factor,
            used_attributes,
            max_merge_per_iter,
            max_merge_distance):
        result = arcpy.gp.TrainIsoClusterClassifier_ia(
            in_raster,
            max_classes,
            out_classifier_definition,
            in_additional_raster,
            max_iterations,
            min_samples_per_cluster,
            skip_factor,
            used_attributes,
            max_merge_per_iter,
            max_merge_distance)
        return result
    return Wrapper(
        in_raster,
        max_classes,
        out_classifier_definition,
        in_additional_raster,
        max_iterations,
        min_samples_per_cluster,
        skip_factor,
        used_attributes,
        max_merge_per_iter,
        max_merge_distance)
TrainIsoClusterClassifier.__esri_toolname__ = "TrainIsoClusterClassifier_ia"
TrainIsoClusterClassifier.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10"
]


def TrainKNearestNeighborClassifier(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster="#",
        kNN="#",
        max_samples_per_class="#",
        used_attributes="#",
        dimension_value_field="#"):
    """TrainKNearestNeighborClassifier_ia(in_raster, in_training_features, out_classifier_definition, {in_additional_raster}, {kNN}, {max_samples_per_class}, {[used_attribute,...]}, {dimension_value_field})

    Generates an Esri classifier definition file (.ecd) using the K-Nearest Neighbor classification method.

    Arguments:
    in_raster -- 
    in_training_features -- 
    out_classifier_definition -- 
    in_additional_raster -- 
    kNN -- 
    max_samples_per_class -- 
    used_attribute -- 
    dimension_value_field -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            kNN,
            max_samples_per_class,
            used_attributes,
            dimension_value_field):
        result = arcpy.gp.TrainKNearestNeighborClassifier_ia(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            kNN,
            max_samples_per_class,
            used_attributes,
            dimension_value_field)
        return result
    return Wrapper(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster,
        kNN,
        max_samples_per_class,
        used_attributes,
        dimension_value_field)
TrainKNearestNeighborClassifier.__esri_toolname__ = "TrainKNearestNeighborClassifier_ia"
TrainKNearestNeighborClassifier.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8"
]


def TrainMaximumLikelihoodClassifier(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster="#",
        used_attributes="#",
        dimension_value_field="#"):
    """TrainMaximumLikelihoodClassifier_ia(in_raster, in_training_features, out_classifier_definition, {in_additional_raster}, {[used_attribute,...]}, {dimension_value_field})

    Generates an Esri classifier definition file (.ecd) using the Maximum Likelihood Classifier (MLC) classification definition.

    Arguments:
    in_raster -- 
    in_training_features -- 
    out_classifier_definition -- 
    in_additional_raster -- 
    used_attribute -- 
    dimension_value_field -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            used_attributes,
            dimension_value_field):
        result = arcpy.gp.TrainMaximumLikelihoodClassifier_ia(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            used_attributes,
            dimension_value_field)
        return result
    return Wrapper(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster,
        used_attributes,
        dimension_value_field)
TrainMaximumLikelihoodClassifier.__esri_toolname__ = "TrainMaximumLikelihoodClassifier_ia"
TrainMaximumLikelihoodClassifier.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def TrainRandomTreesClassifier(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster="#",
        max_num_trees="#",
        max_tree_depth="#",
        max_samples_per_class="#",
        used_attributes="#",
        dimension_value_field="#"):
    """TrainRandomTreesClassifier_ia(in_raster, in_training_features, out_classifier_definition, {in_additional_raster}, {max_num_trees}, {max_tree_depth}, {max_samples_per_class}, {[used_attribute,...]}, {dimension_value_field})

    Generates an Esri classifier definition file (.ecd) using the Random Trees classification method.

    Arguments:
    in_raster -- 
    in_training_features -- 
    out_classifier_definition -- 
    in_additional_raster -- 
    max_num_trees -- 
    max_tree_depth -- 
    max_samples_per_class -- 
    used_attribute -- 
    dimension_value_field -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            max_num_trees,
            max_tree_depth,
            max_samples_per_class,
            used_attributes,
            dimension_value_field):
        result = arcpy.gp.TrainRandomTreesClassifier_ia(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            max_num_trees,
            max_tree_depth,
            max_samples_per_class,
            used_attributes,
            dimension_value_field)
        return result
    return Wrapper(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster,
        max_num_trees,
        max_tree_depth,
        max_samples_per_class,
        used_attributes,
        dimension_value_field)
TrainRandomTreesClassifier.__esri_toolname__ = "TrainRandomTreesClassifier_ia"
TrainRandomTreesClassifier.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9"
]


def TrainRandomTreesRegressionModel(
        in_rasters,
        in_target_data,
        out_regression_definition,
        target_value_field="#",
        target_dimension_field="#",
        raster_dimension="#",
        out_importance_table="#",
        max_num_trees="#",
        max_tree_depth="#",
        max_samples="#",
        average_points_per_cell="#",
        percent_testing="#",
        out_scatterplots="#",
        out_sample_features="#"):
    """TrainRandomTreesRegressionModel_ia([in_raster,...], in_target_data, out_regression_definition, {target_value_field}, {target_dimension_field}, {raster_dimension}, {out_importance_table}, {max_num_trees}, {max_tree_depth}, {max_samples}, {average_points_per_cell}, {percent_testing}, {out_scatterplots}, {out_sample_features})

    Models the relationship between explanatory variables (independent variables) and a target dataset (dependent variable).

    Arguments:
    in_raster -- 
    in_target_data -- 
    out_regression_definition -- 
    target_value_field -- 
    target_dimension_field -- 
    raster_dimension -- 
    out_importance_table -- 
    max_num_trees -- 
    max_tree_depth -- 
    max_samples -- 
    average_points_per_cell -- 
    percent_testing -- 
    out_scatterplots -- 
    out_sample_features -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_rasters,
            in_target_data,
            out_regression_definition,
            target_value_field,
            target_dimension_field,
            raster_dimension,
            out_importance_table,
            max_num_trees,
            max_tree_depth,
            max_samples,
            average_points_per_cell,
            percent_testing,
            out_scatterplots,
            out_sample_features):
        result = arcpy.gp.TrainRandomTreesRegressionModel_ia(
            in_rasters,
            in_target_data,
            out_regression_definition,
            target_value_field,
            target_dimension_field,
            raster_dimension,
            out_importance_table,
            max_num_trees,
            max_tree_depth,
            max_samples,
            average_points_per_cell,
            percent_testing,
            out_scatterplots,
            out_sample_features)
        return result
    return Wrapper(
        in_rasters,
        in_target_data,
        out_regression_definition,
        target_value_field,
        target_dimension_field,
        raster_dimension,
        out_importance_table,
        max_num_trees,
        max_tree_depth,
        max_samples,
        average_points_per_cell,
        percent_testing,
        out_scatterplots,
        out_sample_features)
TrainRandomTreesRegressionModel.__esri_toolname__ = "TrainRandomTreesRegressionModel_ia"
TrainRandomTreesRegressionModel.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14"
]


def TrainSupportVectorMachineClassifier(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster="#",
        max_samples_per_class="#",
        used_attributes="#",
        dimension_value_field="#"):
    """TrainSupportVectorMachineClassifier_ia(in_raster, in_training_features, out_classifier_definition, {in_additional_raster}, {max_samples_per_class}, {[used_attribute,...]}, {dimension_value_field})

    Generates an Esri classifier definition file (.ecd) using the Support Vector Machine (SVM) classification definition.

    Arguments:
    in_raster -- 
    in_training_features -- 
    out_classifier_definition -- 
    in_additional_raster -- 
    max_samples_per_class -- 
    used_attribute -- 
    dimension_value_field -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            max_samples_per_class,
            used_attributes,
            dimension_value_field):
        result = arcpy.gp.TrainSupportVectorMachineClassifier_ia(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            max_samples_per_class,
            used_attributes,
            dimension_value_field)
        return result
    return Wrapper(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster,
        max_samples_per_class,
        used_attributes,
        dimension_value_field)
TrainSupportVectorMachineClassifier.__esri_toolname__ = "TrainSupportVectorMachineClassifier_ia"
TrainSupportVectorMachineClassifier.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def UpdateAccuracyAssessmentPoints(
        in_class_data,
        in_points,
        out_points,
        target_field="#",
        polygon_dimension_field="#",
        point_dimension_field="#"):
    """UpdateAccuracyAssessmentPoints_ia(in_class_data, in_points, out_points, {target_field}, {polygon_dimension_field}, {point_dimension_field})

    Updates the Target field in the attribute table to compare reference points to the classified image.

    Arguments:
    in_class_data -- 
    in_points -- 
    out_points -- 
    target_field -- 
    polygon_dimension_field -- 
    point_dimension_field -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_class_data,
            in_points,
            out_points,
            target_field,
            polygon_dimension_field,
            point_dimension_field):
        result = arcpy.gp.UpdateAccuracyAssessmentPoints_ia(
            in_class_data,
            in_points,
            out_points,
            target_field,
            polygon_dimension_field,
            point_dimension_field)
        return result
    return Wrapper(
        in_class_data,
        in_points,
        out_points,
        target_field,
        polygon_dimension_field,
        point_dimension_field)
UpdateAccuracyAssessmentPoints.__esri_toolname__ = "UpdateAccuracyAssessmentPoints_ia"
UpdateAccuracyAssessmentPoints.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def VideoMetadataToFeatureClass(
        in_video,
        csv_file="#",
        flightpath="#",
        flightpath_type="#",
        imagepath="#",
        imagepath_type="#",
        footprint="#",
        start_time="#",
        stop_time="#",
        min_distance="#",
        min_time="#"):
    """VideoMetadataToFeatureClass_ia(in_video, {csv_file}, {flightpath}, {flightpath_type}, {imagepath}, {imagepath_type}, {footprint}, {start_time}, {stop_time}, {min_distance}, {min_time})

    Extracts the platform, frame center, frame outline, and attributes metadata from an FMV-compliant video. The output geometry and attributes are saved as feature classes.

    Arguments:
    in_video -- 
    csv_file -- 
    flightpath -- 
    flightpath_type -- 
    imagepath -- 
    imagepath_type -- 
    footprint -- 
    start_time -- 
    stop_time -- 
    min_distance -- 
    min_time -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_video,
            csv_file,
            flightpath,
            flightpath_type,
            imagepath,
            imagepath_type,
            footprint,
            start_time,
            stop_time,
            min_distance,
            min_time):
        result = arcpy.gp.VideoMetadataToFeatureClass_ia(
            in_video,
            csv_file,
            flightpath,
            flightpath_type,
            imagepath,
            imagepath_type,
            footprint,
            start_time,
            stop_time,
            min_distance,
            min_time)
        return result
    return Wrapper(
        in_video,
        csv_file,
        flightpath,
        flightpath_type,
        imagepath,
        imagepath_type,
        footprint,
        start_time,
        stop_time,
        min_distance,
        min_time)
VideoMetadataToFeatureClass.__esri_toolname__ = "VideoMetadataToFeatureClass_ia"
VideoMetadataToFeatureClass.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11"
]


def VideoMultiplexer(
        in_video_file,
        metadata_file,
        out_video_file,
        metadata_mapping_file="#",
        timeshift_file="#",
        elevation_layer="#"):
    """VideoMultiplexer_ia(in_video_file, metadata_file, out_video_file, {metadata_mapping_file}, {timeshift_file}, {elevation_layer})

    Creates a video file that combines an archived video stream file and an associated metadata file synchronized by a time stamp.

    Arguments:
    in_video_file -- 
    metadata_file -- 
    out_video_file -- 
    metadata_mapping_file -- 
    timeshift_file -- 
    elevation_layer -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_video_file,
            metadata_file,
            out_video_file,
            metadata_mapping_file,
            timeshift_file,
            elevation_layer):
        result = arcpy.gp.VideoMultiplexer_ia(
            in_video_file,
            metadata_file,
            out_video_file,
            metadata_mapping_file,
            timeshift_file,
            elevation_layer)
        return result
    return Wrapper(
        in_video_file,
        metadata_file,
        out_video_file,
        metadata_mapping_file,
        timeshift_file,
        elevation_layer)
VideoMultiplexer.__esri_toolname__ = "VideoMultiplexer_ia"
VideoMultiplexer.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def WeightedSum(
        in_weighted_sum_table):
    """WeightedSum_ia(in_weighted_sum_table)

    Overlays several rasters, multiplying each by their given weight and summing them together.

    Arguments:
    in_weighted_sum_table -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_weighted_sum_table):
        in_weighted_sum_table = Utils.compoundParameterToString(in_weighted_sum_table, ParameterClasses.WSTable)
        # parse out raster names to use as local function arguments
        import re as _re  # Use underscore to avoid polluting user's namespace
        # Construct a regular expression to parse the string version of a single weighted sum table entry
        # for example: "'landuse.tif' VALUE 0.34"
        pattern = _re.compile(pattern=r"""
            ^                   # beginning of string
            \s*                 # any amount of white space
            (?P<raster>.*\S)    # 1. raster name
            \s+                 # at least one white space
            (?P<field>\S+)      # 2. raster field name
            \s+                 # at least one white space
            (?P<weight>\S+)     # 3. raster weight value
            \s*                 # any amount of white space
            $                   # end of string
        """, flags=_re.VERBOSE)
        rasters = ["WeightedSum", ]  # local functions take a list of op name followed by rasters
        fields = []
        weights = []
        for item in in_weighted_sum_table.split(";"):
            item = item.strip()
            if len(item) < 1:
                continue
            m = pattern.match(item)
            raster_name = m.group("raster")
            raster_field = m.group("field")
            weight = float(m.group("weight"))
            raster_name = raster_name.strip("\"'")  # remove surrounding quotation marks
            rasters.append(raster_name)
            fields.append(raster_field)
            weights.append(weight)
        return _wrapLocalFunctionRaster(
            u"WeightedSum_sa",
            rasters,
            {"fields": fields, "weights": weights, "flattenBands": True},
        )
    return Wrapper(
        in_weighted_sum_table)
WeightedSum.__esri_toolname__ = "WeightedSum_ia"
WeightedSum.__esri_toolinfo__ = [
    "Python::WSTable::"
]


def ZonalStatistics(
        in_zone_data,
        zone_field,
        in_value_raster,
        statistics_type="#",
        ignore_nodata="#",
        process_as_multidimensional="#",
        percentile_value="#",
        percentile_interpolation_type="#",
        circular_calculation="#",
        circular_wrap_value="#"):
    """ZonalStatistics_ia(in_zone_data, zone_field, in_value_raster, {statistics_type}, {ignore_nodata}, {process_as_multidimensional}, {percentile_value}, {percentile_interpolation_type}, {circular_calculation}, {circular_wrap_value})

    Summarizes the values of a raster within the zones of another dataset.

    Arguments:
    in_zone_data -- 
    zone_field -- 
    in_value_raster -- 
    statistics_type -- 
    ignore_nodata -- 
    process_as_multidimensional -- 
    percentile_value -- 
    percentile_interpolation_type -- 
    circular_calculation -- 
    circular_wrap_value -- 

    Results:
    out_raster -- Output Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_zone_data,
            zone_field,
            in_value_raster,
            statistics_type,
            ignore_nodata,
            process_as_multidimensional,
            percentile_value,
            percentile_interpolation_type,
            circular_calculation,
            circular_wrap_value):
        out_raster = "#"
        result = arcpy.gp.ZonalStatistics_ia(
            in_zone_data,
            zone_field,
            in_value_raster,
            out_raster,
            statistics_type,
            ignore_nodata,
            process_as_multidimensional,
            percentile_value,
            percentile_interpolation_type,
            circular_calculation,
            circular_wrap_value)
        return _wrapToolRaster(u"ZonalStatistics_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_zone_data,
        zone_field,
        in_value_raster,
        statistics_type,
        ignore_nodata,
        process_as_multidimensional,
        percentile_value,
        percentile_interpolation_type,
        circular_calculation,
        circular_wrap_value)
ZonalStatistics.__esri_toolname__ = "ZonalStatistics_ia"
ZonalStatistics.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11"
]


def ZonalStatisticsAsTable(
        in_zone_data,
        zone_field,
        in_value_raster,
        out_table,
        ignore_nodata="#",
        statistics_type="#",
        process_as_multidimensional="#",
        percentile_values="#",
        percentile_interpolation_type="#",
        circular_calculation="#",
        circular_wrap_value="#"):
    """ZonalStatisticsAsTable_ia(in_zone_data, zone_field, in_value_raster, out_table, {ignore_nodata}, {statistics_type}, {process_as_multidimensional}, {[percentile_value,...]}, {percentile_interpolation_type}, {circular_calculation}, {circular_wrap_value})

    Summarizes the values of a raster within the zones of another dataset and reports the results as a table.

    Arguments:
    in_zone_data -- 
    zone_field -- 
    in_value_raster -- 
    out_table -- 
    ignore_nodata -- 
    statistics_type -- 
    process_as_multidimensional -- 
    percentile_value -- 
    percentile_interpolation_type -- 
    circular_calculation -- 
    circular_wrap_value -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_zone_data,
            zone_field,
            in_value_raster,
            out_table,
            ignore_nodata,
            statistics_type,
            process_as_multidimensional,
            percentile_values,
            percentile_interpolation_type,
            circular_calculation,
            circular_wrap_value):
        result = arcpy.gp.ZonalStatisticsAsTable_ia(
            in_zone_data,
            zone_field,
            in_value_raster,
            out_table,
            ignore_nodata,
            statistics_type,
            process_as_multidimensional,
            percentile_values,
            percentile_interpolation_type,
            circular_calculation,
            circular_wrap_value)
        return result
    return Wrapper(
        in_zone_data,
        zone_field,
        in_value_raster,
        out_table,
        ignore_nodata,
        statistics_type,
        process_as_multidimensional,
        percentile_values,
        percentile_interpolation_type,
        circular_calculation,
        circular_wrap_value)
ZonalStatisticsAsTable.__esri_toolname__ = "ZonalStatisticsAsTable_ia"
ZonalStatisticsAsTable.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11"
]

def ApplyEnvironment(
        in_raster):
    """ApplyEnvironment(in_raster)

    Creates a copy of in_raster with environment settings applied.

    Arguments:
    in_raster -- The input that will be copied.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def wrapper(in_raster):
        return _wrapLocalFunctionRaster(u"ApplyEnvironment",
            ["Copy", in_raster])
    return wrapper(
        in_raster)

def FloatDivide(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """FloatDivide(in_raster_or_constant1, in_raster_or_constant2)

    Divides the values of two rasters on a cell-by-cell basis. The result will
    be a true floating point division.

    Arguments:
    in_raster_or_constant1 -- The input whose values will be divided by the second input.
    in_raster_or_constant2 -- The input whose values the first input are to be divided by.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def wrapper(in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Divide_sa",
            ["FloatDivide", in_raster_or_constant1, in_raster_or_constant2])
    return wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)

def FloorDivide(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """FloorDivide(in_raster_or_constant1, in_raster_or_constant2)

    Divides the values of two rasters on a cell-by-cell basis. The result will
    be a floored floating point division.

    Arguments:
    in_raster_or_constant1 -- The input whose values will be divided by the second input.
    in_raster_or_constant2 -- The input whose values the first input are to be divided by.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Divide_sa",
            ["FloorDivide", in_raster_or_constant1, in_raster_or_constant2])
    return wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)