from arcpy.arcobjects.arcobjectconversion import convertArcObjectToPythonObject as _convertArcObjectToPythonObject
from arcpy.geoprocessing._base import gp_fixargs as _gp_fixargs
from arcpy.arcobjects._base import _ObjectWithoutInitCall

class FeatureSharingDraft(_ObjectWithoutInitCall):

    def __init__(self):
        import arcgisscripting
        self._arc_object = arcgisscripting._sharing.SharingDraft(*_gp_fixargs((), True))
        self.overwriteExistingService=False
        self.serverType="HOSTING_SERVER"
        self.serviceType="FEATURE"
        self.serviceName=""
        self.portalFolder=""
        self.summary=""
        self.tags=""
        self.description=""
        self.credits=""
        self.useLimitations=False
        self.offline=False
        self.checkUniqueIDAssignment=False

    def exportToSDDraft(self, out_sddraft):
        return _convertArcObjectToPythonObject(self._arc_object.exportToSDDraft(out_sddraft, self))

class TileSharingDraft(_ObjectWithoutInitCall):

    def __init__(self):
        import arcgisscripting
        self._arc_object = arcgisscripting._sharing.SharingDraft(*_gp_fixargs((), True))
        self.overwriteExistingService=False
        self.serverType="HOSTING_SERVER"
        self.serviceType="TILE"
        self.serviceName=""
        self.portalFolder=""
        self.summary=""
        self.tags=""
        self.description=""
        self.credits=""
        self.useLimitations=False
        self.offline=False

    def exportToSDDraft(self, out_sddraft):
        return _convertArcObjectToPythonObject(self._arc_object.exportToSDDraft(out_sddraft,self))

class MapImageSharingDraft(_ObjectWithoutInitCall):

    def __init__(self):
        import arcgisscripting
        self._arc_object = arcgisscripting._sharing.SharingDraft(*_gp_fixargs((), True))
        self.federatedServerUrl=""
        self.overwriteExistingService=False
        self.serverType="FEDERATED_SERVER"
        self.serviceType="MAP_IMAGE"
        self.serviceName=""
        self.portalFolder=""
        self.serverFolder=""
        self.summary=""
        self.tags=""
        self.description=""
        self.credits=""
        self.useLimitations=False
        self.offline=False
        self.copyDataToServer = False
        self.checkUniqueIDAssignment=False

    def exportToSDDraft(self, out_sddraft):
        return _convertArcObjectToPythonObject(self._arc_object.exportToSDDraft(out_sddraft,self))

class MapServiceSharingDraft(_ObjectWithoutInitCall):

    def __init__(self):
        import arcgisscripting
        self._arc_object = arcgisscripting._sharing.SharingDraft(*_gp_fixargs((), True))
        self.federatedServerUrl=""
        self.targetServer = ""
        self.overwriteExistingService=False
        self.serverType="FEDERATED_SERVER"
        self.serviceType="MAP_SERVICE"
        self.serviceName=""
        self.portalFolder=""
        self.serverFolder=""
        self.summary=""
        self.tags=""
        self.description=""
        self.credits=""
        self.useLimitations=False
        self.offline=False
        self.copyDataToServer = False
        self.checkUniqueIDAssignment=False

    def exportToSDDraft(self, out_sddraft):
        self.federatedServerUrl = self.targetServer # todo: temp fix
        return _convertArcObjectToPythonObject(self._arc_object.exportToSDDraft(out_sddraft,self))

class GeoprocessingSharingDraft(_ObjectWithoutInitCall):

    def __init__(self):
        import arcgisscripting
        self._arc_object = arcgisscripting._sharing.SharingDraft(*_gp_fixargs((), True))
        self.serverType = "STANDALONE_SERVER" 
        self.serviceType = "GP_SERVICE"
        self.serviceName = ""
        self.description = ""
        self.summary = ""
        self.tags = ""
        self.offline = False
        self.targetServer = ""
        self.overwriteExistingService = False
        self.copyDataToServer = False
        self.executionType = "Asynchronous"
        self.serverFolder = ""
        self.portalFolder = ""
        self.maximumRecords = 1000
        self.maxInstances = 2
        self.minInstances = 1
        self.resultMapService = False
        self.messageLevel = "Error"
        self.maxUsageTime = 600
        self.maxWaitTime = 60
        self.maxIdleTime = 1800
        self.capabilities = None
        self.constantValues = None
        self.choiceLists = None
        self.draftValue = None
        self.offlineTarget = "11"

    def exportToSDDraft(self, out_sddraft):
        return _convertArcObjectToPythonObject(self._arc_object.exportToGPSDDraft(out_sddraft, self))

def CreateSharingDraft(server_type, service_type, service_name, draft_value):

    if service_type == "MAP_SERVICE" and server_type == "STANDALONE_SERVER": #todo: validation
      map_service = MapServiceSharingDraft()
      map_service.serviceName = service_name
      map_service.serverType = server_type
      map_service.serviceName = service_name
      map_service.draftValue = draft_value._arc_object #todo: temp fix
      return map_service
    
    if service_type == "GP_SERVICE" or service_type == "WEB_TOOL":
      gp_service = GeoprocessingSharingDraft()
      gp_service.serverType = server_type
      gp_service.serviceType = service_type
      gp_service.serviceName = service_name
      gp_service.draftValue = draft_value
      return gp_service