# -*- coding: utf-8 -*-
# COPYRIGHT 2020 ESRI
#
# TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
# Unpublished material - all rights reserved under the
# Copyright Laws of the United States.
#
# For additional information, contact:
# Environmental Systems Research Institute, Inc.
# Attn: Contracts Dept
# 380 New York Street
# Redlands, California, USA 92373
#
# email: contracts@esri.com
#
# Warning: This module is automatically generated, changes will be overwritten.
from arcgisscripting import _wrapToolRaster, _wrapLocalFunctionRaster
import arcpy
from . import ParameterClasses
from . import Utils

try:
    unicode
except NameError:
    unicode = str


__all__ = [
    "Abs",
    "ACos",
    "ACosH",
    "AddSurfaceInformation",
    "Aggregate",
    "AggregateMultidimensionalRaster",
    "AreaSolarRadiation",
    "ASin",
    "ASinH",
    "Aspect",
    "ATan",
    "ATan2",
    "ATanH",
    "BandCollectionStats",
    "Basin",
    "BitwiseAnd",
    "BitwiseLeftShift",
    "BitwiseNot",
    "BitwiseOr",
    "BitwiseRightShift",
    "BitwiseXOr",
    "BlockStatistics",
    "BooleanAnd",
    "BooleanNot",
    "BooleanOr",
    "BooleanXOr",
    "BoundaryClean",
    "CalculateKernelDensityRatio",
    "CellStatistics",
    "ClassifyRaster",
    "ClassProbability",
    "CombinatorialAnd",
    "CombinatorialOr",
    "CombinatorialXOr",
    "Combine",
    "ComputeConfusionMatrix",
    "ComputeSegmentAttributes",
    "Con",
    "Contour",
    "ContourList",
    "ContourWithBarriers",
    "Corridor",
    "Cos",
    "CosH",
    "CostAllocation",
    "CostBackLink",
    "CostConnectivity",
    "CostDistance",
    "CostPath",
    "CostPathAsPolyline",
    "CreateAccuracyAssessmentPoints",
    "CreateConstantRaster",
    "CreateNormalRaster",
    "CreateRandomRaster",
    "CreateSignatures",
    "Curvature",
    "CutFill",
    "DarcyFlow",
    "DarcyVelocity",
    "DeepLearningModelToEcd",
    "Dendrogram",
    "DeriveContinuousFlow",
    "DeriveStreamAsLine",
    "DeriveStreamAsRaster",
    "Diff",
    "DimensionalMovingStatistics",
    "DistanceAccumulation",
    "DistanceAllocation",
    "Divide",
    "EditSignatures",
    "EqualTo",
    "EqualToFrequency",
    "EucAllocation",
    "EucBackDirection",
    "EucDirection",
    "EucDistance",
    "Exp",
    "Exp10",
    "Exp2",
    "Expand",
    "ExportTrainingDataForDeepLearning",
    "ExtractByAttributes",
    "ExtractByCircle",
    "ExtractByMask",
    "ExtractByPoints",
    "ExtractByPolygon",
    "ExtractByRectangle",
    "ExtractMultiValuesToPoints",
    "ExtractValuesToPoints",
    "Fill",
    "Filter",
    "Float",
    "FlowAccumulation",
    "FlowDirection",
    "FlowDistance",
    "FlowLength",
    "FocalFlow",
    "FocalStatistics",
    "FuzzyMembership",
    "FuzzyOverlay",
    "GenerateMultidimensionalAnomaly",
    "GenerateTrainingSamplesFromSeedPoints",
    "GreaterThan",
    "GreaterThanEqual",
    "GreaterThanFrequency",
    "HighestPosition",
    "Hillshade",
    "Idw",
    "InList",
    "InspectTrainingSamples",
    "Int",
    "InterpolateShape",
    "IsNull",
    "IsoCluster",
    "IsoClusterUnsupervisedClassification",
    "KernelDensity",
    "Kriging",
    "LessThan",
    "LessThanEqual",
    "LessThanFrequency",
    "LinearSpectralUnmixing",
    "LineDensity",
    "LineStatistics",
    "Ln",
    "LocateRegions",
    "Log10",
    "Log2",
    "Lookup",
    "LowestPosition",
    "MajorityFilter",
    "Minus",
    "MLClassify",
    "Mod",
    "NaturalNeighbor",
    "Negate",
    "Nibble",
    "NotEqual",
    "ObserverPoints",
    "OptimalPathAsLine",
    "OptimalPathAsRaster",
    "OptimalRegionConnections",
    "Over",
    "ParticleTrack",
    "PathAllocation",
    "PathBackLink",
    "PathDistance",
    "Pick",
    "Plus",
    "PointDensity",
    "PointsSolarRadiation",
    "PointStatistics",
    "Popularity",
    "PorousPuff",
    "Power",
    "PrincipalComponents",
    "Rank",
    "ReclassByASCIIFile",
    "ReclassByTable",
    "Reclassify",
    "RegionGroup",
    "RemoveRasterSegmentTilingArtifacts",
    "RescaleByFunction",
    "RoundDown",
    "RoundUp",
    "Sample",
    "SegmentMeanShift",
    "SetNull",
    "Shrink",
    "Sin",
    "SinH",
    "Sink",
    "Slice",
    "Slope",
    "SnapPourPoint",
    "SolarRadiationGraphics",
    "Spline",
    "SplineWithBarriers",
    "Square",
    "SquareRoot",
    "StorageCapacity",
    "StreamLink",
    "StreamOrder",
    "StreamToFeature",
    "SurfaceParameters",
    "TabulateArea",
    "Tan",
    "TanH",
    "Test",
    "Thin",
    "Times",
    "TopoToRaster",
    "TopoToRasterByFile",
    "TrainIsoClusterClassifier",
    "TrainKNearestNeighborClassifier",
    "TrainMaximumLikelihoodClassifier",
    "TrainRandomTreesClassifier",
    "TrainSupportVectorMachineClassifier",
    "Trend",
    "UpdateAccuracyAssessmentPoints",
    "Viewshed",
    "Viewshed2",
    "Visibility",
    "Watershed",
    "WeightedOverlay",
    "WeightedSum",
    "ZonalFill",
    "ZonalGeometry",
    "ZonalGeometryAsTable",
    "ZonalHistogram",
    "ZonalStatistics",
    "ZonalStatisticsAsTable",
    "ApplyEnvironment",
    "FloatDivide",
    "FloorDivide"
]


def Abs(
        in_raster_or_constant):
    """Abs_sa(in_raster_or_constant)

    Calculates the absolute value of the cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Abs_sa",
            ["Abs", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Abs.__esri_toolname__ = "Abs_sa"
Abs.__esri_toolinfo__ = [
    "::::1"
]


def ACos(
        in_raster_or_constant):
    """ACos_sa(in_raster_or_constant)

    Calculates the inverse cosine of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ACos_sa",
            ["ACos", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ACos.__esri_toolname__ = "ACos_sa"
ACos.__esri_toolinfo__ = [
    "::::1"
]


def ACosH(
        in_raster_or_constant):
    """ACosH_sa(in_raster_or_constant)

    Calculates the inverse hyperbolic cosine of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ACosH_sa",
            ["ACosH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ACosH.__esri_toolname__ = "ACosH_sa"
ACosH.__esri_toolinfo__ = [
    "::::1"
]


def AddSurfaceInformation(
        in_feature_class,
        in_surface,
        out_property,
        method="#",
        sample_distance="#",
        z_factor="#",
        pyramid_level_resolution="#",
        noise_filtering="#"):
    """AddSurfaceInformation_sa(in_feature_class, in_surface, [out_property,...], {method}, {sample_distance}, {z_factor}, {pyramid_level_resolution}, {noise_filtering})

    Attributes features with statistics derived from a  surface.

    Arguments:
    in_feature_class -- 
    in_surface -- 
    out_property -- 
    method -- 
    sample_distance -- 
    z_factor -- 
    pyramid_level_resolution -- 
    noise_filtering -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_feature_class,
            in_surface,
            out_property,
            method,
            sample_distance,
            z_factor,
            pyramid_level_resolution,
            noise_filtering):
        result = arcpy.gp.AddSurfaceInformation_sa(
            in_feature_class,
            in_surface,
            out_property,
            method,
            sample_distance,
            z_factor,
            pyramid_level_resolution,
            noise_filtering)
        return result
    return Wrapper(
        in_feature_class,
        in_surface,
        out_property,
        method,
        sample_distance,
        z_factor,
        pyramid_level_resolution,
        noise_filtering)
AddSurfaceInformation.__esri_toolname__ = "AddSurfaceInformation_sa"
AddSurfaceInformation.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8"
]


def Aggregate(
        in_raster,
        cell_factor,
        aggregation_type="#",
        extent_handling="#",
        ignore_nodata="#"):
    """Aggregate_sa(in_raster, cell_factor, {aggregation_type}, {extent_handling}, {ignore_nodata})

    Generates a reduced-resolution version of a raster. Each output cell contains the Sum, Minimum, Maximum, Mean, or Median of the input cells that are encompassed by the extent of that cell.

    Arguments:
    in_raster -- 
    cell_factor -- 
    aggregation_type -- 
    extent_handling -- 
    ignore_nodata -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            cell_factor,
            aggregation_type,
            extent_handling,
            ignore_nodata):
        args = {}
        aggr_types = {
            # values from esriGeoAnalysisStatisticsEnum
            "MAXIMUM": 2,
            "MINIMUM": 5,
            "MEAN": 3,
            "MEDIAN": 4,
            "SUM": 9,
        }
        args["CellFactor"] = cell_factor
        args["AggregationType"] = aggr_types.get(str(aggregation_type).upper(), aggr_types["SUM"])
        args["ExpandHandling"] = 0 if extent_handling.upper() == "TRUNCATE" else -1
        args["IgnoreNoData"] = 0 if ignore_nodata.upper() == "NODATA" else -1
        in_raster = ApplyEnvironment(in_raster)
        result = arcpy.sa.Apply(in_raster, "Aggregate", args)
        with arcpy.EnvManager(cellSize=None):
            result = ApplyEnvironment(result)
        return result
    return Wrapper(
        in_raster,
        cell_factor,
        aggregation_type,
        extent_handling,
        ignore_nodata)
Aggregate.__esri_toolname__ = "Aggregate_sa"
Aggregate.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def AggregateMultidimensionalRaster(
        in_multidimensional_raster,
        dimension,
        aggregation_method="#",
        variables="#",
        aggregation_def="#",
        interval_keyword="#",
        interval_value="#",
        interval_unit="#",
        interval_ranges="#",
        aggregation_function="#",
        ignore_nodata="#",
        dimensionless="#",
        percentile_value="#",
        percentile_interpolation_type="#"):
    """AggregateMultidimensionalRaster_sa(in_multidimensional_raster, dimension, {aggregation_method}, {[variable,...]}, {aggregation_def}, {interval_keyword}, {interval_value}, {interval_unit}, {interval_ranges}, {aggregation_function}, {ignore_nodata}, {dimensionless}, {percentile_value}, {percentile_interpolation_type})

    Generates a multidimensional raster dataset by combining existing multidimensional raster variables along a dimension.

    Arguments:
    in_multidimensional_raster -- 
    dimension -- 
    aggregation_method -- 
    variable -- 
    aggregation_def -- 
    interval_keyword -- 
    interval_value -- 
    interval_unit -- 
    interval_ranges -- 
    aggregation_function -- 
    ignore_nodata -- 
    dimensionless -- 
    percentile_value -- 
    percentile_interpolation_type -- 

    Results:
    out_multidimensional_raster -- Output Multidimensional Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_multidimensional_raster,
            dimension,
            aggregation_method,
            variables,
            aggregation_def,
            interval_keyword,
            interval_value,
            interval_unit,
            interval_ranges,
            aggregation_function,
            ignore_nodata,
            dimensionless,
            percentile_value,
            percentile_interpolation_type):
        out_multidimensional_raster = "#"
        result = arcpy.gp.AggregateMultidimensionalRaster_sa(
            in_multidimensional_raster,
            dimension,
            out_multidimensional_raster,
            aggregation_method,
            variables,
            aggregation_def,
            interval_keyword,
            interval_value,
            interval_unit,
            interval_ranges,
            aggregation_function,
            ignore_nodata,
            dimensionless,
            percentile_value,
            percentile_interpolation_type)
        return _wrapToolRaster(u"AggregateMultidimensionalRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_multidimensional_raster,
        dimension,
        aggregation_method,
        variables,
        aggregation_def,
        interval_keyword,
        interval_value,
        interval_unit,
        interval_ranges,
        aggregation_function,
        ignore_nodata,
        dimensionless,
        percentile_value,
        percentile_interpolation_type)
AggregateMultidimensionalRaster.__esri_toolname__ = "AggregateMultidimensionalRaster_sa"
AggregateMultidimensionalRaster.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14",
    "::::15"
]


def AreaSolarRadiation(
        in_surface_raster,
        latitude="#",
        sky_size="#",
        time_configuration="#",
        day_interval="#",
        hour_interval="#",
        each_interval="#",
        z_factor="#",
        slope_aspect_input_type="#",
        calculation_directions="#",
        zenith_divisions="#",
        azimuth_divisions="#",
        diffuse_model_type="#",
        diffuse_proportion="#",
        transmittivity="#",
        out_direct_radiation_raster="#",
        out_diffuse_radiation_raster="#",
        out_direct_duration_raster="#"):
    """AreaSolarRadiation_sa(in_surface_raster, {latitude}, {sky_size}, {time_configuration}, {day_interval}, {hour_interval}, {each_interval}, {z_factor}, {slope_aspect_input_type}, {calculation_directions}, {zenith_divisions}, {azimuth_divisions}, {diffuse_model_type}, {diffuse_proportion}, {transmittivity}, {out_direct_radiation_raster}, {out_diffuse_radiation_raster}, {out_direct_duration_raster})

    Derives incoming solar radiation from a raster surface.

    Arguments:
    in_surface_raster -- 
    latitude -- 
    sky_size -- 
    time_configuration -- 
    day_interval -- 
    hour_interval -- 
    each_interval -- 
    z_factor -- 
    slope_aspect_input_type -- 
    calculation_directions -- 
    zenith_divisions -- 
    azimuth_divisions -- 
    diffuse_model_type -- 
    diffuse_proportion -- 
    transmittivity -- 
    out_direct_radiation_raster -- 
    out_diffuse_radiation_raster -- 
    out_direct_duration_raster -- 

    Results:
    out_global_radiation_raster -- Output global radiation raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_surface_raster,
            latitude,
            sky_size,
            time_configuration,
            day_interval,
            hour_interval,
            each_interval,
            z_factor,
            slope_aspect_input_type,
            calculation_directions,
            zenith_divisions,
            azimuth_divisions,
            diffuse_model_type,
            diffuse_proportion,
            transmittivity,
            out_direct_radiation_raster,
            out_diffuse_radiation_raster,
            out_direct_duration_raster):
        time_configuration = Utils.compoundParameterToString(time_configuration, ParameterClasses._Time)
        out_global_radiation_raster = "#"
        result = arcpy.gp.AreaSolarRadiation_sa(
            in_surface_raster,
            out_global_radiation_raster,
            latitude,
            sky_size,
            time_configuration,
            day_interval,
            hour_interval,
            each_interval,
            z_factor,
            slope_aspect_input_type,
            calculation_directions,
            zenith_divisions,
            azimuth_divisions,
            diffuse_model_type,
            diffuse_proportion,
            transmittivity,
            out_direct_radiation_raster,
            out_diffuse_radiation_raster,
            out_direct_duration_raster)
        return _wrapToolRaster(u"AreaSolarRadiation_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_surface_raster,
        latitude,
        sky_size,
        time_configuration,
        day_interval,
        hour_interval,
        each_interval,
        z_factor,
        slope_aspect_input_type,
        calculation_directions,
        zenith_divisions,
        azimuth_divisions,
        diffuse_model_type,
        diffuse_proportion,
        transmittivity,
        out_direct_radiation_raster,
        out_diffuse_radiation_raster,
        out_direct_duration_raster)
AreaSolarRadiation.__esri_toolname__ = "AreaSolarRadiation_sa"
AreaSolarRadiation.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "Python::TimeMultipleDays|TimeSpecialDays|TimeWholeYear|TimeWithinDay::",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14",
    "::::15",
    "::::16",
    "::::17",
    "::::18",
    "::::19"
]


def ASin(
        in_raster_or_constant):
    """ASin_sa(in_raster_or_constant)

    Calculates the inverse sine of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ASin_sa",
            ["ASin", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ASin.__esri_toolname__ = "ASin_sa"
ASin.__esri_toolinfo__ = [
    "::::1"
]


def ASinH(
        in_raster_or_constant):
    """ASinH_sa(in_raster_or_constant)

    Calculates the inverse hyperbolic sine of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ASinH_sa",
            ["ASinH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ASinH.__esri_toolname__ = "ASinH_sa"
ASinH.__esri_toolinfo__ = [
    "::::1"
]


def Aspect(
        in_raster,
        method="#",
        z_unit="#",
        project_geodesic_azimuths="#"):
    """Aspect_sa(in_raster, {method}, {z_unit}, {project_geodesic_azimuths})

    Derives the aspect from each cell of a raster surface.

    Arguments:
    in_raster -- 
    method -- 
    z_unit -- 
    project_geodesic_azimuths -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            method,
            z_unit,
            project_geodesic_azimuths):
        out_raster = "#"
        result = arcpy.gp.Aspect_sa(
            in_raster,
            out_raster,
            method,
            z_unit,
            project_geodesic_azimuths)
        return _wrapToolRaster(u"Aspect_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        method,
        z_unit,
        project_geodesic_azimuths)
Aspect.__esri_toolname__ = "Aspect_sa"
Aspect.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5"
]


def ATan(
        in_raster_or_constant):
    """ATan_sa(in_raster_or_constant)

    Calculates the inverse tangent of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ATan_sa",
            ["ATan", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ATan.__esri_toolname__ = "ATan_sa"
ATan.__esri_toolinfo__ = [
    "::::1"
]


def ATan2(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """ATan2_sa(in_raster_or_constant1, in_raster_or_constant2)

    Calculates the inverse tangent (based on x,y) of cells in a raster.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"ATan2_sa",
            ["ATan2", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
ATan2.__esri_toolname__ = "ATan2_sa"
ATan2.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def ATanH(
        in_raster_or_constant):
    """ATanH_sa(in_raster_or_constant)

    Calculates the inverse hyperbolic tangent of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ATanH_sa",
            ["ATanH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ATanH.__esri_toolname__ = "ATanH_sa"
ATanH.__esri_toolinfo__ = [
    "::::1"
]


def BandCollectionStats(
        in_raster_bands,
        out_stat_file,
        compute_matrices="#"):
    """BandCollectionStats_sa([in_raster_band,...], out_stat_file, {compute_matrices})

    Calculates the statistics for a set of raster bands.

    Arguments:
    in_raster_band -- 
    out_stat_file -- 
    compute_matrices -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster_bands,
            out_stat_file,
            compute_matrices):
        result = arcpy.gp.BandCollectionStats_sa(
            in_raster_bands,
            out_stat_file,
            compute_matrices)
        return result
    return Wrapper(
        in_raster_bands,
        out_stat_file,
        compute_matrices)
BandCollectionStats.__esri_toolname__ = "BandCollectionStats_sa"
BandCollectionStats.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3"
]


def Basin(
        in_flow_direction_raster):
    """Basin_sa(in_flow_direction_raster)

    Creates a raster delineating all drainage basins.

    Arguments:
    in_flow_direction_raster -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_flow_direction_raster):
        out_raster = "#"
        result = arcpy.gp.Basin_sa(
            in_flow_direction_raster,
            out_raster)
        return _wrapToolRaster(u"Basin_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_flow_direction_raster)
Basin.__esri_toolname__ = "Basin_sa"
Basin.__esri_toolinfo__ = [
    "::::1"
]


def BitwiseAnd(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BitwiseAnd_sa(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Bitwise And operation on the binary values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BitwiseAnd_sa",
            ["BitwiseAnd", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BitwiseAnd.__esri_toolname__ = "BitwiseAnd_sa"
BitwiseAnd.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BitwiseLeftShift(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BitwiseLeftShift_sa(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Bitwise Left Shift operation on the binary values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BitwiseLeftShift_sa",
            ["BitwiseLeftShift", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BitwiseLeftShift.__esri_toolname__ = "BitwiseLeftShift_sa"
BitwiseLeftShift.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BitwiseNot(
        in_raster_or_constant):
    """BitwiseNot_sa(in_raster_or_constant)

    Performs a Bitwise Not (complement) operation on the binary value of an input raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"BitwiseNot_sa",
            ["BitwiseNot", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
BitwiseNot.__esri_toolname__ = "BitwiseNot_sa"
BitwiseNot.__esri_toolinfo__ = [
    "::::1"
]


def BitwiseOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BitwiseOr_sa(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Bitwise Or operation on the binary values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BitwiseOr_sa",
            ["BitwiseOr", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BitwiseOr.__esri_toolname__ = "BitwiseOr_sa"
BitwiseOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BitwiseRightShift(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BitwiseRightShift_sa(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Bitwise Right Shift operation on the binary values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BitwiseRightShift_sa",
            ["BitwiseRightShift", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BitwiseRightShift.__esri_toolname__ = "BitwiseRightShift_sa"
BitwiseRightShift.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BitwiseXOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BitwiseXOr_sa(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Bitwise eXclusive Or operation on the binary values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BitwiseXOr_sa",
            ["BitwiseXOr", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BitwiseXOr.__esri_toolname__ = "BitwiseXOr_sa"
BitwiseXOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BlockStatistics(
        in_raster,
        neighborhood="#",
        statistics_type="#",
        ignore_nodata="#"):
    """BlockStatistics_sa(in_raster, {neighborhood}, {statistics_type}, {ignore_nodata})

    Partitions the input into non-overlapping blocks and calculates the statistic of the values within each block. The value is assigned to all of the cells in each block in the output.

    Arguments:
    in_raster -- 
    neighborhood -- 
    statistics_type -- 
    ignore_nodata -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            neighborhood,
            statistics_type,
            ignore_nodata):
        neighborhood = Utils.compoundParameterToString(neighborhood, ParameterClasses._Neighborhood)
        out_raster = "#"
        result = arcpy.gp.BlockStatistics_sa(
            in_raster,
            out_raster,
            neighborhood,
            statistics_type,
            ignore_nodata)
        return _wrapToolRaster(u"BlockStatistics_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        neighborhood,
        statistics_type,
        ignore_nodata)
BlockStatistics.__esri_toolname__ = "BlockStatistics_sa"
BlockStatistics.__esri_toolinfo__ = [
    "::::1",
    "Python::NbrAnnulus|NbrCircle|NbrIrregular|NbrRectangle|NbrWedge|NbrWeight::",
    "::::4",
    "::::5"
]


def BooleanAnd(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BooleanAnd_sa(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Boolean And operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BooleanAnd_sa",
            ["BooleanAnd", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BooleanAnd.__esri_toolname__ = "BooleanAnd_sa"
BooleanAnd.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BooleanNot(
        in_raster_or_constant):
    """BooleanNot_sa(in_raster_or_constant)

    Performs a Boolean Not (complement) operation on the cell values of the input raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"BooleanNot_sa",
            ["BooleanNot", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
BooleanNot.__esri_toolname__ = "BooleanNot_sa"
BooleanNot.__esri_toolinfo__ = [
    "::::1"
]


def BooleanOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BooleanOr_sa(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Boolean Or operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BooleanOr_sa",
            ["BooleanOr", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BooleanOr.__esri_toolname__ = "BooleanOr_sa"
BooleanOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BooleanXOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BooleanXOr_sa(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Boolean eXclusive Or operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BooleanXOr_sa",
            ["BooleanXOr", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BooleanXOr.__esri_toolname__ = "BooleanXOr_sa"
BooleanXOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BoundaryClean(
        in_raster,
        sort_type="#",
        number_of_runs="#"):
    """BoundaryClean_sa(in_raster, {sort_type}, {number_of_runs})

    Smooths the boundary between zones in a raster.

    Arguments:
    in_raster -- 
    sort_type -- 
    number_of_runs -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            sort_type,
            number_of_runs):
        out_raster = "#"
        result = arcpy.gp.BoundaryClean_sa(
            in_raster,
            out_raster,
            sort_type,
            number_of_runs)
        return _wrapToolRaster(u"BoundaryClean_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        sort_type,
        number_of_runs)
BoundaryClean.__esri_toolname__ = "BoundaryClean_sa"
BoundaryClean.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4"
]


def CalculateKernelDensityRatio(
        in_features_numerator,
        in_features_denominator,
        population_field_numerator,
        population_field_denominator,
        cell_size="#",
        search_radius_numerator="#",
        search_radius_denominator="#",
        out_cell_values="#",
        method="#",
        in_barriers_numerator="#",
        in_barriers_denominator="#"):
    """CalculateKernelDensityRatio_sa(in_features_numerator, in_features_denominator, population_field_numerator, population_field_denominator, {cell_size}, {search_radius_numerator}, {search_radius_denominator}, {out_cell_values}, {method}, {in_barriers_numerator}, {in_barriers_denominator})

    Calculates a spatial relative risk surface using two input feature datasets. The numerator in the ratio represents cases, such as number of crimes or number of patients, and the denominator represents the control, such as the total population.

    Arguments:
    in_features_numerator -- 
    in_features_denominator -- 
    population_field_numerator -- 
    population_field_denominator -- 
    cell_size -- 
    search_radius_numerator -- 
    search_radius_denominator -- 
    out_cell_values -- 
    method -- 
    in_barriers_numerator -- 
    in_barriers_denominator -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_features_numerator,
            in_features_denominator,
            population_field_numerator,
            population_field_denominator,
            cell_size,
            search_radius_numerator,
            search_radius_denominator,
            out_cell_values,
            method,
            in_barriers_numerator,
            in_barriers_denominator):
        out_raster = "#"
        result = arcpy.gp.CalculateKernelDensityRatio_sa(
            in_features_numerator,
            in_features_denominator,
            population_field_numerator,
            population_field_denominator,
            out_raster,
            cell_size,
            search_radius_numerator,
            search_radius_denominator,
            out_cell_values,
            method,
            in_barriers_numerator,
            in_barriers_denominator)
        return _wrapToolRaster(u"CalculateKernelDensityRatio_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_features_numerator,
        in_features_denominator,
        population_field_numerator,
        population_field_denominator,
        cell_size,
        search_radius_numerator,
        search_radius_denominator,
        out_cell_values,
        method,
        in_barriers_numerator,
        in_barriers_denominator)
CalculateKernelDensityRatio.__esri_toolname__ = "CalculateKernelDensityRatio_sa"
CalculateKernelDensityRatio.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12"
]


def CellStatistics(
        in_rasters_or_constants,
        statistics_type="#",
        ignore_nodata="#",
        process_as_multiband="#",
        percentile_value="#",
        percentile_interpolation_type="#"):
    """CellStatistics_sa([in_rasters_or_constant,...], {statistics_type}, {ignore_nodata}, {process_as_multiband}, {percentile_value}, {percentile_interpolation_type})

    Calculates a per-cell statistic from multiple rasters.

    Arguments:
    in_rasters_or_constant -- 
    statistics_type -- 
    ignore_nodata -- 
    process_as_multiband -- 
    percentile_value -- 
    percentile_interpolation_type -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_rasters_or_constants,
            statistics_type,
            ignore_nodata,
            process_as_multiband,
            percentile_value,
            percentile_interpolation_type):
        statisticsTypes = {
            "MAJORITY": "Majority",
            "MAXIMUM": "Max",
            "MEAN": "Mean",
            "MEDIAN": "Med",
            "MINIMUM": "Min",
            "MINORITY": "Minority",
            "PERCENTILE": "Percentile",
            "RANGE": "Range",
            "STD": "Std",
            "SUM": "Sum",
            "VARIETY": "Variety"
        }
        interpolationTypes = {
            "AUTO_DETECT" : 1,
            "NEAREST" : 2,
            "LINEAR" : 3,
        }
        if Utils.useDefaultArgumentValue(statistics_type):
            statistics_type = "MEAN"
        if not statistics_type in statisticsTypes:
            raise arcpy.ExecuteError("ERROR 000864: Overlay statistic: The input is not within the defined domain.\nERROR 000800: The value is not a member of MEAN | MAJORITY | MAXIMUM | MEDIAN | MINIMUM | MINORITY | PERCENTILE | RANGE | STD | SUM | VARIETY.\n")
        function = statisticsTypes[statistics_type]
        if Utils.useDefaultArgumentValue(ignore_nodata):
            ignore_nodata = "DATA"
        if ignore_nodata not in ["DATA", "NODATA"]:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (CellStatistics). Parameters are not valid.\nERROR 000621: Input to parameter ignore_nodata not within domain.\n")
        if Utils.useDefaultArgumentValue(process_as_multiband):
            process_as_multiband = "SINGLE_BAND"
        if process_as_multiband not in ["SINGLE_BAND", "MULTI_BAND"]:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (CellStatistics). Parameters are not valid.\nERROR 000621: Input to parameter process_as_multiband not within domain.\n")
        if Utils.argumentValueEqualsString(ignore_nodata, "DATA"):
            function += "ContinueOnNoData"
        if Utils.useDefaultArgumentValue(percentile_value):
            percentile_value = 90.0
        if Utils.useDefaultArgumentValue(percentile_interpolation_type):
            percentile_interpolation_type = "AUTO_DETECT"
        if percentile_interpolation_type.upper() not in interpolationTypes:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (CellStatistics). Parameters are not valid.\nERROR 000621: Input to parameter percentile_interpolation_type not within domain.\n")
        return _wrapLocalFunctionRaster(
            u"CellStatistics_sa",
            [function] + Utils.flattenLists(in_rasters_or_constants),
            {
                "flattenBands" : process_as_multiband.upper() == "SINGLE_BAND",
                "PercentileValue" : float(percentile_value),
                "PercentileInterpolationType" : int(interpolationTypes[percentile_interpolation_type]),
            })
    return Wrapper(
        in_rasters_or_constants,
        statistics_type,
        ignore_nodata,
        process_as_multiband,
        percentile_value,
        percentile_interpolation_type)
CellStatistics.__esri_toolname__ = "CellStatistics_sa"
CellStatistics.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def ClassifyRaster(
        in_raster,
        in_classifier_definition,
        in_additional_raster="#"):
    """ClassifyRaster_sa(in_raster, in_classifier_definition, {in_additional_raster})

    Classifies a raster dataset based on an Esri classifier definition file (.ecd) and raster dataset inputs.

    Arguments:
    in_raster -- 
    in_classifier_definition -- 
    in_additional_raster -- 

    Results:
    out_raster_dataset -- Output Classified Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_classifier_definition,
            in_additional_raster):
        out_raster_dataset = "#"
        result = arcpy.gp.ClassifyRaster_sa(
            in_raster,
            in_classifier_definition,
            out_raster_dataset,
            in_additional_raster)
        return _wrapToolRaster(u"ClassifyRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_classifier_definition,
        in_additional_raster)
ClassifyRaster.__esri_toolname__ = "ClassifyRaster_sa"
ClassifyRaster.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def ClassProbability(
        in_raster_bands,
        in_signature_file,
        maximum_output_value="#",
        a_priori_probabilities="#",
        in_a_priori_file="#"):
    """ClassProbability_sa([in_raster_band,...], in_signature_file, {maximum_output_value}, {a_priori_probabilities}, {in_a_priori_file})

    Creates a multiband raster of probability bands, with one band being created for each class represented in the input signature file.

    Arguments:
    in_raster_band -- 
    in_signature_file -- 
    maximum_output_value -- 
    a_priori_probabilities -- 
    in_a_priori_file -- 

    Results:
    out_multiband_raster -- Output multiband raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_bands,
            in_signature_file,
            maximum_output_value,
            a_priori_probabilities,
            in_a_priori_file):
        out_multiband_raster = "#"
        result = arcpy.gp.ClassProbability_sa(
            in_raster_bands,
            in_signature_file,
            out_multiband_raster,
            maximum_output_value,
            a_priori_probabilities,
            in_a_priori_file)
        return _wrapToolRaster(u"ClassProbability_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster_bands,
        in_signature_file,
        maximum_output_value,
        a_priori_probabilities,
        in_a_priori_file)
ClassProbability.__esri_toolname__ = "ClassProbability_sa"
ClassProbability.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6"
]


def CombinatorialAnd(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """CombinatorialAnd_sa(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Combinatorial And operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        out_raster = "#"
        result = arcpy.gp.CombinatorialAnd_sa(
            in_raster_or_constant1,
            in_raster_or_constant2,
            out_raster)
        return _wrapToolRaster(u"CombinatorialAnd_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
CombinatorialAnd.__esri_toolname__ = "CombinatorialAnd_sa"
CombinatorialAnd.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def CombinatorialOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """CombinatorialOr_sa(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Combinatorial Or operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        out_raster = "#"
        result = arcpy.gp.CombinatorialOr_sa(
            in_raster_or_constant1,
            in_raster_or_constant2,
            out_raster)
        return _wrapToolRaster(u"CombinatorialOr_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
CombinatorialOr.__esri_toolname__ = "CombinatorialOr_sa"
CombinatorialOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def CombinatorialXOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """CombinatorialXOr_sa(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Combinatorial eXclusive Or operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        out_raster = "#"
        result = arcpy.gp.CombinatorialXOr_sa(
            in_raster_or_constant1,
            in_raster_or_constant2,
            out_raster)
        return _wrapToolRaster(u"CombinatorialXOr_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
CombinatorialXOr.__esri_toolname__ = "CombinatorialXOr_sa"
CombinatorialXOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def Combine(
        in_rasters):
    """Combine_sa([in_raster,...])

    Combines multiple rasters so that a unique output value is assigned to each unique combination of input values.

    Arguments:
    in_raster -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_rasters):
        out_raster = "#"
        result = arcpy.gp.Combine_sa(
            in_rasters,
            out_raster)
        return _wrapToolRaster(u"Combine_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_rasters)
Combine.__esri_toolname__ = "Combine_sa"
Combine.__esri_toolinfo__ = [
    "::::1"
]


def ComputeConfusionMatrix(
        in_accuracy_assessment_points,
        out_confusion_matrix):
    """ComputeConfusionMatrix_sa(in_accuracy_assessment_points, out_confusion_matrix)

    Computes a confusion matrix with errors of omission and commission and derives a kappa index of agreement, Intersection over Union (IoU),  and an overall accuracy between the classified map and the reference data.

    Arguments:
    in_accuracy_assessment_points -- 
    out_confusion_matrix -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_accuracy_assessment_points,
            out_confusion_matrix):
        result = arcpy.gp.ComputeConfusionMatrix_sa(
            in_accuracy_assessment_points,
            out_confusion_matrix)
        return result
    return Wrapper(
        in_accuracy_assessment_points,
        out_confusion_matrix)
ComputeConfusionMatrix.__esri_toolname__ = "ComputeConfusionMatrix_sa"
ComputeConfusionMatrix.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def ComputeSegmentAttributes(
        in_segmented_raster,
        in_additional_raster="#",
        used_attributes="#"):
    """ComputeSegmentAttributes_sa(in_segmented_raster, {in_additional_raster}, {[used_attribute,...]})

    Computes a set of attributes associated with the segmented image. The input raster can be a single-band or 3-band, 8-bit segmented image.

    Arguments:
    in_segmented_raster -- 
    in_additional_raster -- 
    used_attribute -- 

    Results:
    out_index_raster_dataset -- Output Segment Index Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_segmented_raster,
            in_additional_raster,
            used_attributes):
        out_index_raster_dataset = "#"
        result = arcpy.gp.ComputeSegmentAttributes_sa(
            in_segmented_raster,
            out_index_raster_dataset,
            in_additional_raster,
            used_attributes)
        return _wrapToolRaster(u"ComputeSegmentAttributes_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_segmented_raster,
        in_additional_raster,
        used_attributes)
ComputeSegmentAttributes.__esri_toolname__ = "ComputeSegmentAttributes_sa"
ComputeSegmentAttributes.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4"
]


def Con(
        in_conditional_raster,
        in_true_raster_or_constant,
        in_false_raster_or_constant="#",
        where_clause="#"):
    """Con_sa(in_conditional_raster, in_true_raster_or_constant, {in_false_raster_or_constant}, {where_clause})

    Performs a conditional if/else evaluation on each of the input cells of an input raster.

    Arguments:
    in_conditional_raster -- 
    in_true_raster_or_constant -- 
    in_false_raster_or_constant -- 
    where_clause -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_conditional_raster,
            in_true_raster_or_constant,
            in_false_raster_or_constant,
            where_clause):
        if Utils.useDefaultArgumentValue(where_clause):
            if Utils.useDefaultArgumentValue(in_false_raster_or_constant):
                return _wrapLocalFunctionRaster(u"Con_sa",
                    ["IfThen", in_conditional_raster, in_true_raster_or_constant])
            else:
                return _wrapLocalFunctionRaster(u"Con_sa",
                    ["IfThenElse", in_conditional_raster, in_true_raster_or_constant, in_false_raster_or_constant])
        out_raster = "#"
        result = arcpy.gp.Con_sa(
            in_conditional_raster,
            in_true_raster_or_constant,
            out_raster,
            in_false_raster_or_constant,
            where_clause)
        return _wrapToolRaster(u"Con_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_conditional_raster,
        in_true_raster_or_constant,
        in_false_raster_or_constant,
        where_clause)
Con.__esri_toolname__ = "Con_sa"
Con.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5"
]


def Contour(
        in_raster,
        out_polyline_features,
        contour_interval,
        base_contour="#",
        z_factor="#",
        contour_type="#",
        max_vertices_per_feature="#"):
    """Contour_sa(in_raster, out_polyline_features, contour_interval, {base_contour}, {z_factor}, {contour_type}, {max_vertices_per_feature})

    Creates a feature class of contours from a raster surface.

    Arguments:
    in_raster -- 
    out_polyline_features -- 
    contour_interval -- 
    base_contour -- 
    z_factor -- 
    contour_type -- 
    max_vertices_per_feature -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            out_polyline_features,
            contour_interval,
            base_contour,
            z_factor,
            contour_type,
            max_vertices_per_feature):
        result = arcpy.gp.Contour_sa(
            in_raster,
            out_polyline_features,
            contour_interval,
            base_contour,
            z_factor,
            contour_type,
            max_vertices_per_feature)
        return result
    return Wrapper(
        in_raster,
        out_polyline_features,
        contour_interval,
        base_contour,
        z_factor,
        contour_type,
        max_vertices_per_feature)
Contour.__esri_toolname__ = "Contour_sa"
Contour.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def ContourList(
        in_raster,
        out_polyline_features,
        contour_values):
    """ContourList_sa(in_raster, out_polyline_features, [contour_value,...])

    Creates a feature class of selected contour values from a raster surface.

    Arguments:
    in_raster -- 
    out_polyline_features -- 
    contour_value -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            out_polyline_features,
            contour_values):
        result = arcpy.gp.ContourList_sa(
            in_raster,
            out_polyline_features,
            contour_values)
        return result
    return Wrapper(
        in_raster,
        out_polyline_features,
        contour_values)
ContourList.__esri_toolname__ = "ContourList_sa"
ContourList.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3"
]


def ContourWithBarriers(
        in_raster,
        out_contour_feature_class,
        in_barrier_features="#",
        in_contour_type="#",
        in_contour_values_file="#",
        explicit_only="#",
        in_base_contour="#",
        in_contour_interval="#",
        in_indexed_contour_interval="#",
        in_explicit_contours="#",
        in_z_factor="#"):
    """ContourWithBarriers_sa(in_raster, out_contour_feature_class, {in_barrier_features}, {in_contour_type}, {in_contour_values_file}, {explicit_only}, {in_base_contour}, {in_contour_interval}, {in_indexed_contour_interval}, {[in_explicit_contour,...]}, {in_z_factor})

    Creates contours from a raster surface. The inclusion of barrier features allows you to independently generate contours on either side of a barrier.

    Arguments:
    in_raster -- 
    out_contour_feature_class -- 
    in_barrier_features -- 
    in_contour_type -- 
    in_contour_values_file -- 
    explicit_only -- 
    in_base_contour -- 
    in_contour_interval -- 
    in_indexed_contour_interval -- 
    in_explicit_contour -- 
    in_z_factor -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            out_contour_feature_class,
            in_barrier_features,
            in_contour_type,
            in_contour_values_file,
            explicit_only,
            in_base_contour,
            in_contour_interval,
            in_indexed_contour_interval,
            in_explicit_contours,
            in_z_factor):
        result = arcpy.gp.ContourWithBarriers_sa(
            in_raster,
            out_contour_feature_class,
            in_barrier_features,
            in_contour_type,
            in_contour_values_file,
            explicit_only,
            in_base_contour,
            in_contour_interval,
            in_indexed_contour_interval,
            in_explicit_contours,
            in_z_factor)
        return result
    return Wrapper(
        in_raster,
        out_contour_feature_class,
        in_barrier_features,
        in_contour_type,
        in_contour_values_file,
        explicit_only,
        in_base_contour,
        in_contour_interval,
        in_indexed_contour_interval,
        in_explicit_contours,
        in_z_factor)
ContourWithBarriers.__esri_toolname__ = "ContourWithBarriers_sa"
ContourWithBarriers.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11"
]


def Corridor(
        in_distance_raster1,
        in_distance_raster2):
    """Corridor_sa(in_distance_raster1, in_distance_raster2)

    Calculates the sum of accumulative costs for two input accumulative cost rasters.

    Arguments:
    in_distance_raster1 -- 
    in_distance_raster2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_distance_raster1,
            in_distance_raster2):
        out_raster = "#"
        result = arcpy.gp.Corridor_sa(
            in_distance_raster1,
            in_distance_raster2,
            out_raster)
        return _wrapToolRaster(u"Corridor_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_distance_raster1,
        in_distance_raster2)
Corridor.__esri_toolname__ = "Corridor_sa"
Corridor.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def Cos(
        in_raster_or_constant):
    """Cos_sa(in_raster_or_constant)

    Calculates the cosine of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Cos_sa",
            ["Cos", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Cos.__esri_toolname__ = "Cos_sa"
Cos.__esri_toolinfo__ = [
    "::::1"
]


def CosH(
        in_raster_or_constant):
    """CosH_sa(in_raster_or_constant)

    Calculates the hyperbolic cosine of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"CosH_sa",
            ["CosH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
CosH.__esri_toolname__ = "CosH_sa"
CosH.__esri_toolinfo__ = [
    "::::1"
]


def CostAllocation(
        in_source_data,
        in_cost_raster,
        maximum_distance="#",
        in_value_raster="#",
        source_field="#",
        out_distance_raster="#",
        out_backlink_raster="#",
        source_cost_multiplier="#",
        source_start_cost="#",
        source_resistance_rate="#",
        source_capacity="#",
        source_direction="#"):
    """CostAllocation_sa(in_source_data, in_cost_raster, {maximum_distance}, {in_value_raster}, {source_field}, {out_distance_raster}, {out_backlink_raster}, {source_cost_multiplier}, {source_start_cost}, {source_resistance_rate}, {source_capacity}, {source_direction})

    Calculates, for each cell, its least-cost source based on the least accumulative cost over a cost surface.

    Arguments:
    in_source_data -- 
    in_cost_raster -- 
    maximum_distance -- 
    in_value_raster -- 
    source_field -- 
    out_distance_raster -- 
    out_backlink_raster -- 
    source_cost_multiplier -- 
    source_start_cost -- 
    source_resistance_rate -- 
    source_capacity -- 
    source_direction -- 

    Results:
    out_allocation_raster -- Output allocation raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_source_data,
            in_cost_raster,
            maximum_distance,
            in_value_raster,
            source_field,
            out_distance_raster,
            out_backlink_raster,
            source_cost_multiplier,
            source_start_cost,
            source_resistance_rate,
            source_capacity,
            source_direction):
        out_allocation_raster = "#"
        result = arcpy.gp.CostAllocation_sa(
            in_source_data,
            in_cost_raster,
            out_allocation_raster,
            maximum_distance,
            in_value_raster,
            source_field,
            out_distance_raster,
            out_backlink_raster,
            source_cost_multiplier,
            source_start_cost,
            source_resistance_rate,
            source_capacity,
            source_direction)
        return _wrapToolRaster(u"CostAllocation_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_source_data,
        in_cost_raster,
        maximum_distance,
        in_value_raster,
        source_field,
        out_distance_raster,
        out_backlink_raster,
        source_cost_multiplier,
        source_start_cost,
        source_resistance_rate,
        source_capacity,
        source_direction)
CostAllocation.__esri_toolname__ = "CostAllocation_sa"
CostAllocation.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13"
]


def CostBackLink(
        in_source_data,
        in_cost_raster,
        maximum_distance="#",
        out_distance_raster="#",
        source_cost_multiplier="#",
        source_start_cost="#",
        source_resistance_rate="#",
        source_capacity="#",
        source_direction="#"):
    """CostBackLink_sa(in_source_data, in_cost_raster, {maximum_distance}, {out_distance_raster}, {source_cost_multiplier}, {source_start_cost}, {source_resistance_rate}, {source_capacity}, {source_direction})

    Defines the neighbor that is the next cell on the least accumulative cost path to the least-cost source.

    Arguments:
    in_source_data -- 
    in_cost_raster -- 
    maximum_distance -- 
    out_distance_raster -- 
    source_cost_multiplier -- 
    source_start_cost -- 
    source_resistance_rate -- 
    source_capacity -- 
    source_direction -- 

    Results:
    out_backlink_raster -- Output backlink raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_source_data,
            in_cost_raster,
            maximum_distance,
            out_distance_raster,
            source_cost_multiplier,
            source_start_cost,
            source_resistance_rate,
            source_capacity,
            source_direction):
        out_backlink_raster = "#"
        result = arcpy.gp.CostBackLink_sa(
            in_source_data,
            in_cost_raster,
            out_backlink_raster,
            maximum_distance,
            out_distance_raster,
            source_cost_multiplier,
            source_start_cost,
            source_resistance_rate,
            source_capacity,
            source_direction)
        return _wrapToolRaster(u"CostBackLink_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_source_data,
        in_cost_raster,
        maximum_distance,
        out_distance_raster,
        source_cost_multiplier,
        source_start_cost,
        source_resistance_rate,
        source_capacity,
        source_direction)
CostBackLink.__esri_toolname__ = "CostBackLink_sa"
CostBackLink.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10"
]


def CostConnectivity(
        in_regions,
        in_cost_raster,
        out_feature_class,
        out_neighbor_paths="#"):
    """CostConnectivity_sa(in_regions, in_cost_raster, out_feature_class, {out_neighbor_paths})

    Produces the least-cost connectivity network between two or more input regions.

    Arguments:
    in_regions -- 
    in_cost_raster -- 
    out_feature_class -- 
    out_neighbor_paths -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_regions,
            in_cost_raster,
            out_feature_class,
            out_neighbor_paths):
        result = arcpy.gp.CostConnectivity_sa(
            in_regions,
            in_cost_raster,
            out_feature_class,
            out_neighbor_paths)
        return result
    return Wrapper(
        in_regions,
        in_cost_raster,
        out_feature_class,
        out_neighbor_paths)
CostConnectivity.__esri_toolname__ = "CostConnectivity_sa"
CostConnectivity.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4"
]


def CostDistance(
        in_source_data,
        in_cost_raster,
        maximum_distance="#",
        out_backlink_raster="#",
        source_cost_multiplier="#",
        source_start_cost="#",
        source_resistance_rate="#",
        source_capacity="#",
        source_direction="#"):
    """CostDistance_sa(in_source_data, in_cost_raster, {maximum_distance}, {out_backlink_raster}, {source_cost_multiplier}, {source_start_cost}, {source_resistance_rate}, {source_capacity}, {source_direction})

    Calculates the least accumulative cost distance for each cell from or to the least-cost source over a cost surface.

    Arguments:
    in_source_data -- 
    in_cost_raster -- 
    maximum_distance -- 
    out_backlink_raster -- 
    source_cost_multiplier -- 
    source_start_cost -- 
    source_resistance_rate -- 
    source_capacity -- 
    source_direction -- 

    Results:
    out_distance_raster -- Output distance raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_source_data,
            in_cost_raster,
            maximum_distance,
            out_backlink_raster,
            source_cost_multiplier,
            source_start_cost,
            source_resistance_rate,
            source_capacity,
            source_direction):
        out_distance_raster = "#"
        result = arcpy.gp.CostDistance_sa(
            in_source_data,
            in_cost_raster,
            out_distance_raster,
            maximum_distance,
            out_backlink_raster,
            source_cost_multiplier,
            source_start_cost,
            source_resistance_rate,
            source_capacity,
            source_direction)
        return _wrapToolRaster(u"CostDistance_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_source_data,
        in_cost_raster,
        maximum_distance,
        out_backlink_raster,
        source_cost_multiplier,
        source_start_cost,
        source_resistance_rate,
        source_capacity,
        source_direction)
CostDistance.__esri_toolname__ = "CostDistance_sa"
CostDistance.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10"
]


def CostPath(
        in_destination_data,
        in_cost_distance_raster,
        in_cost_backlink_raster,
        path_type="#",
        destination_field="#",
        force_flow_direction_convention="#"):
    """CostPath_sa(in_destination_data, in_cost_distance_raster, in_cost_backlink_raster, {path_type}, {destination_field}, {force_flow_direction_convention})

    Calculates the least-cost path from a source to a destination.

    Arguments:
    in_destination_data -- 
    in_cost_distance_raster -- 
    in_cost_backlink_raster -- 
    path_type -- 
    destination_field -- 
    force_flow_direction_convention -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_destination_data,
            in_cost_distance_raster,
            in_cost_backlink_raster,
            path_type,
            destination_field,
            force_flow_direction_convention):
        out_raster = "#"
        result = arcpy.gp.CostPath_sa(
            in_destination_data,
            in_cost_distance_raster,
            in_cost_backlink_raster,
            out_raster,
            path_type,
            destination_field,
            force_flow_direction_convention)
        return _wrapToolRaster(u"CostPath_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_destination_data,
        in_cost_distance_raster,
        in_cost_backlink_raster,
        path_type,
        destination_field,
        force_flow_direction_convention)
CostPath.__esri_toolname__ = "CostPath_sa"
CostPath.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::5",
    "::::6",
    "::::7"
]


def CostPathAsPolyline(
        in_destination_data,
        in_cost_distance_raster,
        in_cost_backlink_raster,
        out_polyline_features,
        path_type="#",
        destination_field="#",
        force_flow_direction_convention="#"):
    """CostPathAsPolyline_sa(in_destination_data, in_cost_distance_raster, in_cost_backlink_raster, out_polyline_features, {path_type}, {destination_field}, {force_flow_direction_convention})

    Calculates the least-cost path from a source to a destination as a line feature.

    Arguments:
    in_destination_data -- 
    in_cost_distance_raster -- 
    in_cost_backlink_raster -- 
    out_polyline_features -- 
    path_type -- 
    destination_field -- 
    force_flow_direction_convention -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_destination_data,
            in_cost_distance_raster,
            in_cost_backlink_raster,
            out_polyline_features,
            path_type,
            destination_field,
            force_flow_direction_convention):
        result = arcpy.gp.CostPathAsPolyline_sa(
            in_destination_data,
            in_cost_distance_raster,
            in_cost_backlink_raster,
            out_polyline_features,
            path_type,
            destination_field,
            force_flow_direction_convention)
        return result
    return Wrapper(
        in_destination_data,
        in_cost_distance_raster,
        in_cost_backlink_raster,
        out_polyline_features,
        path_type,
        destination_field,
        force_flow_direction_convention)
CostPathAsPolyline.__esri_toolname__ = "CostPathAsPolyline_sa"
CostPathAsPolyline.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def CreateAccuracyAssessmentPoints(
        in_class_data,
        out_points,
        target_field="#",
        num_random_points="#",
        sampling="#",
        polygon_dimension_field="#"):
    """CreateAccuracyAssessmentPoints_sa(in_class_data, out_points, {target_field}, {num_random_points}, {sampling}, {polygon_dimension_field})

    Creates randomly sampled points for post-classification accuracy assessment.

    Arguments:
    in_class_data -- 
    out_points -- 
    target_field -- 
    num_random_points -- 
    sampling -- 
    polygon_dimension_field -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_class_data,
            out_points,
            target_field,
            num_random_points,
            sampling,
            polygon_dimension_field):
        result = arcpy.gp.CreateAccuracyAssessmentPoints_sa(
            in_class_data,
            out_points,
            target_field,
            num_random_points,
            sampling,
            polygon_dimension_field)
        return result
    return Wrapper(
        in_class_data,
        out_points,
        target_field,
        num_random_points,
        sampling,
        polygon_dimension_field)
CreateAccuracyAssessmentPoints.__esri_toolname__ = "CreateAccuracyAssessmentPoints_sa"
CreateAccuracyAssessmentPoints.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def CreateConstantRaster(
        constant_value,
        data_type="#",
        cell_size="#",
        extent="#"):
    """CreateConstantRaster_sa(constant_value, {data_type}, {cell_size}, {extent})

    Creates a raster of a constant value within the extent and cell size of the analysis window.

    Arguments:
    constant_value -- 
    data_type -- 
    cell_size -- 
    extent -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            constant_value,
            data_type,
            cell_size,
            extent):
        out_raster = "#"
        result = arcpy.gp.CreateConstantRaster_sa(
            out_raster,
            constant_value,
            data_type,
            cell_size,
            extent)
        return _wrapToolRaster(u"CreateConstantRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        constant_value,
        data_type,
        cell_size,
        extent)
CreateConstantRaster.__esri_toolname__ = "CreateConstantRaster_sa"
CreateConstantRaster.__esri_toolinfo__ = [
    "::::2",
    "::::3",
    "::::4",
    "::::5"
]


def CreateNormalRaster(
        cell_size="#",
        extent="#"):
    """CreateNormalRaster_sa({cell_size}, {extent})

    Creates a raster of random values with a normal (Gaussian) distribution within the extent and cell size of the analysis window.

    Arguments:
    cell_size -- 
    extent -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            cell_size,
            extent):
        out_raster = "#"
        result = arcpy.gp.CreateNormalRaster_sa(
            out_raster,
            cell_size,
            extent)
        return _wrapToolRaster(u"CreateNormalRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        cell_size,
        extent)
CreateNormalRaster.__esri_toolname__ = "CreateNormalRaster_sa"
CreateNormalRaster.__esri_toolinfo__ = [
    "::::2",
    "::::3"
]


def CreateRandomRaster(
        seed_value="#",
        cell_size="#",
        extent="#"):
    """CreateRandomRaster_sa({seed_value}, {cell_size}, {extent})

    Creates a raster of random floating-point values between 0.0 and 1.0 within the extent and cell size of the analysis window.

    Arguments:
    seed_value -- 
    cell_size -- 
    extent -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            seed_value,
            cell_size,
            extent):
        out_raster = "#"
        result = arcpy.gp.CreateRandomRaster_sa(
            out_raster,
            seed_value,
            cell_size,
            extent)
        return _wrapToolRaster(u"CreateRandomRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        seed_value,
        cell_size,
        extent)
CreateRandomRaster.__esri_toolname__ = "CreateRandomRaster_sa"
CreateRandomRaster.__esri_toolinfo__ = [
    "::::2",
    "::::3",
    "::::4"
]


def CreateSignatures(
        in_raster_bands,
        in_sample_data,
        out_signature_file,
        compute_covariance="#",
        sample_field="#"):
    """CreateSignatures_sa([in_raster_band,...], in_sample_data, out_signature_file, {compute_covariance}, {sample_field})

    Creates an ASCII signature file of classes defined by input sample data and a set of raster bands.

    Arguments:
    in_raster_band -- 
    in_sample_data -- 
    out_signature_file -- 
    compute_covariance -- 
    sample_field -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster_bands,
            in_sample_data,
            out_signature_file,
            compute_covariance,
            sample_field):
        result = arcpy.gp.CreateSignatures_sa(
            in_raster_bands,
            in_sample_data,
            out_signature_file,
            compute_covariance,
            sample_field)
        return result
    return Wrapper(
        in_raster_bands,
        in_sample_data,
        out_signature_file,
        compute_covariance,
        sample_field)
CreateSignatures.__esri_toolname__ = "CreateSignatures_sa"
CreateSignatures.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5"
]


def Curvature(
        in_raster,
        z_factor="#",
        out_profile_curve_raster="#",
        out_plan_curve_raster="#"):
    """Curvature_sa(in_raster, {z_factor}, {out_profile_curve_raster}, {out_plan_curve_raster})

    Calculates the curvature of a raster surface, optionally including profile and plan curvature.

    Arguments:
    in_raster -- 
    z_factor -- 
    out_profile_curve_raster -- 
    out_plan_curve_raster -- 

    Results:
    out_curvature_raster -- Output curvature raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            z_factor,
            out_profile_curve_raster,
            out_plan_curve_raster):
        out_curvature_raster = "#"
        result = arcpy.gp.Curvature_sa(
            in_raster,
            out_curvature_raster,
            z_factor,
            out_profile_curve_raster,
            out_plan_curve_raster)
        return _wrapToolRaster(u"Curvature_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        z_factor,
        out_profile_curve_raster,
        out_plan_curve_raster)
Curvature.__esri_toolname__ = "Curvature_sa"
Curvature.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5"
]


def CutFill(
        in_before_surface,
        in_after_surface,
        z_factor="#"):
    """CutFill_sa(in_before_surface, in_after_surface, {z_factor})

    Calculates the volume change between two surfaces. This is typically used for cut and fill operations.

    Arguments:
    in_before_surface -- 
    in_after_surface -- 
    z_factor -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_before_surface,
            in_after_surface,
            z_factor):
        out_raster = "#"
        result = arcpy.gp.CutFill_sa(
            in_before_surface,
            in_after_surface,
            out_raster,
            z_factor)
        return _wrapToolRaster(u"CutFill_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_before_surface,
        in_after_surface,
        z_factor)
CutFill.__esri_toolname__ = "CutFill_sa"
CutFill.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def DarcyFlow(
        in_head_raster,
        in_porosity_raster,
        in_thickness_raster,
        in_transmissivity_raster,
        out_direction_raster="#",
        out_magnitude_raster="#"):
    """DarcyFlow_sa(in_head_raster, in_porosity_raster, in_thickness_raster, in_transmissivity_raster, {out_direction_raster}, {out_magnitude_raster})

    Calculates the groundwater volume balance residual and other outputs for steady flow in an aquifer.

    Arguments:
    in_head_raster -- 
    in_porosity_raster -- 
    in_thickness_raster -- 
    in_transmissivity_raster -- 
    out_direction_raster -- 
    out_magnitude_raster -- 

    Results:
    out_volume_raster -- Output groundwater volume balance residual raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_head_raster,
            in_porosity_raster,
            in_thickness_raster,
            in_transmissivity_raster,
            out_direction_raster,
            out_magnitude_raster):
        out_volume_raster = "#"
        result = arcpy.gp.DarcyFlow_sa(
            in_head_raster,
            in_porosity_raster,
            in_thickness_raster,
            in_transmissivity_raster,
            out_volume_raster,
            out_direction_raster,
            out_magnitude_raster)
        return _wrapToolRaster(u"DarcyFlow_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_head_raster,
        in_porosity_raster,
        in_thickness_raster,
        in_transmissivity_raster,
        out_direction_raster,
        out_magnitude_raster)
DarcyFlow.__esri_toolname__ = "DarcyFlow_sa"
DarcyFlow.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::6",
    "::::7"
]


def DarcyVelocity(
        in_head_raster,
        in_porosity_raster,
        in_thickness_raster,
        in_transmissivity_raster,
        out_magnitude_raster):
    """DarcyVelocity_sa(in_head_raster, in_porosity_raster, in_thickness_raster, in_transmissivity_raster, out_magnitude_raster)

    Calculates the groundwater seepage velocity vector (direction and magnitude) for steady flow in an aquifer.

    Arguments:
    in_head_raster -- 
    in_porosity_raster -- 
    in_thickness_raster -- 
    in_transmissivity_raster -- 
    out_magnitude_raster -- 

    Results:
    out_direction_raster -- Output direction raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_head_raster,
            in_porosity_raster,
            in_thickness_raster,
            in_transmissivity_raster,
            out_magnitude_raster):
        out_direction_raster = "#"
        result = arcpy.gp.DarcyVelocity_sa(
            in_head_raster,
            in_porosity_raster,
            in_thickness_raster,
            in_transmissivity_raster,
            out_direction_raster,
            out_magnitude_raster)
        return _wrapToolRaster(u"DarcyVelocity_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_head_raster,
        in_porosity_raster,
        in_thickness_raster,
        in_transmissivity_raster,
        out_magnitude_raster)
DarcyVelocity.__esri_toolname__ = "DarcyVelocity_sa"
DarcyVelocity.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::6"
]


def DeepLearningModelToEcd(
        in_deep_learning_model,
        in_classification_info_json,
        out_classifier_definition):
    """DeepLearningModelToEcd_sa(in_deep_learning_model, in_classification_info_json, out_classifier_definition)

    Converts a deep learning model to an Esri classifier definition file (.ecd).

    Arguments:
    in_deep_learning_model -- 
    in_classification_info_json -- 
    out_classifier_definition -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_deep_learning_model,
            in_classification_info_json,
            out_classifier_definition):
        result = arcpy.gp.DeepLearningModelToEcd_sa(
            in_deep_learning_model,
            in_classification_info_json,
            out_classifier_definition)
        return result
    return Wrapper(
        in_deep_learning_model,
        in_classification_info_json,
        out_classifier_definition)
DeepLearningModelToEcd.__esri_toolname__ = "DeepLearningModelToEcd_sa"
DeepLearningModelToEcd.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3"
]


def Dendrogram(
        in_signature_file,
        out_dendrogram_file,
        distance_calculation="#",
        line_width="#"):
    """Dendrogram_sa(in_signature_file, out_dendrogram_file, {distance_calculation}, {line_width})

    Constructs a tree diagram (dendrogram) showing attribute distances between sequentially merged classes in a signature file.

    Arguments:
    in_signature_file -- 
    out_dendrogram_file -- 
    distance_calculation -- 
    line_width -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_signature_file,
            out_dendrogram_file,
            distance_calculation,
            line_width):
        result = arcpy.gp.Dendrogram_sa(
            in_signature_file,
            out_dendrogram_file,
            distance_calculation,
            line_width)
        return result
    return Wrapper(
        in_signature_file,
        out_dendrogram_file,
        distance_calculation,
        line_width)
Dendrogram.__esri_toolname__ = "Dendrogram_sa"
Dendrogram.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4"
]


def DeriveContinuousFlow(
        in_surface_raster,
        in_depressions_data="#",
        in_weight_raster="#",
        out_flow_direction_raster="#",
        flow_direction_type="#",
        force_flow="#"):
    """DeriveContinuousFlow_sa(in_surface_raster, {in_depressions_data}, {in_weight_raster}, {out_flow_direction_raster}, {flow_direction_type}, {force_flow})

    Generates a raster of accumulated flow into each cell from an input surface raster with no prior sink or depression filling required.

    Arguments:
    in_surface_raster -- 
    in_depressions_data -- 
    in_weight_raster -- 
    out_flow_direction_raster -- 
    flow_direction_type -- 
    force_flow -- 

    Results:
    out_accumulation_raster -- Output flow accumulation raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_surface_raster,
            in_depressions_data,
            in_weight_raster,
            out_flow_direction_raster,
            flow_direction_type,
            force_flow):
        out_accumulation_raster = "#"
        result = arcpy.gp.DeriveContinuousFlow_sa(
            in_surface_raster,
            out_accumulation_raster,
            in_depressions_data,
            in_weight_raster,
            out_flow_direction_raster,
            flow_direction_type,
            force_flow)
        return _wrapToolRaster(u"DeriveContinuousFlow_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_surface_raster,
        in_depressions_data,
        in_weight_raster,
        out_flow_direction_raster,
        flow_direction_type,
        force_flow)
DeriveContinuousFlow.__esri_toolname__ = "DeriveContinuousFlow_sa"
DeriveContinuousFlow.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def DeriveStreamAsLine(
        in_surface_raster,
        out_stream_features,
        in_depressions_data="#",
        in_weight_raster="#",
        accumulation_threshold="#",
        stream_designation_method="#",
        simplify="#"):
    """DeriveStreamAsLine_sa(in_surface_raster, out_stream_features, {in_depressions_data}, {in_weight_raster}, {accumulation_threshold}, {stream_designation_method}, {simplify})

    Generates stream line features from an input surface raster with no prior sink or depression filling required.

    Arguments:
    in_surface_raster -- 
    out_stream_features -- 
    in_depressions_data -- 
    in_weight_raster -- 
    accumulation_threshold -- 
    stream_designation_method -- 
    simplify -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_surface_raster,
            out_stream_features,
            in_depressions_data,
            in_weight_raster,
            accumulation_threshold,
            stream_designation_method,
            simplify):
        result = arcpy.gp.DeriveStreamAsLine_sa(
            in_surface_raster,
            out_stream_features,
            in_depressions_data,
            in_weight_raster,
            accumulation_threshold,
            stream_designation_method,
            simplify)
        return result
    return Wrapper(
        in_surface_raster,
        out_stream_features,
        in_depressions_data,
        in_weight_raster,
        accumulation_threshold,
        stream_designation_method,
        simplify)
DeriveStreamAsLine.__esri_toolname__ = "DeriveStreamAsLine_sa"
DeriveStreamAsLine.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def DeriveStreamAsRaster(
        in_surface_raster,
        in_depressions_data="#",
        in_weight_raster="#",
        accumulation_threshold="#",
        stream_designation_method="#",
        force_flow="#"):
    """DeriveStreamAsRaster_sa(in_surface_raster, {in_depressions_data}, {in_weight_raster}, {accumulation_threshold}, {stream_designation_method}, {force_flow})

    Generates a stream raster from an input surface raster with no prior sink or depression filling required.

    Arguments:
    in_surface_raster -- 
    in_depressions_data -- 
    in_weight_raster -- 
    accumulation_threshold -- 
    stream_designation_method -- 
    force_flow -- 

    Results:
    out_stream_raster -- Output stream raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_surface_raster,
            in_depressions_data,
            in_weight_raster,
            accumulation_threshold,
            stream_designation_method,
            force_flow):
        out_stream_raster = "#"
        result = arcpy.gp.DeriveStreamAsRaster_sa(
            in_surface_raster,
            out_stream_raster,
            in_depressions_data,
            in_weight_raster,
            accumulation_threshold,
            stream_designation_method,
            force_flow)
        return _wrapToolRaster(u"DeriveStreamAsRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_surface_raster,
        in_depressions_data,
        in_weight_raster,
        accumulation_threshold,
        stream_designation_method,
        force_flow)
DeriveStreamAsRaster.__esri_toolname__ = "DeriveStreamAsRaster_sa"
DeriveStreamAsRaster.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def Diff(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Diff_sa(in_raster_or_constant1, in_raster_or_constant2)

    Determines which values from the first input are logically different from the values of the second input on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Diff_sa",
            ["Diff", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Diff.__esri_toolname__ = "Diff_sa"
Diff.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def DimensionalMovingStatistics(
        in_raster,
        dimension="#",
        backward_window="#",
        forward_window="#",
        nodata_handling="#",
        statistics_type="#",
        percentile_value="#",
        percentile_interpolation_type="#",
        circular_wrap_value="#"):
    """DimensionalMovingStatistics_sa(in_raster, {dimension}, {backward_window}, {forward_window}, {nodata_handling}, {statistics_type}, {percentile_value}, {percentile_interpolation_type}, {circular_wrap_value})

    Calculates statistics over a moving window on multidimensional data along a specified dimension.

    Arguments:
    in_raster -- 
    dimension -- 
    backward_window -- 
    forward_window -- 
    nodata_handling -- 
    statistics_type -- 
    percentile_value -- 
    percentile_interpolation_type -- 
    circular_wrap_value -- 

    Results:
    out_raster -- Output Multidimensional Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            dimension,
            backward_window,
            forward_window,
            nodata_handling,
            statistics_type,
            percentile_value,
            percentile_interpolation_type,
            circular_wrap_value):
        out_raster = Utils.UNEVALUATED_RASTER_FUNCTION_SIGNAL
        result = arcpy.gp.DimensionalMovingStatistics_sa(
            in_raster,
            out_raster,
            dimension,
            backward_window,
            forward_window,
            nodata_handling,
            statistics_type,
            percentile_value,
            percentile_interpolation_type,
            circular_wrap_value)
        import json
        rfx_args = json.loads(result.getOutput(1))
        in_raster = arcpy.Raster(in_raster)
        in_raster = ApplyEnvironment(in_raster)
        out_raster_afr = arcpy.ia.Apply(in_raster, "DimensionalMovingStatistics", rfx_args)
        out_raster_afr = ApplyEnvironment(out_raster_afr)
        # Return an unevaluated raster function chain
        return out_raster_afr
    return Wrapper(
        in_raster,
        dimension,
        backward_window,
        forward_window,
        nodata_handling,
        statistics_type,
        percentile_value,
        percentile_interpolation_type,
        circular_wrap_value)
DimensionalMovingStatistics.__esri_toolname__ = "DimensionalMovingStatistics_sa"
DimensionalMovingStatistics.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10"
]


def DistanceAccumulation(
        in_source_data,
        in_barrier_data="#",
        in_surface_raster="#",
        in_cost_raster="#",
        in_vertical_raster="#",
        vertical_factor="#",
        in_horizontal_raster="#",
        horizontal_factor="#",
        out_back_direction_raster="#",
        out_source_direction_raster="#",
        out_source_location_raster="#",
        source_initial_accumulation="#",
        source_maximum_accumulation="#",
        source_cost_multiplier="#",
        source_direction="#",
        distance_method="#"):
    """DistanceAccumulation_sa(in_source_data, {in_barrier_data}, {in_surface_raster}, {in_cost_raster}, {in_vertical_raster}, {vertical_factor}, {in_horizontal_raster}, {horizontal_factor}, {out_back_direction_raster}, {out_source_direction_raster}, {out_source_location_raster}, {source_initial_accumulation}, {source_maximum_accumulation}, {source_cost_multiplier}, {source_direction}, {distance_method})

    Calculates accumulated distance for each cell to sources, allowing for straight-line distance, cost distance, and true surface distance, as well as vertical and horizontal cost factors.

    Arguments:
    in_source_data -- 
    in_barrier_data -- 
    in_surface_raster -- 
    in_cost_raster -- 
    in_vertical_raster -- 
    vertical_factor -- 
    in_horizontal_raster -- 
    horizontal_factor -- 
    out_back_direction_raster -- 
    out_source_direction_raster -- 
    out_source_location_raster -- 
    source_initial_accumulation -- 
    source_maximum_accumulation -- 
    source_cost_multiplier -- 
    source_direction -- 
    distance_method -- 

    Results:
    out_distance_accumulation_raster -- Output distance accumulation raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_source_data,
            in_barrier_data,
            in_surface_raster,
            in_cost_raster,
            in_vertical_raster,
            vertical_factor,
            in_horizontal_raster,
            horizontal_factor,
            out_back_direction_raster,
            out_source_direction_raster,
            out_source_location_raster,
            source_initial_accumulation,
            source_maximum_accumulation,
            source_cost_multiplier,
            source_direction,
            distance_method):
        vertical_factor = Utils.compoundParameterToString(vertical_factor, ParameterClasses._VerticalFactor)
        horizontal_factor = Utils.compoundParameterToString(horizontal_factor, ParameterClasses._HorizontalFactor)
        out_distance_accumulation_raster = "#"
        result = arcpy.gp.DistanceAccumulation_sa(
            in_source_data,
            out_distance_accumulation_raster,
            in_barrier_data,
            in_surface_raster,
            in_cost_raster,
            in_vertical_raster,
            vertical_factor,
            in_horizontal_raster,
            horizontal_factor,
            out_back_direction_raster,
            out_source_direction_raster,
            out_source_location_raster,
            source_initial_accumulation,
            source_maximum_accumulation,
            source_cost_multiplier,
            source_direction,
            distance_method)
        return _wrapToolRaster(u"DistanceAccumulation_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_source_data,
        in_barrier_data,
        in_surface_raster,
        in_cost_raster,
        in_vertical_raster,
        vertical_factor,
        in_horizontal_raster,
        horizontal_factor,
        out_back_direction_raster,
        out_source_direction_raster,
        out_source_location_raster,
        source_initial_accumulation,
        source_maximum_accumulation,
        source_cost_multiplier,
        source_direction,
        distance_method)
DistanceAccumulation.__esri_toolname__ = "DistanceAccumulation_sa"
DistanceAccumulation.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "Python::VfBinary|VfCos|VfCosSec|VfInverseLinear|VfLinear|VfSec|VfSecCos|VfSymInverseLinear|VfSymLinear|VfTable::",
    "::::8",
    "Python::HfBinary|HfForward|HfInverseLinear|HfLinear|HfTable::",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14",
    "::::15",
    "::::16",
    "::::17"
]


def DistanceAllocation(
        in_source_data,
        in_barrier_data="#",
        in_surface_raster="#",
        in_cost_raster="#",
        in_vertical_raster="#",
        vertical_factor="#",
        in_horizontal_raster="#",
        horizontal_factor="#",
        out_distance_accumulation_raster="#",
        out_back_direction_raster="#",
        out_source_direction_raster="#",
        out_source_location_raster="#",
        source_field="#",
        source_initial_accumulation="#",
        source_maximum_accumulation="#",
        source_cost_multiplier="#",
        source_direction="#",
        distance_method="#"):
    """DistanceAllocation_sa(in_source_data, {in_barrier_data}, {in_surface_raster}, {in_cost_raster}, {in_vertical_raster}, {vertical_factor}, {in_horizontal_raster}, {horizontal_factor}, {out_distance_accumulation_raster}, {out_back_direction_raster}, {out_source_direction_raster}, {out_source_location_raster}, {source_field}, {source_initial_accumulation}, {source_maximum_accumulation}, {source_cost_multiplier}, {source_direction}, {distance_method})

    Calculates distance allocation for each cell to the provided sources based on straight-line distance, cost distance, and true surface distance, as well as vertical and horizontal cost factors.

    Arguments:
    in_source_data -- 
    in_barrier_data -- 
    in_surface_raster -- 
    in_cost_raster -- 
    in_vertical_raster -- 
    vertical_factor -- 
    in_horizontal_raster -- 
    horizontal_factor -- 
    out_distance_accumulation_raster -- 
    out_back_direction_raster -- 
    out_source_direction_raster -- 
    out_source_location_raster -- 
    source_field -- 
    source_initial_accumulation -- 
    source_maximum_accumulation -- 
    source_cost_multiplier -- 
    source_direction -- 
    distance_method -- 

    Results:
    out_distance_allocation_raster -- Output distance allocation raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_source_data,
            in_barrier_data,
            in_surface_raster,
            in_cost_raster,
            in_vertical_raster,
            vertical_factor,
            in_horizontal_raster,
            horizontal_factor,
            out_distance_accumulation_raster,
            out_back_direction_raster,
            out_source_direction_raster,
            out_source_location_raster,
            source_field,
            source_initial_accumulation,
            source_maximum_accumulation,
            source_cost_multiplier,
            source_direction,
            distance_method):
        vertical_factor = Utils.compoundParameterToString(vertical_factor, ParameterClasses._VerticalFactor)
        horizontal_factor = Utils.compoundParameterToString(horizontal_factor, ParameterClasses._HorizontalFactor)
        out_distance_allocation_raster = "#"
        result = arcpy.gp.DistanceAllocation_sa(
            in_source_data,
            out_distance_allocation_raster,
            in_barrier_data,
            in_surface_raster,
            in_cost_raster,
            in_vertical_raster,
            vertical_factor,
            in_horizontal_raster,
            horizontal_factor,
            out_distance_accumulation_raster,
            out_back_direction_raster,
            out_source_direction_raster,
            out_source_location_raster,
            source_field,
            source_initial_accumulation,
            source_maximum_accumulation,
            source_cost_multiplier,
            source_direction,
            distance_method)
        return _wrapToolRaster(u"DistanceAllocation_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_source_data,
        in_barrier_data,
        in_surface_raster,
        in_cost_raster,
        in_vertical_raster,
        vertical_factor,
        in_horizontal_raster,
        horizontal_factor,
        out_distance_accumulation_raster,
        out_back_direction_raster,
        out_source_direction_raster,
        out_source_location_raster,
        source_field,
        source_initial_accumulation,
        source_maximum_accumulation,
        source_cost_multiplier,
        source_direction,
        distance_method)
DistanceAllocation.__esri_toolname__ = "DistanceAllocation_sa"
DistanceAllocation.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "Python::VfBinary|VfCos|VfCosSec|VfInverseLinear|VfLinear|VfSec|VfSecCos|VfSymInverseLinear|VfSymLinear|VfTable::",
    "::::8",
    "Python::HfBinary|HfForward|HfInverseLinear|HfLinear|HfTable::",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14",
    "::::15",
    "::::16",
    "::::17",
    "::::18",
    "::::19"
]


def Divide(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Divide_sa(in_raster_or_constant1, in_raster_or_constant2)

    Divides the values of two rasters on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Divide_sa",
            ["Divide", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Divide.__esri_toolname__ = "Divide_sa"
Divide.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def EditSignatures(
        in_raster_bands,
        in_signature_file,
        in_signature_remap_file,
        out_signature_file,
        sample_interval="#"):
    """EditSignatures_sa([in_raster_band,...], in_signature_file, in_signature_remap_file, out_signature_file, {sample_interval})

    Edits and updates a signature file by merging, renumbering, and deleting class signatures.

    Arguments:
    in_raster_band -- 
    in_signature_file -- 
    in_signature_remap_file -- 
    out_signature_file -- 
    sample_interval -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster_bands,
            in_signature_file,
            in_signature_remap_file,
            out_signature_file,
            sample_interval):
        result = arcpy.gp.EditSignatures_sa(
            in_raster_bands,
            in_signature_file,
            in_signature_remap_file,
            out_signature_file,
            sample_interval)
        return result
    return Wrapper(
        in_raster_bands,
        in_signature_file,
        in_signature_remap_file,
        out_signature_file,
        sample_interval)
EditSignatures.__esri_toolname__ = "EditSignatures_sa"
EditSignatures.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5"
]


def EqualTo(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """EqualTo_sa(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational equal-to operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"EqualTo_sa",
            ["EqualTo", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
EqualTo.__esri_toolname__ = "EqualTo_sa"
EqualTo.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def EqualToFrequency(
        in_value_raster,
        in_rasters,
        process_as_multiband="#"):
    """EqualToFrequency_sa(in_value_raster, [in_raster,...], {process_as_multiband})

    Evaluates on a cell-by-cell basis the number of times the values in a set of rasters are equal to another raster.

    Arguments:
    in_value_raster -- 
    in_raster -- 
    process_as_multiband -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_value_raster,
            in_rasters,
            process_as_multiband):
        if Utils.useDefaultArgumentValue(process_as_multiband):
            process_as_multiband = "SINGLE_BAND"
        if process_as_multiband not in ["SINGLE_BAND", "MULTI_BAND"]:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (EqualToFrequency). Parameters are not valid.\nERROR 000621: Input to parameter process_as_multiband not within domain.\n")
        return _wrapLocalFunctionRaster(u"EqualToFrequency_sa", ["EqualToFrequency", in_value_raster] + Utils.flattenLists(in_rasters), {"flattenBands" : process_as_multiband.upper() == "SINGLE_BAND"})
    return Wrapper(
        in_value_raster,
        in_rasters,
        process_as_multiband)
EqualToFrequency.__esri_toolname__ = "EqualToFrequency_sa"
EqualToFrequency.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def EucAllocation(
        in_source_data,
        maximum_distance="#",
        in_value_raster="#",
        cell_size="#",
        source_field="#",
        out_distance_raster="#",
        out_direction_raster="#",
        distance_method="#",
        in_barrier_data="#",
        out_back_direction_raster="#"):
    """EucAllocation_sa(in_source_data, {maximum_distance}, {in_value_raster}, {cell_size}, {source_field}, {out_distance_raster}, {out_direction_raster}, {distance_method}, {in_barrier_data}, {out_back_direction_raster})

    Calculates, for each cell, the nearest source based on Euclidean distance.

    Arguments:
    in_source_data -- 
    maximum_distance -- 
    in_value_raster -- 
    cell_size -- 
    source_field -- 
    out_distance_raster -- 
    out_direction_raster -- 
    distance_method -- 
    in_barrier_data -- 
    out_back_direction_raster -- 

    Results:
    out_allocation_raster -- Output allocation raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_source_data,
            maximum_distance,
            in_value_raster,
            cell_size,
            source_field,
            out_distance_raster,
            out_direction_raster,
            distance_method,
            in_barrier_data,
            out_back_direction_raster):
        out_allocation_raster = "#"
        result = arcpy.gp.EucAllocation_sa(
            in_source_data,
            out_allocation_raster,
            maximum_distance,
            in_value_raster,
            cell_size,
            source_field,
            out_distance_raster,
            out_direction_raster,
            distance_method,
            in_barrier_data,
            out_back_direction_raster)
        return _wrapToolRaster(u"EucAllocation_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_source_data,
        maximum_distance,
        in_value_raster,
        cell_size,
        source_field,
        out_distance_raster,
        out_direction_raster,
        distance_method,
        in_barrier_data,
        out_back_direction_raster)
EucAllocation.__esri_toolname__ = "EucAllocation_sa"
EucAllocation.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11"
]


def EucBackDirection(
        in_source_data,
        in_barrier_data="#",
        maximum_distance="#",
        cell_size="#",
        distance_method="#"):
    """EucBackDirection_sa(in_source_data, {in_barrier_data}, {maximum_distance}, {cell_size}, {distance_method})

    Calculates, for each cell, the direction, in degrees, to the neighboring cell along the shortest path back to the closest source while avoiding barriers.

    Arguments:
    in_source_data -- 
    in_barrier_data -- 
    maximum_distance -- 
    cell_size -- 
    distance_method -- 

    Results:
    out_back_direction_raster -- Output back direction raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_source_data,
            in_barrier_data,
            maximum_distance,
            cell_size,
            distance_method):
        out_back_direction_raster = "#"
        result = arcpy.gp.EucBackDirection_sa(
            in_source_data,
            out_back_direction_raster,
            in_barrier_data,
            maximum_distance,
            cell_size,
            distance_method)
        return _wrapToolRaster(u"EucBackDirection_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_source_data,
        in_barrier_data,
        maximum_distance,
        cell_size,
        distance_method)
EucBackDirection.__esri_toolname__ = "EucBackDirection_sa"
EucBackDirection.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def EucDirection(
        in_source_data,
        maximum_distance="#",
        cell_size="#",
        out_distance_raster="#",
        distance_method="#",
        in_barrier_data="#",
        out_back_direction_raster="#"):
    """EucDirection_sa(in_source_data, {maximum_distance}, {cell_size}, {out_distance_raster}, {distance_method}, {in_barrier_data}, {out_back_direction_raster})

    Calculates, for each cell, the direction, in degrees, to the nearest source.

    Arguments:
    in_source_data -- 
    maximum_distance -- 
    cell_size -- 
    out_distance_raster -- 
    distance_method -- 
    in_barrier_data -- 
    out_back_direction_raster -- 

    Results:
    out_direction_raster -- Output direction raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_source_data,
            maximum_distance,
            cell_size,
            out_distance_raster,
            distance_method,
            in_barrier_data,
            out_back_direction_raster):
        out_direction_raster = "#"
        result = arcpy.gp.EucDirection_sa(
            in_source_data,
            out_direction_raster,
            maximum_distance,
            cell_size,
            out_distance_raster,
            distance_method,
            in_barrier_data,
            out_back_direction_raster)
        return _wrapToolRaster(u"EucDirection_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_source_data,
        maximum_distance,
        cell_size,
        out_distance_raster,
        distance_method,
        in_barrier_data,
        out_back_direction_raster)
EucDirection.__esri_toolname__ = "EucDirection_sa"
EucDirection.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8"
]


def EucDistance(
        in_source_data,
        maximum_distance="#",
        cell_size="#",
        out_direction_raster="#",
        distance_method="#",
        in_barrier_data="#",
        out_back_direction_raster="#"):
    """EucDistance_sa(in_source_data, {maximum_distance}, {cell_size}, {out_direction_raster}, {distance_method}, {in_barrier_data}, {out_back_direction_raster})

    Calculates, for each cell, the Euclidean distance to the closest source.

    Arguments:
    in_source_data -- 
    maximum_distance -- 
    cell_size -- 
    out_direction_raster -- 
    distance_method -- 
    in_barrier_data -- 
    out_back_direction_raster -- 

    Results:
    out_distance_raster -- Output distance raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_source_data,
            maximum_distance,
            cell_size,
            out_direction_raster,
            distance_method,
            in_barrier_data,
            out_back_direction_raster):
        out_distance_raster = "#"
        result = arcpy.gp.EucDistance_sa(
            in_source_data,
            out_distance_raster,
            maximum_distance,
            cell_size,
            out_direction_raster,
            distance_method,
            in_barrier_data,
            out_back_direction_raster)
        return _wrapToolRaster(u"EucDistance_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_source_data,
        maximum_distance,
        cell_size,
        out_direction_raster,
        distance_method,
        in_barrier_data,
        out_back_direction_raster)
EucDistance.__esri_toolname__ = "EucDistance_sa"
EucDistance.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8"
]


def Exp(
        in_raster_or_constant):
    """Exp_sa(in_raster_or_constant)

    Calculates the base e exponential of the cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Exp_sa",
            ["Exp", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Exp.__esri_toolname__ = "Exp_sa"
Exp.__esri_toolinfo__ = [
    "::::1"
]


def Exp10(
        in_raster_or_constant):
    """Exp10_sa(in_raster_or_constant)

    Calculates the base 10 exponential of the cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Exp10_sa",
            ["Exp10", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Exp10.__esri_toolname__ = "Exp10_sa"
Exp10.__esri_toolinfo__ = [
    "::::1"
]


def Exp2(
        in_raster_or_constant):
    """Exp2_sa(in_raster_or_constant)

    Calculates the base 2 exponential of the cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Exp2_sa",
            ["Exp2", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Exp2.__esri_toolname__ = "Exp2_sa"
Exp2.__esri_toolinfo__ = [
    "::::1"
]


def Expand(
        in_raster,
        number_cells,
        zone_values,
        expand_method="#"):
    """Expand_sa(in_raster, number_cells, [zone_value,...], {expand_method})

    Expands specified zones of a raster by a specified number of cells.

    Arguments:
    in_raster -- 
    number_cells -- 
    zone_value -- 
    expand_method -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            number_cells,
            zone_values,
            expand_method):
        out_raster = "#"
        result = arcpy.gp.Expand_sa(
            in_raster,
            out_raster,
            number_cells,
            zone_values,
            expand_method)
        return _wrapToolRaster(u"Expand_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        number_cells,
        zone_values,
        expand_method)
Expand.__esri_toolname__ = "Expand_sa"
Expand.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5"
]


def ExportTrainingDataForDeepLearning(
        in_raster,
        out_folder,
        in_class_data="#",
        image_chip_format="#",
        tile_size_x="#",
        tile_size_y="#",
        stride_x="#",
        stride_y="#",
        output_nofeature_tiles="#",
        metadata_format="#",
        start_index="#",
        class_value_field="#",
        buffer_radius="#",
        in_mask_polygons="#",
        rotation_angle="#",
        reference_system="#",
        processing_mode="#",
        blacken_around_feature="#",
        crop_mode="#",
        in_raster2="#",
        in_instance_data="#",
        instance_class_value_field="#",
        min_polygon_overlap_ratio="#"):
    """ExportTrainingDataForDeepLearning_sa(in_raster, out_folder, {in_class_data}, {image_chip_format}, {tile_size_x}, {tile_size_y}, {stride_x}, {stride_y}, {output_nofeature_tiles}, {metadata_format}, {start_index}, {class_value_field}, {buffer_radius}, {in_mask_polygons}, {rotation_angle}, {reference_system}, {processing_mode}, {blacken_around_feature}, {crop_mode}, {in_raster2}, {in_instance_data}, {instance_class_value_field}, {min_polygon_overlap_ratio})

    Converts labeled vector or raster data into deep learning training datasets using a remote sensing image. The output will be a folder of image chips and a folder of metadata files in the specified format.

    Arguments:
    in_raster -- 
    out_folder -- 
    in_class_data -- 
    image_chip_format -- 
    tile_size_x -- 
    tile_size_y -- 
    stride_x -- 
    stride_y -- 
    output_nofeature_tiles -- 
    metadata_format -- 
    start_index -- 
    class_value_field -- 
    buffer_radius -- 
    in_mask_polygons -- 
    rotation_angle -- 
    reference_system -- 
    processing_mode -- 
    blacken_around_feature -- 
    crop_mode -- 
    in_raster2 -- 
    in_instance_data -- 
    instance_class_value_field -- 
    min_polygon_overlap_ratio -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            out_folder,
            in_class_data,
            image_chip_format,
            tile_size_x,
            tile_size_y,
            stride_x,
            stride_y,
            output_nofeature_tiles,
            metadata_format,
            start_index,
            class_value_field,
            buffer_radius,
            in_mask_polygons,
            rotation_angle,
            reference_system,
            processing_mode,
            blacken_around_feature,
            crop_mode,
            in_raster2,
            in_instance_data,
            instance_class_value_field,
            min_polygon_overlap_ratio):
        result = arcpy.gp.ExportTrainingDataForDeepLearning_sa(
            in_raster,
            out_folder,
            in_class_data,
            image_chip_format,
            tile_size_x,
            tile_size_y,
            stride_x,
            stride_y,
            output_nofeature_tiles,
            metadata_format,
            start_index,
            class_value_field,
            buffer_radius,
            in_mask_polygons,
            rotation_angle,
            reference_system,
            processing_mode,
            blacken_around_feature,
            crop_mode,
            in_raster2,
            in_instance_data,
            instance_class_value_field,
            min_polygon_overlap_ratio)
        return result
    return Wrapper(
        in_raster,
        out_folder,
        in_class_data,
        image_chip_format,
        tile_size_x,
        tile_size_y,
        stride_x,
        stride_y,
        output_nofeature_tiles,
        metadata_format,
        start_index,
        class_value_field,
        buffer_radius,
        in_mask_polygons,
        rotation_angle,
        reference_system,
        processing_mode,
        blacken_around_feature,
        crop_mode,
        in_raster2,
        in_instance_data,
        instance_class_value_field,
        min_polygon_overlap_ratio)
ExportTrainingDataForDeepLearning.__esri_toolname__ = "ExportTrainingDataForDeepLearning_sa"
ExportTrainingDataForDeepLearning.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14",
    "::::15",
    "::::16",
    "::::17",
    "::::18",
    "::::19",
    "::::20",
    "::::21",
    "::::22",
    "::::23"
]


def ExtractByAttributes(
        in_raster,
        where_clause):
    """ExtractByAttributes_sa(in_raster, where_clause)

    Extracts the cells of a raster based on a logical query.

    Arguments:
    in_raster -- 
    where_clause -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            where_clause):
        out_raster = "#"
        result = arcpy.gp.ExtractByAttributes_sa(
            in_raster,
            where_clause,
            out_raster)
        return _wrapToolRaster(u"ExtractByAttributes_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        where_clause)
ExtractByAttributes.__esri_toolname__ = "ExtractByAttributes_sa"
ExtractByAttributes.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def ExtractByCircle(
        in_raster,
        center_point,
        radius,
        extraction_area="#"):
    """ExtractByCircle_sa(in_raster, center_point, radius, {extraction_area})

    Extracts the cells of a raster based on a circle by specifying the circle's center and radius.

    Arguments:
    in_raster -- 
    center_point -- 
    radius -- 
    extraction_area -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            center_point,
            radius,
            extraction_area):
        center_point = Utils.compoundParameterToString(center_point, arcpy.Point)
        out_raster = "#"
        result = arcpy.gp.ExtractByCircle_sa(
            in_raster,
            center_point,
            radius,
            out_raster,
            extraction_area)
        return _wrapToolRaster(u"ExtractByCircle_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        center_point,
        radius,
        extraction_area)
ExtractByCircle.__esri_toolname__ = "ExtractByCircle_sa"
ExtractByCircle.__esri_toolinfo__ = [
    "::::1",
    "Python::Point::",
    "::::3",
    "::::5"
]


def ExtractByMask(
        in_raster,
        in_mask_data,
        extraction_area="#",
        analysis_extent="#"):
    """ExtractByMask_sa(in_raster, in_mask_data, {extraction_area}, {analysis_extent})

    Extracts the cells of a raster that correspond to the areas defined by a mask.

    Arguments:
    in_raster -- 
    in_mask_data -- 
    extraction_area -- 
    analysis_extent -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_mask_data,
            extraction_area,
            analysis_extent):
        analysis_extent = Utils.compoundParameterToString(analysis_extent, arcpy.Extent)
        out_raster = "#"
        result = arcpy.gp.ExtractByMask_sa(
            in_raster,
            in_mask_data,
            out_raster,
            extraction_area,
            analysis_extent)
        return _wrapToolRaster(u"ExtractByMask_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_mask_data,
        extraction_area,
        analysis_extent)
ExtractByMask.__esri_toolname__ = "ExtractByMask_sa"
ExtractByMask.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "Python::Extent::"
]


def ExtractByPoints(
        in_raster,
        points,
        extraction_area="#"):
    """ExtractByPoints_sa(in_raster, [point,...], {extraction_area})

    Extracts the cells of a raster based on a set of coordinate points.

    Arguments:
    in_raster -- 
    point -- 
    extraction_area -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            points,
            extraction_area):
        points = Utils.multiValueCompoundParameterToString(points, arcpy.Point)
        out_raster = "#"
        result = arcpy.gp.ExtractByPoints_sa(
            in_raster,
            points,
            out_raster,
            extraction_area)
        return _wrapToolRaster(u"ExtractByPoints_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        points,
        extraction_area)
ExtractByPoints.__esri_toolname__ = "ExtractByPoints_sa"
ExtractByPoints.__esri_toolinfo__ = [
    "::::1",
    "Python::Point::",
    "::::4"
]


def ExtractByPolygon(
        in_raster,
        polygons,
        extraction_area="#"):
    """ExtractByPolygon_sa(in_raster, [polygon,...], {extraction_area})

    Extracts the cells of a raster based on a polygon by specifying the polygon's vertices.

    Arguments:
    in_raster -- 
    polygon -- 
    extraction_area -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            polygons,
            extraction_area):
        polygons = Utils.multiValueCompoundParameterToString(polygons, arcpy.Point)
        out_raster = "#"
        result = arcpy.gp.ExtractByPolygon_sa(
            in_raster,
            polygons,
            out_raster,
            extraction_area)
        return _wrapToolRaster(u"ExtractByPolygon_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        polygons,
        extraction_area)
ExtractByPolygon.__esri_toolname__ = "ExtractByPolygon_sa"
ExtractByPolygon.__esri_toolinfo__ = [
    "::::1",
    "Python::Point::",
    "::::4"
]


def ExtractByRectangle(
        in_raster,
        extent,
        extraction_area="#"):
    """ExtractByRectangle_sa(in_raster, extent, {extraction_area})

    Extracts the cells of a raster based on a rectangle by specifying the rectangle's extent.

    Arguments:
    in_raster -- 
    extent -- 
    extraction_area -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            extent,
            extraction_area):
        extent = Utils.compoundParameterToString(extent, arcpy.Extent)
        out_raster = "#"
        result = arcpy.gp.ExtractByRectangle_sa(
            in_raster,
            extent,
            out_raster,
            extraction_area)
        return _wrapToolRaster(u"ExtractByRectangle_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        extent,
        extraction_area)
ExtractByRectangle.__esri_toolname__ = "ExtractByRectangle_sa"
ExtractByRectangle.__esri_toolinfo__ = [
    "::::1",
    "Python::Extent::",
    "::::4"
]


def ExtractMultiValuesToPoints(
        in_point_features,
        in_rasters,
        bilinear_interpolate_values="#"):
    """ExtractMultiValuesToPoints_sa(in_point_features, in_rasters, {bilinear_interpolate_values})

    Extracts cell values at locations specified in a point feature class from one or more rasters and records the values to the attribute table of the point feature class.

    Arguments:
    in_point_features -- 
    in_rasters -- 
    bilinear_interpolate_values -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_point_features,
            in_rasters,
            bilinear_interpolate_values):
        result = arcpy.gp.ExtractMultiValuesToPoints_sa(
            in_point_features,
            in_rasters,
            bilinear_interpolate_values)
        return result
    return Wrapper(
        in_point_features,
        in_rasters,
        bilinear_interpolate_values)
ExtractMultiValuesToPoints.__esri_toolname__ = "ExtractMultiValuesToPoints_sa"
ExtractMultiValuesToPoints.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3"
]


def ExtractValuesToPoints(
        in_point_features,
        in_raster,
        out_point_features,
        interpolate_values="#",
        add_attributes="#"):
    """ExtractValuesToPoints_sa(in_point_features, in_raster, out_point_features, {interpolate_values}, {add_attributes})

    Extracts the cell values of a raster based on a set of point features and records the values in the attribute table of an output feature class.

    Arguments:
    in_point_features -- 
    in_raster -- 
    out_point_features -- 
    interpolate_values -- 
    add_attributes -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_point_features,
            in_raster,
            out_point_features,
            interpolate_values,
            add_attributes):
        result = arcpy.gp.ExtractValuesToPoints_sa(
            in_point_features,
            in_raster,
            out_point_features,
            interpolate_values,
            add_attributes)
        return result
    return Wrapper(
        in_point_features,
        in_raster,
        out_point_features,
        interpolate_values,
        add_attributes)
ExtractValuesToPoints.__esri_toolname__ = "ExtractValuesToPoints_sa"
ExtractValuesToPoints.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5"
]


def Fill(
        in_surface_raster,
        z_limit="#"):
    """Fill_sa(in_surface_raster, {z_limit})

    Fills sinks in a surface raster to remove small imperfections in the data.

    Arguments:
    in_surface_raster -- 
    z_limit -- 

    Results:
    out_surface_raster -- Output surface raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_surface_raster,
            z_limit):
        out_surface_raster = "#"
        result = arcpy.gp.Fill_sa(
            in_surface_raster,
            out_surface_raster,
            z_limit)
        return _wrapToolRaster(u"Fill_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_surface_raster,
        z_limit)
Fill.__esri_toolname__ = "Fill_sa"
Fill.__esri_toolinfo__ = [
    "::::1",
    "::::3"
]


def Filter(
        in_raster,
        filter_type="#",
        ignore_nodata="#"):
    """Filter_sa(in_raster, {filter_type}, {ignore_nodata})

    Performs either a smoothing (Low pass) or edge-enhancing (High pass) filter on a raster.

    Arguments:
    in_raster -- 
    filter_type -- 
    ignore_nodata -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            filter_type,
            ignore_nodata):
        out_raster = "#"
        result = arcpy.gp.Filter_sa(
            in_raster,
            out_raster,
            filter_type,
            ignore_nodata)
        return _wrapToolRaster(u"Filter_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        filter_type,
        ignore_nodata)
Filter.__esri_toolname__ = "Filter_sa"
Filter.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4"
]


def Float(
        in_raster_or_constant):
    """Float_sa(in_raster_or_constant)

    Converts each cell value of a raster into a floating-point representation.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Float_sa",
            ["Float", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Float.__esri_toolname__ = "Float_sa"
Float.__esri_toolinfo__ = [
    "::::1"
]


def FlowAccumulation(
        in_flow_direction_raster,
        in_weight_raster="#",
        data_type="#",
        flow_direction_type="#"):
    """FlowAccumulation_sa(in_flow_direction_raster, {in_weight_raster}, {data_type}, {flow_direction_type})

    Creates a raster of accumulated flow into each cell. A weight factor can optionally be applied.

    Arguments:
    in_flow_direction_raster -- 
    in_weight_raster -- 
    data_type -- 
    flow_direction_type -- 

    Results:
    out_accumulation_raster -- Output accumulation raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_flow_direction_raster,
            in_weight_raster,
            data_type,
            flow_direction_type):
        out_accumulation_raster = "#"
        result = arcpy.gp.FlowAccumulation_sa(
            in_flow_direction_raster,
            out_accumulation_raster,
            in_weight_raster,
            data_type,
            flow_direction_type)
        return _wrapToolRaster(u"FlowAccumulation_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_flow_direction_raster,
        in_weight_raster,
        data_type,
        flow_direction_type)
FlowAccumulation.__esri_toolname__ = "FlowAccumulation_sa"
FlowAccumulation.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5"
]


def FlowDirection(
        in_surface_raster,
        force_flow="#",
        out_drop_raster="#",
        flow_direction_type="#"):
    """FlowDirection_sa(in_surface_raster, {force_flow}, {out_drop_raster}, {flow_direction_type})

    Creates a raster of flow direction from each cell to its downslope neighbor, or neighbors, using the D8, Multiple Flow Direction (MFD), or D-Infinity (DINF) method.

    Arguments:
    in_surface_raster -- 
    force_flow -- 
    out_drop_raster -- 
    flow_direction_type -- 

    Results:
    out_flow_direction_raster -- Output flow direction raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_surface_raster,
            force_flow,
            out_drop_raster,
            flow_direction_type):
        out_flow_direction_raster = "#"
        result = arcpy.gp.FlowDirection_sa(
            in_surface_raster,
            out_flow_direction_raster,
            force_flow,
            out_drop_raster,
            flow_direction_type)
        return _wrapToolRaster(u"FlowDirection_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_surface_raster,
        force_flow,
        out_drop_raster,
        flow_direction_type)
FlowDirection.__esri_toolname__ = "FlowDirection_sa"
FlowDirection.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5"
]


def FlowDistance(
        in_stream_raster,
        in_surface_raster,
        in_flow_direction_raster="#",
        distance_type="#",
        flow_direction_type="#",
        statistics_type="#"):
    """FlowDistance_sa(in_stream_raster, in_surface_raster, {in_flow_direction_raster}, {distance_type}, {flow_direction_type}, {statistics_type})

    Computes, for each cell, the horizontal or vertical component of downslope distance, following the flow paths, to cells on a stream into which they flow. In case of multiple flow paths, minimum, weighted mean, or maximum flow distance can be computed.

    Arguments:
    in_stream_raster -- 
    in_surface_raster -- 
    in_flow_direction_raster -- 
    distance_type -- 
    flow_direction_type -- 
    statistics_type -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_stream_raster,
            in_surface_raster,
            in_flow_direction_raster,
            distance_type,
            flow_direction_type,
            statistics_type):
        out_raster = "#"
        result = arcpy.gp.FlowDistance_sa(
            in_stream_raster,
            in_surface_raster,
            out_raster,
            in_flow_direction_raster,
            distance_type,
            flow_direction_type,
            statistics_type)
        return _wrapToolRaster(u"FlowDistance_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_stream_raster,
        in_surface_raster,
        in_flow_direction_raster,
        distance_type,
        flow_direction_type,
        statistics_type)
FlowDistance.__esri_toolname__ = "FlowDistance_sa"
FlowDistance.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def FlowLength(
        in_flow_direction_raster,
        direction_measurement="#",
        in_weight_raster="#"):
    """FlowLength_sa(in_flow_direction_raster, {direction_measurement}, {in_weight_raster})

    Calculates the upstream or downstream distance, or weighted distance, along the flow path for each cell.

    Arguments:
    in_flow_direction_raster -- 
    direction_measurement -- 
    in_weight_raster -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_flow_direction_raster,
            direction_measurement,
            in_weight_raster):
        out_raster = "#"
        result = arcpy.gp.FlowLength_sa(
            in_flow_direction_raster,
            out_raster,
            direction_measurement,
            in_weight_raster)
        return _wrapToolRaster(u"FlowLength_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_flow_direction_raster,
        direction_measurement,
        in_weight_raster)
FlowLength.__esri_toolname__ = "FlowLength_sa"
FlowLength.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4"
]


def FocalFlow(
        in_surface_raster,
        threshold_value="#"):
    """FocalFlow_sa(in_surface_raster, {threshold_value})

    Determines the flow of the values in the input raster within each cell's immediate neighborhood.

    Arguments:
    in_surface_raster -- 
    threshold_value -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_surface_raster,
            threshold_value):
        out_raster = "#"
        result = arcpy.gp.FocalFlow_sa(
            in_surface_raster,
            out_raster,
            threshold_value)
        return _wrapToolRaster(u"FocalFlow_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_surface_raster,
        threshold_value)
FocalFlow.__esri_toolname__ = "FocalFlow_sa"
FocalFlow.__esri_toolinfo__ = [
    "::::1",
    "::::3"
]


def FocalStatistics(
        in_raster,
        neighborhood="#",
        statistics_type="#",
        ignore_nodata="#",
        percentile_value="#"):
    """FocalStatistics_sa(in_raster, {neighborhood}, {statistics_type}, {ignore_nodata}, {percentile_value})

    Calculates for each input cell location a statistic of the values within a specified neighborhood around it.

    Arguments:
    in_raster -- 
    neighborhood -- 
    statistics_type -- 
    ignore_nodata -- 
    percentile_value -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            neighborhood,
            statistics_type,
            ignore_nodata,
            percentile_value):
        neighborhood = Utils.compoundParameterToString(neighborhood, ParameterClasses._Neighborhood)
        args = {}
        # Neighborhood parameter
        nbr_types = {
            # values from esriRasterNeighborhoodEnum
            "RECTANGLE": 1,
            "CIRCLE": 2,
            "ANNULUS": 3,
            "WEDGE": 4,
            "IRREGULAR": 5,
            "WEIGHT": 6,
        }
        # Set defaults
        nbr_index = nbr_types["RECTANGLE"]  # Default neighborhood type
        args["Width"] = 3
        args["Height"] = 3
        in_raster = ApplyEnvironment(in_raster)
        # Parse and validate parameters
        msgs = Utils.ParameterErrors()
        # Neighborhood type
        nbr_fields = [f for f in neighborhood.split() if f]  # discard empty fields
        cell_scale = 1.0
        def _parse_float(f):
            try:
                from locale import atof as _atof
                return _atof(f)  # localized string
            except AttributeError:
                return float(f)  # number
        if len(nbr_fields) > 0:
            nbr_string = nbr_fields[0].upper()
            if nbr_string in nbr_types.keys():
                nbr_index = nbr_types[nbr_fields[0].upper()]
            if nbr_fields[-1].upper() == "MAP":
                cell_scale = _parse_float(arcpy.GetRasterProperties_management(in_raster, "CELLSIZEX").getOutput(0))
        def _cs(field: str, scale: float = cell_scale) -> int:  # convert MAP units to CELL units
            raw = _parse_float(field)
            if raw <= 0:
                msgs.add_id_message("ERROR", 622, "FocalStatistics")
                msgs.add_id_message("ERROR", 628, "neighborhood")
                raise arcpy.ExecuteError(msgs.combine())
            result = int(0.5 + raw / float(scale))
            if result <= 0:
                msgs.add_id_message("ERROR", 10176)  # Invalid neighborhood mask
                msgs.add_id_message("INFO", 952, "FocalStatistics")  # Failed to execute (tool_name).
                raise arcpy.ExecuteError(msgs.combine())
            return result
        args["NeighborhoodType"] = nbr_index
        if nbr_index == nbr_types["ANNULUS"]:
            if len(nbr_fields) >= 3:
                args["InnerRadius"] = _cs(nbr_fields[1])
                args["OuterRadius"] = _cs(nbr_fields[2])
            else:
                args["InnerRadius"] = 1
                args["OuterRadius"] = 3
        elif nbr_index == nbr_types["CIRCLE"]:
            if len(nbr_fields) > 1:
                args["Radius"] = _cs(nbr_fields[1])
            else:
                args["Radius"] = 3
        elif nbr_index == nbr_types["RECTANGLE"]:
            if len(nbr_fields) >= 3:
                args["Width"] = _cs(nbr_fields[1])
                args["Height"] = _cs(nbr_fields[2])
            else:
                args["Width"] = 3
                args["Height"] = 3
        elif nbr_index == nbr_types["WEDGE"]:
            if len(nbr_fields) >= 4:
                args["Radius"] = _cs(nbr_fields[1])
                args["StartAngle"] = _parse_float(nbr_fields[2])
                args["EndAngle"] = _parse_float(nbr_fields[3])
            else:
                args["Radius"] = 3
                args["StartAngle"] = 0
                args["EndAngle"] = 90
        elif nbr_index in (nbr_types["WEIGHT"], nbr_types["IRREGULAR"]):
            # Parse kernel file
            assert len(nbr_fields) == 2
            file_name = nbr_fields[1].strip("\"'")
            values = []
            with open(file_name, "r") as kernel_file:
                w, h = [int(s) for s in next(kernel_file).split()]
                for row in kernel_file:
                    for col in row.split():
                        values.append(_parse_float(col))
                assert len(values) == w * h
                args["Width"] = w
                args["Height"] = h
                args["NeighborhoodValues"] = values
        # Statistics type parameter
        stat_types = {
            # values from esriGeoAnalysisStatisticsEnum
            "MAJORITY": 1,
            "MAXIMUM": 2,
            "MEAN": 3,
            "MEDIAN": 4,
            "MINIMUM": 5,
            "MINORITY": 6,
            "RANGE": 7,
            "STANDARD_DEVIATION": 8,
            "STD": 8,
            "SUM": 9,
            "VARIETY": 10,
            "PERCENTILE": 12,
        }
        args["StatisticType"] = stat_types.get(str(statistics_type).upper(), stat_types["MEAN"])
        #
        args["NoDataPolicy"] = 0 if ignore_nodata.upper() == "NODATA" else -1
        try:
            args["Percentile"] = _parse_float(percentile_value)
        except ValueError:
            args["Percentile"] = 90.0
        result = arcpy.sa.Apply(in_raster, "Focal", args)
        result = ApplyEnvironment(result)
        return result
    return Wrapper(
        in_raster,
        neighborhood,
        statistics_type,
        ignore_nodata,
        percentile_value)
FocalStatistics.__esri_toolname__ = "FocalStatistics_sa"
FocalStatistics.__esri_toolinfo__ = [
    "::::1",
    "Python::NbrAnnulus|NbrCircle|NbrIrregular|NbrRectangle|NbrWedge|NbrWeight::",
    "::::4",
    "::::5",
    "::::6"
]


def FuzzyMembership(
        in_raster,
        fuzzy_function="#",
        hedge="#"):
    """FuzzyMembership_sa(in_raster, {fuzzy_function}, {hedge})

    Transforms  the input raster   into a 0 to 1 scale, indicating the strength of a membership in a set, based on a specified fuzzification algorithm.

    Arguments:
    in_raster -- 
    fuzzy_function -- 
    hedge -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            fuzzy_function,
            hedge):
        fuzzy_function = Utils.compoundParameterToString(fuzzy_function, ParameterClasses._FuzzyMembership)
        out_raster = "#"
        result = arcpy.gp.FuzzyMembership_sa(
            in_raster,
            out_raster,
            fuzzy_function,
            hedge)
        return _wrapToolRaster(u"FuzzyMembership_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        fuzzy_function,
        hedge)
FuzzyMembership.__esri_toolname__ = "FuzzyMembership_sa"
FuzzyMembership.__esri_toolinfo__ = [
    "::::1",
    "Python::FuzzyGaussian|FuzzyLarge|FuzzyLinear|FuzzyMSLarge|FuzzyMSSmall|FuzzyNear|FuzzySmall::",
    "::::4"
]


def FuzzyOverlay(
        in_rasters,
        overlay_type="#",
        gamma="#"):
    """FuzzyOverlay_sa([in_raster,...], {overlay_type}, {gamma})

    Combine fuzzy membership rasters data together, based on selected overlay type.

    Arguments:
    in_raster -- 
    overlay_type -- 
    gamma -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_rasters,
            overlay_type,
            gamma):
        out_raster = "#"
        result = arcpy.gp.FuzzyOverlay_sa(
            in_rasters,
            out_raster,
            overlay_type,
            gamma)
        return _wrapToolRaster(u"FuzzyOverlay_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_rasters,
        overlay_type,
        gamma)
FuzzyOverlay.__esri_toolname__ = "FuzzyOverlay_sa"
FuzzyOverlay.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4"
]


def GenerateMultidimensionalAnomaly(
        in_multidimensional_raster,
        variables="#",
        method="#",
        calculation_interval="#",
        ignore_nodata="#",
        reference_mean_raster="#"):
    """GenerateMultidimensionalAnomaly_sa(in_multidimensional_raster, {[variable,...]}, {method}, {calculation_interval}, {ignore_nodata}, {reference_mean_raster})

    Computes the anomaly for each slice in an existing multidimensional raster to generate a new multidimensional raster.

    Arguments:
    in_multidimensional_raster -- 
    variable -- 
    method -- 
    calculation_interval -- 
    ignore_nodata -- 
    reference_mean_raster -- 

    Results:
    out_multidimensional_raster -- Output Multidimensional Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_multidimensional_raster,
            variables,
            method,
            calculation_interval,
            ignore_nodata,
            reference_mean_raster):
        out_multidimensional_raster = "#"
        result = arcpy.gp.GenerateMultidimensionalAnomaly_sa(
            in_multidimensional_raster,
            out_multidimensional_raster,
            variables,
            method,
            calculation_interval,
            ignore_nodata,
            reference_mean_raster)
        return _wrapToolRaster(u"GenerateMultidimensionalAnomaly_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_multidimensional_raster,
        variables,
        method,
        calculation_interval,
        ignore_nodata,
        reference_mean_raster)
GenerateMultidimensionalAnomaly.__esri_toolname__ = "GenerateMultidimensionalAnomaly_sa"
GenerateMultidimensionalAnomaly.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def GenerateTrainingSamplesFromSeedPoints(
        in_class_data,
        in_seed_points,
        out_training_feature_class,
        min_sample_area="#",
        max_sample_radius="#"):
    """GenerateTrainingSamplesFromSeedPoints_sa(in_class_data, in_seed_points, out_training_feature_class, {min_sample_area}, {max_sample_radius})

    Generates training samples from seed points, such as accuracy assessment points or training sample points. A typical use case is generating training samples from an existing source, such as a thematic raster or a feature class.

    Arguments:
    in_class_data -- 
    in_seed_points -- 
    out_training_feature_class -- 
    min_sample_area -- 
    max_sample_radius -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_class_data,
            in_seed_points,
            out_training_feature_class,
            min_sample_area,
            max_sample_radius):
        result = arcpy.gp.GenerateTrainingSamplesFromSeedPoints_sa(
            in_class_data,
            in_seed_points,
            out_training_feature_class,
            min_sample_area,
            max_sample_radius)
        return result
    return Wrapper(
        in_class_data,
        in_seed_points,
        out_training_feature_class,
        min_sample_area,
        max_sample_radius)
GenerateTrainingSamplesFromSeedPoints.__esri_toolname__ = "GenerateTrainingSamplesFromSeedPoints_sa"
GenerateTrainingSamplesFromSeedPoints.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5"
]


def GreaterThan(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """GreaterThan_sa(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational greater-than operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"GreaterThan_sa",
            ["GreaterThan", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
GreaterThan.__esri_toolname__ = "GreaterThan_sa"
GreaterThan.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def GreaterThanEqual(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """GreaterThanEqual_sa(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational greater-than-or-equal-to operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"GreaterThanEqual_sa",
            ["GreaterThanEqual", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
GreaterThanEqual.__esri_toolname__ = "GreaterThanEqual_sa"
GreaterThanEqual.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def GreaterThanFrequency(
        in_value_raster,
        in_rasters,
        process_as_multiband="#"):
    """GreaterThanFrequency_sa(in_value_raster, [in_raster,...], {process_as_multiband})

    Evaluates on a cell-by-cell basis the number of times a set of rasters is greater than another raster.

    Arguments:
    in_value_raster -- 
    in_raster -- 
    process_as_multiband -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_value_raster,
            in_rasters,
            process_as_multiband):
        if Utils.useDefaultArgumentValue(process_as_multiband):
            process_as_multiband = "SINGLE_BAND"
        if process_as_multiband not in ["SINGLE_BAND", "MULTI_BAND"]:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (GreaterThanFrequency). Parameters are not valid.\nERROR 000621: Input to parameter process_as_multiband not within domain.\n")
        return _wrapLocalFunctionRaster(u"GreaterThanFrequency_sa", ["GreaterThanFrequency", in_value_raster] + Utils.flattenLists(in_rasters), {"flattenBands" : process_as_multiband.upper() == "SINGLE_BAND"})
    return Wrapper(
        in_value_raster,
        in_rasters,
        process_as_multiband)
GreaterThanFrequency.__esri_toolname__ = "GreaterThanFrequency_sa"
GreaterThanFrequency.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def HighestPosition(
        in_rasters_or_constants):
    """HighestPosition_sa([in_rasters_or_constant,...])

    Determines on a cell-by-cell basis the position of the raster with the maximum value in a set of rasters.

    Arguments:
    in_rasters_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_rasters_or_constants):
        return _wrapLocalFunctionRaster(u"HighestPosition_sa", ["HighestPosition"] + Utils.flattenLists(in_rasters_or_constants), {"flattenBands" : True})
    return Wrapper(
        in_rasters_or_constants)
HighestPosition.__esri_toolname__ = "HighestPosition_sa"
HighestPosition.__esri_toolinfo__ = [
    "::::1"
]


def Hillshade(
        in_raster,
        azimuth="#",
        altitude="#",
        model_shadows="#",
        z_factor="#"):
    """Hillshade_sa(in_raster, {azimuth}, {altitude}, {model_shadows}, {z_factor})

    Creates a shaded relief from a surface raster by considering the illumination source angle and shadows.

    Arguments:
    in_raster -- 
    azimuth -- 
    altitude -- 
    model_shadows -- 
    z_factor -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            azimuth,
            altitude,
            model_shadows,
            z_factor):
        out_raster = "#"
        result = arcpy.gp.Hillshade_sa(
            in_raster,
            out_raster,
            azimuth,
            altitude,
            model_shadows,
            z_factor)
        return _wrapToolRaster(u"Hillshade_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        azimuth,
        altitude,
        model_shadows,
        z_factor)
Hillshade.__esri_toolname__ = "Hillshade_sa"
Hillshade.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def Idw(
        in_point_features,
        z_field,
        cell_size="#",
        power="#",
        search_radius="#",
        in_barrier_polyline_features="#"):
    """Idw_sa(in_point_features, z_field, {cell_size}, {power}, {search_radius}, {in_barrier_polyline_features})

    Interpolates a raster surface from points using an inverse distance weighted (IDW) technique.

    Arguments:
    in_point_features -- 
    z_field -- 
    cell_size -- 
    power -- 
    search_radius -- 
    in_barrier_polyline_features -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_point_features,
            z_field,
            cell_size,
            power,
            search_radius,
            in_barrier_polyline_features):
        search_radius = Utils.compoundParameterToString(search_radius, ParameterClasses._Radius)
        out_raster = "#"
        result = arcpy.gp.Idw_sa(
            in_point_features,
            z_field,
            out_raster,
            cell_size,
            power,
            search_radius,
            in_barrier_polyline_features)
        return _wrapToolRaster(u"Idw_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_point_features,
        z_field,
        cell_size,
        power,
        search_radius,
        in_barrier_polyline_features)
Idw.__esri_toolname__ = "Idw_sa"
Idw.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "Python::RadiusFixed|RadiusVariable::",
    "::::7"
]


def InList(
        in_raster_or_constant,
        in_raster_or_constants,
        process_as_multiband="#"):
    """InList_sa(in_raster_or_constant, [in_raster_or_constant,...], {process_as_multiband})

    Determines which values from the first input are contained in a set of other inputs, on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant -- 
    in_raster_or_constant -- 
    process_as_multiband -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant,
            in_raster_or_constants,
            process_as_multiband):
        if Utils.useDefaultArgumentValue(process_as_multiband):
            process_as_multiband = "SINGLE_BAND"
        if process_as_multiband not in ["SINGLE_BAND", "MULTI_BAND"]:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (InList). Parameters are not valid.\nERROR 000621: Input to parameter process_as_multiband not within domain.\n")
        return _wrapLocalFunctionRaster(u"InList_sa", ["InList", in_raster_or_constant] + Utils.flattenLists(in_raster_or_constants), {"flattenBands" : process_as_multiband.upper() == "SINGLE_BAND"})
    return Wrapper(
        in_raster_or_constant,
        in_raster_or_constants,
        process_as_multiband)
InList.__esri_toolname__ = "InList_sa"
InList.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def InspectTrainingSamples(
        in_raster,
        in_training_features,
        in_classifier_definition,
        out_training_feature_class,
        in_additional_raster="#"):
    """InspectTrainingSamples_sa(in_raster, in_training_features, in_classifier_definition, out_training_feature_class, {in_additional_raster})

    Estimates the accuracy of individual training samples. The cross validation accuracy is computed using the previously generated classification training result in an .ecd file and the training samples. Outputs include a raster dataset containing the misclassified class values and a training sample dataset with the accuracy score for each training sample.

    Arguments:
    in_raster -- 
    in_training_features -- 
    in_classifier_definition -- 
    out_training_feature_class -- 
    in_additional_raster -- 

    Results:
    out_misclassified_raster -- Output Misclassified Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_training_features,
            in_classifier_definition,
            out_training_feature_class,
            in_additional_raster):
        out_misclassified_raster = "#"
        result = arcpy.gp.InspectTrainingSamples_sa(
            in_raster,
            in_training_features,
            in_classifier_definition,
            out_training_feature_class,
            out_misclassified_raster,
            in_additional_raster)
        return _wrapToolRaster(u"InspectTrainingSamples_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_training_features,
        in_classifier_definition,
        out_training_feature_class,
        in_additional_raster)
InspectTrainingSamples.__esri_toolname__ = "InspectTrainingSamples_sa"
InspectTrainingSamples.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::6"
]


def Int(
        in_raster_or_constant):
    """Int_sa(in_raster_or_constant)

    Converts each cell value of a raster to an integer by truncation.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Int_sa",
            ["Int", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Int.__esri_toolname__ = "Int_sa"
Int.__esri_toolinfo__ = [
    "::::1"
]


def InterpolateShape(
        in_surface,
        in_feature_class,
        out_feature_class,
        sample_distance="#",
        z_factor="#",
        method="#",
        vertices_only="#",
        pyramid_level_resolution="#",
        preserve_features="#"):
    """InterpolateShape_sa(in_surface, in_feature_class, out_feature_class, {sample_distance}, {z_factor}, {method}, {vertices_only}, {pyramid_level_resolution}, {preserve_features})

    Creates 3D features by interpolating z-values from a surface.

    Arguments:
    in_surface -- 
    in_feature_class -- 
    out_feature_class -- 
    sample_distance -- 
    z_factor -- 
    method -- 
    vertices_only -- 
    pyramid_level_resolution -- 
    preserve_features -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_surface,
            in_feature_class,
            out_feature_class,
            sample_distance,
            z_factor,
            method,
            vertices_only,
            pyramid_level_resolution,
            preserve_features):
        result = arcpy.gp.InterpolateShape_sa(
            in_surface,
            in_feature_class,
            out_feature_class,
            sample_distance,
            z_factor,
            method,
            vertices_only,
            pyramid_level_resolution,
            preserve_features)
        return result
    return Wrapper(
        in_surface,
        in_feature_class,
        out_feature_class,
        sample_distance,
        z_factor,
        method,
        vertices_only,
        pyramid_level_resolution,
        preserve_features)
InterpolateShape.__esri_toolname__ = "InterpolateShape_sa"
InterpolateShape.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9"
]


def IsNull(
        in_raster):
    """IsNull_sa(in_raster)

    Determines which values from the input raster are NoData on a cell-by-cell basis.

    Arguments:
    in_raster -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster):
        return _wrapLocalFunctionRaster(u"IsNull_sa",
            ["IsNull", in_raster])
    return Wrapper(
        in_raster)
IsNull.__esri_toolname__ = "IsNull_sa"
IsNull.__esri_toolinfo__ = [
    "::::1"
]


def IsoCluster(
        in_raster_bands,
        out_signature_file,
        number_classes,
        number_iterations="#",
        min_class_size="#",
        sample_interval="#"):
    """IsoCluster_sa([in_raster_band,...], out_signature_file, number_classes, {number_iterations}, {min_class_size}, {sample_interval})

    Uses an isodata clustering algorithm to determine the characteristics of the natural groupings of cells in multidimensional attribute space and stores the results in an output ASCII signature file.

    Arguments:
    in_raster_band -- 
    out_signature_file -- 
    number_classes -- 
    number_iterations -- 
    min_class_size -- 
    sample_interval -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster_bands,
            out_signature_file,
            number_classes,
            number_iterations,
            min_class_size,
            sample_interval):
        result = arcpy.gp.IsoCluster_sa(
            in_raster_bands,
            out_signature_file,
            number_classes,
            number_iterations,
            min_class_size,
            sample_interval)
        return result
    return Wrapper(
        in_raster_bands,
        out_signature_file,
        number_classes,
        number_iterations,
        min_class_size,
        sample_interval)
IsoCluster.__esri_toolname__ = "IsoCluster_sa"
IsoCluster.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def IsoClusterUnsupervisedClassification(
        in_raster_bands,
        Number_of_classes,
        Minimum_class_size="#",
        Sample_interval="#",
        out_signature_file="#"):
    """IsoClusterUnsupervisedClassification_sa([in_raster_band,...], Number_of_classes, {Minimum_class_size}, {Sample_interval}, {out_signature_file})

    Performs unsupervised classification on a series of input raster bands using the Iso Cluster and Maximum Likelihood Classification tools.

    Arguments:
    in_raster_band -- 
    Number_of_classes -- 
    Minimum_class_size -- 
    Sample_interval -- 
    out_signature_file -- 

    Results:
    Output_classified_raster -- Output classified raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_bands,
            Number_of_classes,
            Minimum_class_size,
            Sample_interval,
            out_signature_file):
        Output_classified_raster = "#"
        result = arcpy.gp.IsoClusterUnsupervisedClassification_sa(
            in_raster_bands,
            Number_of_classes,
            Output_classified_raster,
            Minimum_class_size,
            Sample_interval,
            out_signature_file)
        return _wrapToolRaster(u"IsoClusterUnsupervisedClassification_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster_bands,
        Number_of_classes,
        Minimum_class_size,
        Sample_interval,
        out_signature_file)
IsoClusterUnsupervisedClassification.__esri_toolname__ = "IsoClusterUnsupervisedClassification_sa"
IsoClusterUnsupervisedClassification.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6"
]


def KernelDensity(
        in_features,
        population_field,
        cell_size="#",
        search_radius="#",
        area_unit_scale_factor="#",
        out_cell_values="#",
        method="#",
        in_barriers="#"):
    """KernelDensity_sa(in_features, population_field, {cell_size}, {search_radius}, {area_unit_scale_factor}, {out_cell_values}, {method}, {in_barriers})

    Calculates a magnitude-per-unit area from point or polyline features using a kernel function to fit a smoothly tapered surface to each point or polyline. A barrier can be used to alter the influence of a feature while calculating kernel density.

    Arguments:
    in_features -- 
    population_field -- 
    cell_size -- 
    search_radius -- 
    area_unit_scale_factor -- 
    out_cell_values -- 
    method -- 
    in_barriers -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_features,
            population_field,
            cell_size,
            search_radius,
            area_unit_scale_factor,
            out_cell_values,
            method,
            in_barriers):
        out_raster = "#"
        result = arcpy.gp.KernelDensity_sa(
            in_features,
            population_field,
            out_raster,
            cell_size,
            search_radius,
            area_unit_scale_factor,
            out_cell_values,
            method,
            in_barriers)
        return _wrapToolRaster(u"KernelDensity_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_features,
        population_field,
        cell_size,
        search_radius,
        area_unit_scale_factor,
        out_cell_values,
        method,
        in_barriers)
KernelDensity.__esri_toolname__ = "KernelDensity_sa"
KernelDensity.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9"
]


def Kriging(
        in_point_features,
        z_field,
        kriging_model,
        cell_size="#",
        search_radius="#",
        out_variance_prediction_raster="#"):
    """Kriging_sa(in_point_features, z_field, kriging_model, {cell_size}, {search_radius}, {out_variance_prediction_raster})

    Interpolates a raster surface from points using kriging.

    Arguments:
    in_point_features -- 
    z_field -- 
    kriging_model -- 
    cell_size -- 
    search_radius -- 
    out_variance_prediction_raster -- 

    Results:
    out_surface_raster -- Output surface raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_point_features,
            z_field,
            kriging_model,
            cell_size,
            search_radius,
            out_variance_prediction_raster):
        kriging_model = Utils.compoundParameterToString(kriging_model, ParameterClasses._KrigingModel)
        search_radius = Utils.compoundParameterToString(search_radius, ParameterClasses._Radius)
        out_surface_raster = "#"
        result = arcpy.gp.Kriging_sa(
            in_point_features,
            z_field,
            out_surface_raster,
            kriging_model,
            cell_size,
            search_radius,
            out_variance_prediction_raster)
        return _wrapToolRaster(u"Kriging_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_point_features,
        z_field,
        kriging_model,
        cell_size,
        search_radius,
        out_variance_prediction_raster)
Kriging.__esri_toolname__ = "Kriging_sa"
Kriging.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "Python::KrigingModelOrdinary|KrigingModelUniversal::",
    "::::5",
    "Python::RadiusFixed|RadiusVariable::",
    "::::7"
]


def LessThan(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """LessThan_sa(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational less-than operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"LessThan_sa",
            ["LessThan", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
LessThan.__esri_toolname__ = "LessThan_sa"
LessThan.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def LessThanEqual(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """LessThanEqual_sa(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational less-than-or-equal-to operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"LessThanEqual_sa",
            ["LessThanEqual", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
LessThanEqual.__esri_toolname__ = "LessThanEqual_sa"
LessThanEqual.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def LessThanFrequency(
        in_value_raster,
        in_rasters,
        process_as_multiband="#"):
    """LessThanFrequency_sa(in_value_raster, [in_raster,...], {process_as_multiband})

    Evaluates on a cell-by-cell basis the number of times a set of rasters is less than another raster.

    Arguments:
    in_value_raster -- 
    in_raster -- 
    process_as_multiband -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_value_raster,
            in_rasters,
            process_as_multiband):
        if Utils.useDefaultArgumentValue(process_as_multiband):
            process_as_multiband = "SINGLE_BAND"
        if process_as_multiband not in ["SINGLE_BAND", "MULTI_BAND"]:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (LessThanFrequency). Parameters are not valid.\nERROR 000621: Input to parameter process_as_multiband not within domain.\n")
        return _wrapLocalFunctionRaster(u"LessThanFrequency_sa", ["LessThanFrequency", in_value_raster] + Utils.flattenLists(in_rasters), {"flattenBands" : process_as_multiband.upper() == "SINGLE_BAND"})
    return Wrapper(
        in_value_raster,
        in_rasters,
        process_as_multiband)
LessThanFrequency.__esri_toolname__ = "LessThanFrequency_sa"
LessThanFrequency.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def LinearSpectralUnmixing(
        in_raster,
        in_spectral_profile_file,
        value_option="#"):
    """LinearSpectralUnmixing_sa(in_raster, in_spectral_profile_file, {[value_option,...]})

    Performs subpixel classification and calculates the fractional abundance of different land cover types for individual pixels.

    Arguments:
    in_raster -- 
    in_spectral_profile_file -- 
    value_option -- 

    Results:
    out_raster -- Output Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_spectral_profile_file,
            value_option):
        out_raster = "#"
        result = arcpy.gp.LinearSpectralUnmixing_sa(
            in_raster,
            out_raster,
            in_spectral_profile_file,
            value_option)
        return _wrapToolRaster(u"LinearSpectralUnmixing_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_spectral_profile_file,
        value_option)
LinearSpectralUnmixing.__esri_toolname__ = "LinearSpectralUnmixing_sa"
LinearSpectralUnmixing.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4"
]


def LineDensity(
        in_polyline_features,
        population_field,
        cell_size="#",
        search_radius="#",
        area_unit_scale_factor="#"):
    """LineDensity_sa(in_polyline_features, population_field, {cell_size}, {search_radius}, {area_unit_scale_factor})

    Calculates a magnitude-per-unit area from polyline features that fall within a radius around each cell.

    Arguments:
    in_polyline_features -- 
    population_field -- 
    cell_size -- 
    search_radius -- 
    area_unit_scale_factor -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_polyline_features,
            population_field,
            cell_size,
            search_radius,
            area_unit_scale_factor):
        out_raster = "#"
        result = arcpy.gp.LineDensity_sa(
            in_polyline_features,
            population_field,
            out_raster,
            cell_size,
            search_radius,
            area_unit_scale_factor)
        return _wrapToolRaster(u"LineDensity_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_polyline_features,
        population_field,
        cell_size,
        search_radius,
        area_unit_scale_factor)
LineDensity.__esri_toolname__ = "LineDensity_sa"
LineDensity.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6"
]


def LineStatistics(
        in_polyline_features,
        field,
        cell_size="#",
        search_radius="#",
        statistics_type="#"):
    """LineStatistics_sa(in_polyline_features, field, {cell_size}, {search_radius}, {statistics_type})

    Calculates a statistic on the attributes of lines in a circular neighborhood around each output cell.

    Arguments:
    in_polyline_features -- 
    field -- 
    cell_size -- 
    search_radius -- 
    statistics_type -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_polyline_features,
            field,
            cell_size,
            search_radius,
            statistics_type):
        out_raster = "#"
        result = arcpy.gp.LineStatistics_sa(
            in_polyline_features,
            field,
            out_raster,
            cell_size,
            search_radius,
            statistics_type)
        return _wrapToolRaster(u"LineStatistics_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_polyline_features,
        field,
        cell_size,
        search_radius,
        statistics_type)
LineStatistics.__esri_toolname__ = "LineStatistics_sa"
LineStatistics.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6"
]


def Ln(
        in_raster_or_constant):
    """Ln_sa(in_raster_or_constant)

    Calculates the natural logarithm (base e) of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Ln_sa",
            ["Ln", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Ln.__esri_toolname__ = "Ln_sa"
Ln.__esri_toolinfo__ = [
    "::::1"
]


def LocateRegions(
        in_raster,
        total_area="#",
        area_units="#",
        number_of_regions="#",
        region_shape="#",
        region_orientation="#",
        shape_tradeoff="#",
        evaluation_method="#",
        minimum_area="#",
        maximum_area="#",
        minimum_distance="#",
        maximum_distance="#",
        distance_units="#",
        in_existing_regions="#",
        number_of_neighbors="#",
        no_islands="#",
        region_seeds="#",
        region_resolution="#",
        selection_method="#"):
    """LocateRegions_sa(in_raster, {total_area}, {area_units}, {number_of_regions}, {region_shape}, {region_orientation}, {shape_tradeoff}, {evaluation_method}, {minimum_area}, {maximum_area}, {minimum_distance}, {maximum_distance}, {distance_units}, {in_existing_regions}, {number_of_neighbors}, {no_islands}, {region_seeds}, {region_resolution}, {selection_method})

    Identifies the best regions, or groups of contiguous cells, from an input utility (suitability) raster that satisfy a specified evaluation criterion and that meet identified shape, size, number, and interregion distance constraints.

    Arguments:
    in_raster -- 
    total_area -- 
    area_units -- 
    number_of_regions -- 
    region_shape -- 
    region_orientation -- 
    shape_tradeoff -- 
    evaluation_method -- 
    minimum_area -- 
    maximum_area -- 
    minimum_distance -- 
    maximum_distance -- 
    distance_units -- 
    in_existing_regions -- 
    number_of_neighbors -- 
    no_islands -- 
    region_seeds -- 
    region_resolution -- 
    selection_method -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            total_area,
            area_units,
            number_of_regions,
            region_shape,
            region_orientation,
            shape_tradeoff,
            evaluation_method,
            minimum_area,
            maximum_area,
            minimum_distance,
            maximum_distance,
            distance_units,
            in_existing_regions,
            number_of_neighbors,
            no_islands,
            region_seeds,
            region_resolution,
            selection_method):
        out_raster = "#"
        result = arcpy.gp.LocateRegions_sa(
            in_raster,
            out_raster,
            total_area,
            area_units,
            number_of_regions,
            region_shape,
            region_orientation,
            shape_tradeoff,
            evaluation_method,
            minimum_area,
            maximum_area,
            minimum_distance,
            maximum_distance,
            distance_units,
            in_existing_regions,
            number_of_neighbors,
            no_islands,
            region_seeds,
            region_resolution,
            selection_method)
        return _wrapToolRaster(u"LocateRegions_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        total_area,
        area_units,
        number_of_regions,
        region_shape,
        region_orientation,
        shape_tradeoff,
        evaluation_method,
        minimum_area,
        maximum_area,
        minimum_distance,
        maximum_distance,
        distance_units,
        in_existing_regions,
        number_of_neighbors,
        no_islands,
        region_seeds,
        region_resolution,
        selection_method)
LocateRegions.__esri_toolname__ = "LocateRegions_sa"
LocateRegions.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14",
    "::::15",
    "::::16",
    "::::17",
    "::::18",
    "::::19",
    "::::20"
]


def Log10(
        in_raster_or_constant):
    """Log10_sa(in_raster_or_constant)

    Calculates the base 10 logarithm of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Log10_sa",
            ["Log10", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Log10.__esri_toolname__ = "Log10_sa"
Log10.__esri_toolinfo__ = [
    "::::1"
]


def Log2(
        in_raster_or_constant):
    """Log2_sa(in_raster_or_constant)

    Calculates the base 2 logarithm of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Log2_sa",
            ["Log2", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Log2.__esri_toolname__ = "Log2_sa"
Log2.__esri_toolinfo__ = [
    "::::1"
]


def Lookup(
        in_raster,
        lookup_field):
    """Lookup_sa(in_raster, lookup_field)

    Creates a raster by looking up values in another field in the table of the input raster.

    Arguments:
    in_raster -- 
    lookup_field -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            lookup_field):
        out_raster = "#"
        result = arcpy.gp.Lookup_sa(
            in_raster,
            lookup_field,
            out_raster)
        return _wrapToolRaster(u"Lookup_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        lookup_field)
Lookup.__esri_toolname__ = "Lookup_sa"
Lookup.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def LowestPosition(
        in_rasters_or_constants):
    """LowestPosition_sa([in_rasters_or_constant,...])

    Determines on a cell-by-cell basis the position of the raster with the minimum value in a set of rasters.

    Arguments:
    in_rasters_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_rasters_or_constants):
        return _wrapLocalFunctionRaster(u"LowestPosition_sa", ["LowestPosition"] + Utils.flattenLists(in_rasters_or_constants), {"flattenBands" : True})
    return Wrapper(
        in_rasters_or_constants)
LowestPosition.__esri_toolname__ = "LowestPosition_sa"
LowestPosition.__esri_toolinfo__ = [
    "::::1"
]


def MajorityFilter(
        in_raster,
        number_neighbors="#",
        majority_definition="#"):
    """MajorityFilter_sa(in_raster, {number_neighbors}, {majority_definition})

    Replaces cells in a raster based on the majority of their contiguous neighboring cells.

    Arguments:
    in_raster -- 
    number_neighbors -- 
    majority_definition -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            number_neighbors,
            majority_definition):
        out_raster = "#"
        result = arcpy.gp.MajorityFilter_sa(
            in_raster,
            out_raster,
            number_neighbors,
            majority_definition)
        return _wrapToolRaster(u"MajorityFilter_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        number_neighbors,
        majority_definition)
MajorityFilter.__esri_toolname__ = "MajorityFilter_sa"
MajorityFilter.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4"
]


def Minus(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Minus_sa(in_raster_or_constant1, in_raster_or_constant2)

    Subtracts the value of the second input raster from the value of the first input raster on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Minus_sa",
            ["Minus", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Minus.__esri_toolname__ = "Minus_sa"
Minus.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def MLClassify(
        in_raster_bands,
        in_signature_file,
        reject_fraction="#",
        a_priori_probabilities="#",
        in_a_priori_file="#",
        out_confidence_raster="#"):
    """MLClassify_sa([in_raster_band,...], in_signature_file, {reject_fraction}, {a_priori_probabilities}, {in_a_priori_file}, {out_confidence_raster})

    Performs a maximum likelihood classification on a set of raster bands and creates a classified raster as output.

    Arguments:
    in_raster_band -- 
    in_signature_file -- 
    reject_fraction -- 
    a_priori_probabilities -- 
    in_a_priori_file -- 
    out_confidence_raster -- 

    Results:
    out_classified_raster -- Output classified raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_bands,
            in_signature_file,
            reject_fraction,
            a_priori_probabilities,
            in_a_priori_file,
            out_confidence_raster):
        out_classified_raster = "#"
        result = arcpy.gp.MLClassify_sa(
            in_raster_bands,
            in_signature_file,
            out_classified_raster,
            reject_fraction,
            a_priori_probabilities,
            in_a_priori_file,
            out_confidence_raster)
        return _wrapToolRaster(u"MLClassify_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster_bands,
        in_signature_file,
        reject_fraction,
        a_priori_probabilities,
        in_a_priori_file,
        out_confidence_raster)
MLClassify.__esri_toolname__ = "MLClassify_sa"
MLClassify.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def Mod(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Mod_sa(in_raster_or_constant1, in_raster_or_constant2)

    Finds the remainder (modulo) of the first raster when divided by the second raster on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Mod_sa",
            ["Mod", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Mod.__esri_toolname__ = "Mod_sa"
Mod.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def NaturalNeighbor(
        in_point_features,
        z_field,
        cell_size="#"):
    """NaturalNeighbor_sa(in_point_features, z_field, {cell_size})

    Interpolates a raster surface from points using a natural neighbor technique.

    Arguments:
    in_point_features -- 
    z_field -- 
    cell_size -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_point_features,
            z_field,
            cell_size):
        out_raster = "#"
        result = arcpy.gp.NaturalNeighbor_sa(
            in_point_features,
            z_field,
            out_raster,
            cell_size)
        return _wrapToolRaster(u"NaturalNeighbor_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_point_features,
        z_field,
        cell_size)
NaturalNeighbor.__esri_toolname__ = "NaturalNeighbor_sa"
NaturalNeighbor.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def Negate(
        in_raster_or_constant):
    """Negate_sa(in_raster_or_constant)

    Changes the sign (multiplies by -1) of the cell values of the input raster on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Negate_sa",
            ["Negate", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Negate.__esri_toolname__ = "Negate_sa"
Negate.__esri_toolinfo__ = [
    "::::1"
]


def Nibble(
        in_raster,
        in_mask_raster,
        nibble_values="#",
        nibble_nodata="#",
        in_zone_raster="#"):
    """Nibble_sa(in_raster, in_mask_raster, {nibble_values}, {nibble_nodata}, {in_zone_raster})

    Replaces cells of a raster corresponding to a mask with the values of the nearest neighbors.

    Arguments:
    in_raster -- 
    in_mask_raster -- 
    nibble_values -- 
    nibble_nodata -- 
    in_zone_raster -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_mask_raster,
            nibble_values,
            nibble_nodata,
            in_zone_raster):
        out_raster = "#"
        result = arcpy.gp.Nibble_sa(
            in_raster,
            in_mask_raster,
            out_raster,
            nibble_values,
            nibble_nodata,
            in_zone_raster)
        return _wrapToolRaster(u"Nibble_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_mask_raster,
        nibble_values,
        nibble_nodata,
        in_zone_raster)
Nibble.__esri_toolname__ = "Nibble_sa"
Nibble.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6"
]


def NotEqual(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """NotEqual_sa(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational not-equal-to operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"NotEqual_sa",
            ["NotEqual", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
NotEqual.__esri_toolname__ = "NotEqual_sa"
NotEqual.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def ObserverPoints(
        in_raster,
        in_observer_point_features,
        z_factor="#",
        curvature_correction="#",
        refractivity_coefficient="#",
        out_agl_raster="#"):
    """ObserverPoints_sa(in_raster, in_observer_point_features, {z_factor}, {curvature_correction}, {refractivity_coefficient}, {out_agl_raster})

    Identifies which observer points are visible from each raster surface location.

    Arguments:
    in_raster -- 
    in_observer_point_features -- 
    z_factor -- 
    curvature_correction -- 
    refractivity_coefficient -- 
    out_agl_raster -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_observer_point_features,
            z_factor,
            curvature_correction,
            refractivity_coefficient,
            out_agl_raster):
        out_raster = "#"
        result = arcpy.gp.ObserverPoints_sa(
            in_raster,
            in_observer_point_features,
            out_raster,
            z_factor,
            curvature_correction,
            refractivity_coefficient,
            out_agl_raster)
        return _wrapToolRaster(u"ObserverPoints_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_observer_point_features,
        z_factor,
        curvature_correction,
        refractivity_coefficient,
        out_agl_raster)
ObserverPoints.__esri_toolname__ = "ObserverPoints_sa"
ObserverPoints.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def OptimalPathAsLine(
        in_destination_data,
        in_distance_accumulation_raster,
        in_back_direction_raster,
        out_polyline_features,
        destination_field="#",
        path_type="#",
        create_network_paths="#"):
    """OptimalPathAsLine_sa(in_destination_data, in_distance_accumulation_raster, in_back_direction_raster, out_polyline_features, {destination_field}, {path_type}, {create_network_paths})

    Calculates the optimal path from a source to a destination as a line.

    Arguments:
    in_destination_data -- 
    in_distance_accumulation_raster -- 
    in_back_direction_raster -- 
    out_polyline_features -- 
    destination_field -- 
    path_type -- 
    create_network_paths -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_destination_data,
            in_distance_accumulation_raster,
            in_back_direction_raster,
            out_polyline_features,
            destination_field,
            path_type,
            create_network_paths):
        result = arcpy.gp.OptimalPathAsLine_sa(
            in_destination_data,
            in_distance_accumulation_raster,
            in_back_direction_raster,
            out_polyline_features,
            destination_field,
            path_type,
            create_network_paths)
        return result
    return Wrapper(
        in_destination_data,
        in_distance_accumulation_raster,
        in_back_direction_raster,
        out_polyline_features,
        destination_field,
        path_type,
        create_network_paths)
OptimalPathAsLine.__esri_toolname__ = "OptimalPathAsLine_sa"
OptimalPathAsLine.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def OptimalPathAsRaster(
        in_destination_data,
        in_distance_accumulation_raster,
        in_back_direction_raster,
        destination_field="#",
        path_type="#"):
    """OptimalPathAsRaster_sa(in_destination_data, in_distance_accumulation_raster, in_back_direction_raster, {destination_field}, {path_type})

    Calculates the optimal path from a source to a destination as a raster.

    Arguments:
    in_destination_data -- 
    in_distance_accumulation_raster -- 
    in_back_direction_raster -- 
    destination_field -- 
    path_type -- 

    Results:
    out_path_accumulation_raster -- Output optimal accumulation path"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_destination_data,
            in_distance_accumulation_raster,
            in_back_direction_raster,
            destination_field,
            path_type):
        out_path_accumulation_raster = "#"
        result = arcpy.gp.OptimalPathAsRaster_sa(
            in_destination_data,
            in_distance_accumulation_raster,
            in_back_direction_raster,
            out_path_accumulation_raster,
            destination_field,
            path_type)
        return _wrapToolRaster(u"OptimalPathAsRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_destination_data,
        in_distance_accumulation_raster,
        in_back_direction_raster,
        destination_field,
        path_type)
OptimalPathAsRaster.__esri_toolname__ = "OptimalPathAsRaster_sa"
OptimalPathAsRaster.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::5",
    "::::6"
]


def OptimalRegionConnections(
        in_regions,
        out_feature_class,
        in_barrier_data="#",
        in_cost_raster="#",
        out_neighbor_paths="#",
        distance_method="#",
        connections_within_regions="#"):
    """OptimalRegionConnections_sa(in_regions, out_feature_class, {in_barrier_data}, {in_cost_raster}, {out_neighbor_paths}, {distance_method}, {connections_within_regions})

    Calculates the optimal connectivity network between two or more input regions.

    Arguments:
    in_regions -- 
    out_feature_class -- 
    in_barrier_data -- 
    in_cost_raster -- 
    out_neighbor_paths -- 
    distance_method -- 
    connections_within_regions -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_regions,
            out_feature_class,
            in_barrier_data,
            in_cost_raster,
            out_neighbor_paths,
            distance_method,
            connections_within_regions):
        result = arcpy.gp.OptimalRegionConnections_sa(
            in_regions,
            out_feature_class,
            in_barrier_data,
            in_cost_raster,
            out_neighbor_paths,
            distance_method,
            connections_within_regions)
        return result
    return Wrapper(
        in_regions,
        out_feature_class,
        in_barrier_data,
        in_cost_raster,
        out_neighbor_paths,
        distance_method,
        connections_within_regions)
OptimalRegionConnections.__esri_toolname__ = "OptimalRegionConnections_sa"
OptimalRegionConnections.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def Over(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Over_sa(in_raster_or_constant1, in_raster_or_constant2)

    For the cell values in the first input that are not 0, the output value will be that of the first input. Where the cell values are 0, the output will be that of the second input raster.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Over_sa",
            ["Over", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Over.__esri_toolname__ = "Over_sa"
Over.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def ParticleTrack(
        in_direction_raster,
        in_magnitude_raster,
        source_point,
        out_track_file,
        step_length="#",
        tracking_time="#",
        out_track_polyline_features="#"):
    """ParticleTrack_sa(in_direction_raster, in_magnitude_raster, source_point, out_track_file, {step_length}, {tracking_time}, {out_track_polyline_features})

    Calculates the path of a particle through a velocity field, returning an ASCII file of particle tracking data and, optionally, a feature class of track information.

    Arguments:
    in_direction_raster -- 
    in_magnitude_raster -- 
    source_point -- 
    out_track_file -- 
    step_length -- 
    tracking_time -- 
    out_track_polyline_features -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_direction_raster,
            in_magnitude_raster,
            source_point,
            out_track_file,
            step_length,
            tracking_time,
            out_track_polyline_features):
        source_point = Utils.compoundParameterToString(source_point, arcpy.Point)
        result = arcpy.gp.ParticleTrack_sa(
            in_direction_raster,
            in_magnitude_raster,
            source_point,
            out_track_file,
            step_length,
            tracking_time,
            out_track_polyline_features)
        return result
    return Wrapper(
        in_direction_raster,
        in_magnitude_raster,
        source_point,
        out_track_file,
        step_length,
        tracking_time,
        out_track_polyline_features)
ParticleTrack.__esri_toolname__ = "ParticleTrack_sa"
ParticleTrack.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "Python::Point::",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def PathAllocation(
        in_source_data,
        in_cost_raster="#",
        in_surface_raster="#",
        in_horizontal_raster="#",
        horizontal_factor="#",
        in_vertical_raster="#",
        vertical_factor="#",
        maximum_distance="#",
        in_value_raster="#",
        source_field="#",
        out_distance_raster="#",
        out_backlink_raster="#",
        source_cost_multiplier="#",
        source_start_cost="#",
        source_resistance_rate="#",
        source_capacity="#",
        source_direction="#"):
    """PathAllocation_sa(in_source_data, {in_cost_raster}, {in_surface_raster}, {in_horizontal_raster}, {horizontal_factor}, {in_vertical_raster}, {vertical_factor}, {maximum_distance}, {in_value_raster}, {source_field}, {out_distance_raster}, {out_backlink_raster}, {source_cost_multiplier}, {source_start_cost}, {source_resistance_rate}, {source_capacity}, {source_direction})

    Calculates the least-cost source for each cell based on the least accumulative cost over a cost surface, while accounting for surface distance along with horizontal and vertical cost factors.

    Arguments:
    in_source_data -- 
    in_cost_raster -- 
    in_surface_raster -- 
    in_horizontal_raster -- 
    horizontal_factor -- 
    in_vertical_raster -- 
    vertical_factor -- 
    maximum_distance -- 
    in_value_raster -- 
    source_field -- 
    out_distance_raster -- 
    out_backlink_raster -- 
    source_cost_multiplier -- 
    source_start_cost -- 
    source_resistance_rate -- 
    source_capacity -- 
    source_direction -- 

    Results:
    out_allocation_raster -- Output allocation raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_source_data,
            in_cost_raster,
            in_surface_raster,
            in_horizontal_raster,
            horizontal_factor,
            in_vertical_raster,
            vertical_factor,
            maximum_distance,
            in_value_raster,
            source_field,
            out_distance_raster,
            out_backlink_raster,
            source_cost_multiplier,
            source_start_cost,
            source_resistance_rate,
            source_capacity,
            source_direction):
        horizontal_factor = Utils.compoundParameterToString(horizontal_factor, ParameterClasses._HorizontalFactor)
        vertical_factor = Utils.compoundParameterToString(vertical_factor, ParameterClasses._VerticalFactor)
        out_allocation_raster = "#"
        result = arcpy.gp.PathAllocation_sa(
            in_source_data,
            out_allocation_raster,
            in_cost_raster,
            in_surface_raster,
            in_horizontal_raster,
            horizontal_factor,
            in_vertical_raster,
            vertical_factor,
            maximum_distance,
            in_value_raster,
            source_field,
            out_distance_raster,
            out_backlink_raster,
            source_cost_multiplier,
            source_start_cost,
            source_resistance_rate,
            source_capacity,
            source_direction)
        return _wrapToolRaster(u"PathAllocation_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_source_data,
        in_cost_raster,
        in_surface_raster,
        in_horizontal_raster,
        horizontal_factor,
        in_vertical_raster,
        vertical_factor,
        maximum_distance,
        in_value_raster,
        source_field,
        out_distance_raster,
        out_backlink_raster,
        source_cost_multiplier,
        source_start_cost,
        source_resistance_rate,
        source_capacity,
        source_direction)
PathAllocation.__esri_toolname__ = "PathAllocation_sa"
PathAllocation.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "Python::HfBinary|HfForward|HfInverseLinear|HfLinear|HfTable::",
    "::::7",
    "Python::VfBinary|VfCos|VfCosSec|VfInverseLinear|VfLinear|VfSec|VfSecCos|VfSymInverseLinear|VfSymLinear|VfTable::",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14",
    "::::15",
    "::::16",
    "::::17",
    "::::18"
]


def PathBackLink(
        in_source_data,
        in_cost_raster="#",
        in_surface_raster="#",
        in_horizontal_raster="#",
        horizontal_factor="#",
        in_vertical_raster="#",
        vertical_factor="#",
        maximum_distance="#",
        out_distance_raster="#",
        source_cost_multiplier="#",
        source_start_cost="#",
        source_resistance_rate="#",
        source_capacity="#",
        source_direction="#"):
    """PathBackLink_sa(in_source_data, {in_cost_raster}, {in_surface_raster}, {in_horizontal_raster}, {horizontal_factor}, {in_vertical_raster}, {vertical_factor}, {maximum_distance}, {out_distance_raster}, {source_cost_multiplier}, {source_start_cost}, {source_resistance_rate}, {source_capacity}, {source_direction})

    Defines the neighbor that is the next cell on the least accumulative cost path to the least-cost source, while accounting for surface distance along with horizontal and vertical cost factors.

    Arguments:
    in_source_data -- 
    in_cost_raster -- 
    in_surface_raster -- 
    in_horizontal_raster -- 
    horizontal_factor -- 
    in_vertical_raster -- 
    vertical_factor -- 
    maximum_distance -- 
    out_distance_raster -- 
    source_cost_multiplier -- 
    source_start_cost -- 
    source_resistance_rate -- 
    source_capacity -- 
    source_direction -- 

    Results:
    out_backlink_raster -- Output backlink raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_source_data,
            in_cost_raster,
            in_surface_raster,
            in_horizontal_raster,
            horizontal_factor,
            in_vertical_raster,
            vertical_factor,
            maximum_distance,
            out_distance_raster,
            source_cost_multiplier,
            source_start_cost,
            source_resistance_rate,
            source_capacity,
            source_direction):
        horizontal_factor = Utils.compoundParameterToString(horizontal_factor, ParameterClasses._HorizontalFactor)
        vertical_factor = Utils.compoundParameterToString(vertical_factor, ParameterClasses._VerticalFactor)
        out_backlink_raster = "#"
        result = arcpy.gp.PathBackLink_sa(
            in_source_data,
            out_backlink_raster,
            in_cost_raster,
            in_surface_raster,
            in_horizontal_raster,
            horizontal_factor,
            in_vertical_raster,
            vertical_factor,
            maximum_distance,
            out_distance_raster,
            source_cost_multiplier,
            source_start_cost,
            source_resistance_rate,
            source_capacity,
            source_direction)
        return _wrapToolRaster(u"PathBackLink_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_source_data,
        in_cost_raster,
        in_surface_raster,
        in_horizontal_raster,
        horizontal_factor,
        in_vertical_raster,
        vertical_factor,
        maximum_distance,
        out_distance_raster,
        source_cost_multiplier,
        source_start_cost,
        source_resistance_rate,
        source_capacity,
        source_direction)
PathBackLink.__esri_toolname__ = "PathBackLink_sa"
PathBackLink.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "Python::HfBinary|HfForward|HfInverseLinear|HfLinear|HfTable::",
    "::::7",
    "Python::VfBinary|VfCos|VfCosSec|VfInverseLinear|VfLinear|VfSec|VfSecCos|VfSymInverseLinear|VfSymLinear|VfTable::",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14",
    "::::15"
]


def PathDistance(
        in_source_data,
        in_cost_raster="#",
        in_surface_raster="#",
        in_horizontal_raster="#",
        horizontal_factor="#",
        in_vertical_raster="#",
        vertical_factor="#",
        maximum_distance="#",
        out_backlink_raster="#",
        source_cost_multiplier="#",
        source_start_cost="#",
        source_resistance_rate="#",
        source_capacity="#",
        source_direction="#"):
    """PathDistance_sa(in_source_data, {in_cost_raster}, {in_surface_raster}, {in_horizontal_raster}, {horizontal_factor}, {in_vertical_raster}, {vertical_factor}, {maximum_distance}, {out_backlink_raster}, {source_cost_multiplier}, {source_start_cost}, {source_resistance_rate}, {source_capacity}, {source_direction})

    Calculates, for each cell, the least accumulative cost distance from or to the least-cost source, while accounting for surface distance along with horizontal and vertical cost factors.

    Arguments:
    in_source_data -- 
    in_cost_raster -- 
    in_surface_raster -- 
    in_horizontal_raster -- 
    horizontal_factor -- 
    in_vertical_raster -- 
    vertical_factor -- 
    maximum_distance -- 
    out_backlink_raster -- 
    source_cost_multiplier -- 
    source_start_cost -- 
    source_resistance_rate -- 
    source_capacity -- 
    source_direction -- 

    Results:
    out_distance_raster -- Output distance raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_source_data,
            in_cost_raster,
            in_surface_raster,
            in_horizontal_raster,
            horizontal_factor,
            in_vertical_raster,
            vertical_factor,
            maximum_distance,
            out_backlink_raster,
            source_cost_multiplier,
            source_start_cost,
            source_resistance_rate,
            source_capacity,
            source_direction):
        horizontal_factor = Utils.compoundParameterToString(horizontal_factor, ParameterClasses._HorizontalFactor)
        vertical_factor = Utils.compoundParameterToString(vertical_factor, ParameterClasses._VerticalFactor)
        out_distance_raster = "#"
        result = arcpy.gp.PathDistance_sa(
            in_source_data,
            out_distance_raster,
            in_cost_raster,
            in_surface_raster,
            in_horizontal_raster,
            horizontal_factor,
            in_vertical_raster,
            vertical_factor,
            maximum_distance,
            out_backlink_raster,
            source_cost_multiplier,
            source_start_cost,
            source_resistance_rate,
            source_capacity,
            source_direction)
        return _wrapToolRaster(u"PathDistance_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_source_data,
        in_cost_raster,
        in_surface_raster,
        in_horizontal_raster,
        horizontal_factor,
        in_vertical_raster,
        vertical_factor,
        maximum_distance,
        out_backlink_raster,
        source_cost_multiplier,
        source_start_cost,
        source_resistance_rate,
        source_capacity,
        source_direction)
PathDistance.__esri_toolname__ = "PathDistance_sa"
PathDistance.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "Python::HfBinary|HfForward|HfInverseLinear|HfLinear|HfTable::",
    "::::7",
    "Python::VfBinary|VfCos|VfCosSec|VfInverseLinear|VfLinear|VfSec|VfSecCos|VfSymInverseLinear|VfSymLinear|VfTable::",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14",
    "::::15"
]


def Pick(
        in_position_raster,
        in_rasters_or_constants,
        process_as_multiband="#"):
    """Pick_sa(in_position_raster, [in_rasters_or_constant,...], {process_as_multiband})

    The value from a position raster is used to determine from which raster in a list of input rasters the output cell value will be obtained.

    Arguments:
    in_position_raster -- 
    in_rasters_or_constant -- 
    process_as_multiband -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_position_raster,
            in_rasters_or_constants,
            process_as_multiband):
        if Utils.useDefaultArgumentValue(process_as_multiband):
            process_as_multiband = "SINGLE_BAND"
        if process_as_multiband not in ["SINGLE_BAND", "MULTI_BAND"]:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (Pick). Parameters are not valid.\nERROR 000621: Input to parameter process_as_multiband not within domain.\n")
        return _wrapLocalFunctionRaster(u"Pick_sa", ["Pick", in_position_raster] + Utils.flattenLists(in_rasters_or_constants), {"flattenBands" : process_as_multiband.upper() == "SINGLE_BAND"})
    return Wrapper(
        in_position_raster,
        in_rasters_or_constants,
        process_as_multiband)
Pick.__esri_toolname__ = "Pick_sa"
Pick.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def Plus(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Plus_sa(in_raster_or_constant1, in_raster_or_constant2)

    Adds (sums) the values of two rasters on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Plus_sa",
            ["Plus", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Plus.__esri_toolname__ = "Plus_sa"
Plus.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def PointDensity(
        in_point_features,
        population_field,
        cell_size="#",
        neighborhood="#",
        area_unit_scale_factor="#"):
    """PointDensity_sa(in_point_features, population_field, {cell_size}, {neighborhood}, {area_unit_scale_factor})

    Calculates a magnitude-per-unit area from point features that fall within a neighborhood around each cell.

    Arguments:
    in_point_features -- 
    population_field -- 
    cell_size -- 
    neighborhood -- 
    area_unit_scale_factor -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_point_features,
            population_field,
            cell_size,
            neighborhood,
            area_unit_scale_factor):
        neighborhood = Utils.compoundParameterToString(neighborhood, ParameterClasses._Neighborhood)
        out_raster = "#"
        result = arcpy.gp.PointDensity_sa(
            in_point_features,
            population_field,
            out_raster,
            cell_size,
            neighborhood,
            area_unit_scale_factor)
        return _wrapToolRaster(u"PointDensity_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_point_features,
        population_field,
        cell_size,
        neighborhood,
        area_unit_scale_factor)
PointDensity.__esri_toolname__ = "PointDensity_sa"
PointDensity.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "Python::NbrAnnulus|NbrCircle|NbrRectangle|NbrWedge::",
    "::::6"
]


def PointsSolarRadiation(
        in_surface_raster,
        in_points_feature_or_table,
        out_global_radiation_features,
        height_offset="#",
        latitude="#",
        sky_size="#",
        time_configuration="#",
        day_interval="#",
        hour_interval="#",
        each_interval="#",
        z_factor="#",
        slope_aspect_input_type="#",
        calculation_directions="#",
        zenith_divisions="#",
        azimuth_divisions="#",
        diffuse_model_type="#",
        diffuse_proportion="#",
        transmittivity="#",
        out_direct_radiation_features="#",
        out_diffuse_radiation_features="#",
        out_direct_duration_features="#"):
    """PointsSolarRadiation_sa(in_surface_raster, in_points_feature_or_table, out_global_radiation_features, {height_offset}, {latitude}, {sky_size}, {time_configuration}, {day_interval}, {hour_interval}, {each_interval}, {z_factor}, {slope_aspect_input_type}, {calculation_directions}, {zenith_divisions}, {azimuth_divisions}, {diffuse_model_type}, {diffuse_proportion}, {transmittivity}, {out_direct_radiation_features}, {out_diffuse_radiation_features}, {out_direct_duration_features})

    Derives incoming solar radiation for specific locations in a point feature class or location table.

    Arguments:
    in_surface_raster -- 
    in_points_feature_or_table -- 
    out_global_radiation_features -- 
    height_offset -- 
    latitude -- 
    sky_size -- 
    time_configuration -- 
    day_interval -- 
    hour_interval -- 
    each_interval -- 
    z_factor -- 
    slope_aspect_input_type -- 
    calculation_directions -- 
    zenith_divisions -- 
    azimuth_divisions -- 
    diffuse_model_type -- 
    diffuse_proportion -- 
    transmittivity -- 
    out_direct_radiation_features -- 
    out_diffuse_radiation_features -- 
    out_direct_duration_features -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_surface_raster,
            in_points_feature_or_table,
            out_global_radiation_features,
            height_offset,
            latitude,
            sky_size,
            time_configuration,
            day_interval,
            hour_interval,
            each_interval,
            z_factor,
            slope_aspect_input_type,
            calculation_directions,
            zenith_divisions,
            azimuth_divisions,
            diffuse_model_type,
            diffuse_proportion,
            transmittivity,
            out_direct_radiation_features,
            out_diffuse_radiation_features,
            out_direct_duration_features):
        time_configuration = Utils.compoundParameterToString(time_configuration, ParameterClasses._Time)
        result = arcpy.gp.PointsSolarRadiation_sa(
            in_surface_raster,
            in_points_feature_or_table,
            out_global_radiation_features,
            height_offset,
            latitude,
            sky_size,
            time_configuration,
            day_interval,
            hour_interval,
            each_interval,
            z_factor,
            slope_aspect_input_type,
            calculation_directions,
            zenith_divisions,
            azimuth_divisions,
            diffuse_model_type,
            diffuse_proportion,
            transmittivity,
            out_direct_radiation_features,
            out_diffuse_radiation_features,
            out_direct_duration_features)
        return result
    return Wrapper(
        in_surface_raster,
        in_points_feature_or_table,
        out_global_radiation_features,
        height_offset,
        latitude,
        sky_size,
        time_configuration,
        day_interval,
        hour_interval,
        each_interval,
        z_factor,
        slope_aspect_input_type,
        calculation_directions,
        zenith_divisions,
        azimuth_divisions,
        diffuse_model_type,
        diffuse_proportion,
        transmittivity,
        out_direct_radiation_features,
        out_diffuse_radiation_features,
        out_direct_duration_features)
PointsSolarRadiation.__esri_toolname__ = "PointsSolarRadiation_sa"
PointsSolarRadiation.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "Python::TimeMultipleDays|TimeSpecialDays|TimeWholeYear|TimeWithinDay::",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14",
    "::::15",
    "::::16",
    "::::17",
    "::::18",
    "::::19",
    "::::20",
    "::::21"
]


def PointStatistics(
        in_point_features,
        field,
        cell_size="#",
        neighborhood="#",
        statistics_type="#"):
    """PointStatistics_sa(in_point_features, field, {cell_size}, {neighborhood}, {statistics_type})

    Calculates a statistic on the points in a neighborhood around each output cell.

    Arguments:
    in_point_features -- 
    field -- 
    cell_size -- 
    neighborhood -- 
    statistics_type -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_point_features,
            field,
            cell_size,
            neighborhood,
            statistics_type):
        neighborhood = Utils.compoundParameterToString(neighborhood, ParameterClasses._Neighborhood)
        out_raster = "#"
        result = arcpy.gp.PointStatistics_sa(
            in_point_features,
            field,
            out_raster,
            cell_size,
            neighborhood,
            statistics_type)
        return _wrapToolRaster(u"PointStatistics_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_point_features,
        field,
        cell_size,
        neighborhood,
        statistics_type)
PointStatistics.__esri_toolname__ = "PointStatistics_sa"
PointStatistics.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "Python::NbrAnnulus|NbrCircle|NbrRectangle|NbrWedge::",
    "::::6"
]


def Popularity(
        in_popularity_raster_or_constant,
        in_rasters,
        process_as_multiband="#"):
    """Popularity_sa(in_popularity_raster_or_constant, [in_raster,...], {process_as_multiband})

    Determines the value in an argument list that is at a certain level of popularity on a cell-by-cell basis. The particular level of popularity (the number of occurrences of each value) is specified by the first argument.

    Arguments:
    in_popularity_raster_or_constant -- 
    in_raster -- 
    process_as_multiband -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_popularity_raster_or_constant,
            in_rasters,
            process_as_multiband):
        if Utils.useDefaultArgumentValue(process_as_multiband):
            process_as_multiband = "SINGLE_BAND"
        if process_as_multiband not in ["SINGLE_BAND", "MULTI_BAND"]:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (Popularity). Parameters are not valid.\nERROR 000621: Input to parameter process_as_multiband not within domain.\n")
        return _wrapLocalFunctionRaster(u"Popularity_sa", ["Popularity", in_popularity_raster_or_constant] + Utils.flattenLists(in_rasters), {"flattenBands" : process_as_multiband.upper() == "SINGLE_BAND"})
    return Wrapper(
        in_popularity_raster_or_constant,
        in_rasters,
        process_as_multiband)
Popularity.__esri_toolname__ = "Popularity_sa"
Popularity.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def PorousPuff(
        in_track_file,
        in_porosity_raster,
        in_thickness_raster,
        mass,
        dispersion_time="#",
        longitudinal_dispersivity="#",
        dispersivity_ratio="#",
        retardation_factor="#",
        decay_coefficient="#"):
    """PorousPuff_sa(in_track_file, in_porosity_raster, in_thickness_raster, mass, {dispersion_time}, {longitudinal_dispersivity}, {dispersivity_ratio}, {retardation_factor}, {decay_coefficient})

    Calculates the time-dependent, two-dimensional concentration distribution in mass per volume of a solute introduced instantaneously and at a discrete point into a vertically mixed aquifer.

    Arguments:
    in_track_file -- 
    in_porosity_raster -- 
    in_thickness_raster -- 
    mass -- 
    dispersion_time -- 
    longitudinal_dispersivity -- 
    dispersivity_ratio -- 
    retardation_factor -- 
    decay_coefficient -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_track_file,
            in_porosity_raster,
            in_thickness_raster,
            mass,
            dispersion_time,
            longitudinal_dispersivity,
            dispersivity_ratio,
            retardation_factor,
            decay_coefficient):
        out_raster = "#"
        result = arcpy.gp.PorousPuff_sa(
            in_track_file,
            in_porosity_raster,
            in_thickness_raster,
            out_raster,
            mass,
            dispersion_time,
            longitudinal_dispersivity,
            dispersivity_ratio,
            retardation_factor,
            decay_coefficient)
        return _wrapToolRaster(u"PorousPuff_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_track_file,
        in_porosity_raster,
        in_thickness_raster,
        mass,
        dispersion_time,
        longitudinal_dispersivity,
        dispersivity_ratio,
        retardation_factor,
        decay_coefficient)
PorousPuff.__esri_toolname__ = "PorousPuff_sa"
PorousPuff.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10"
]


def Power(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Power_sa(in_raster_or_constant1, in_raster_or_constant2)

    Raises the cell values in a raster to the power of the values found in another raster.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Power_sa",
            ["Power", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Power.__esri_toolname__ = "Power_sa"
Power.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def PrincipalComponents(
        in_raster_bands,
        number_components="#",
        out_data_file="#"):
    """PrincipalComponents_sa([in_raster_band,...], {number_components}, {out_data_file})

    Performs Principal Component Analysis (PCA) on a set of raster bands and generates a single multiband raster as output.

    Arguments:
    in_raster_band -- 
    number_components -- 
    out_data_file -- 

    Results:
    out_multiband_raster -- Output multiband raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_bands,
            number_components,
            out_data_file):
        out_multiband_raster = "#"
        result = arcpy.gp.PrincipalComponents_sa(
            in_raster_bands,
            out_multiband_raster,
            number_components,
            out_data_file)
        return _wrapToolRaster(u"PrincipalComponents_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster_bands,
        number_components,
        out_data_file)
PrincipalComponents.__esri_toolname__ = "PrincipalComponents_sa"
PrincipalComponents.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4"
]


def Rank(
        in_rank_raster_or_constant,
        in_rasters,
        process_as_multiband="#"):
    """Rank_sa(in_rank_raster_or_constant, [in_raster,...], {process_as_multiband})

    Ranks on a cell-by-cell basis the values from a set of input rasters and determines which values are returned based on the value of the rank input raster.

    Arguments:
    in_rank_raster_or_constant -- 
    in_raster -- 
    process_as_multiband -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_rank_raster_or_constant,
            in_rasters,
            process_as_multiband):
        if Utils.useDefaultArgumentValue(process_as_multiband):
            process_as_multiband = "SINGLE_BAND"
        if process_as_multiband not in ["SINGLE_BAND", "MULTI_BAND"]:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (Rank). Parameters are not valid.\nERROR 000621: Input to parameter process_as_multiband not within domain.\n")
        return _wrapLocalFunctionRaster(u"Rank_sa", ["Rank", in_rank_raster_or_constant] + Utils.flattenLists(in_rasters), {"flattenBands" : process_as_multiband.upper() == "SINGLE_BAND"})
    return Wrapper(
        in_rank_raster_or_constant,
        in_rasters,
        process_as_multiband)
Rank.__esri_toolname__ = "Rank_sa"
Rank.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def ReclassByASCIIFile(
        in_raster,
        in_remap_file,
        missing_values="#"):
    """ReclassByASCIIFile_sa(in_raster, in_remap_file, {missing_values})

    Reclassifies (or changes) the values of the input cells of a raster using an ASCII remap file.

    Arguments:
    in_raster -- 
    in_remap_file -- 
    missing_values -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_remap_file,
            missing_values):
        out_raster = "#"
        result = arcpy.gp.ReclassByASCIIFile_sa(
            in_raster,
            in_remap_file,
            out_raster,
            missing_values)
        return _wrapToolRaster(u"ReclassByASCIIFile_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_remap_file,
        missing_values)
ReclassByASCIIFile.__esri_toolname__ = "ReclassByASCIIFile_sa"
ReclassByASCIIFile.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def ReclassByTable(
        in_raster,
        in_remap_table,
        from_value_field,
        to_value_field,
        output_value_field,
        missing_values="#"):
    """ReclassByTable_sa(in_raster, in_remap_table, from_value_field, to_value_field, output_value_field, {missing_values})

    Reclassifies (or changes) the values of the input cells of a raster using a remap table.

    Arguments:
    in_raster -- 
    in_remap_table -- 
    from_value_field -- 
    to_value_field -- 
    output_value_field -- 
    missing_values -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_remap_table,
            from_value_field,
            to_value_field,
            output_value_field,
            missing_values):
        out_raster = "#"
        result = arcpy.gp.ReclassByTable_sa(
            in_raster,
            in_remap_table,
            from_value_field,
            to_value_field,
            output_value_field,
            out_raster,
            missing_values)
        return _wrapToolRaster(u"ReclassByTable_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_remap_table,
        from_value_field,
        to_value_field,
        output_value_field,
        missing_values)
ReclassByTable.__esri_toolname__ = "ReclassByTable_sa"
ReclassByTable.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::7"
]


def Reclassify(
        in_raster,
        reclass_field,
        remap,
        missing_values="#"):
    """Reclassify_sa(in_raster, reclass_field, remap, {missing_values})

    Reclassifies (or changes) the values in a raster.

    Arguments:
    in_raster -- 
    reclass_field -- 
    remap -- 
    missing_values -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            reclass_field,
            remap,
            missing_values):
        remap = Utils.compoundParameterToString(remap, ParameterClasses._Remap)
        out_raster = "#"
        result = arcpy.gp.Reclassify_sa(
            in_raster,
            reclass_field,
            remap,
            out_raster,
            missing_values)
        return _wrapToolRaster(u"Reclassify_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        reclass_field,
        remap,
        missing_values)
Reclassify.__esri_toolname__ = "Reclassify_sa"
Reclassify.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "Python::RemapRange|RemapValue::",
    "::::5"
]


def RegionGroup(
        in_raster,
        number_neighbors="#",
        zone_connectivity="#",
        add_link="#",
        excluded_value="#"):
    """RegionGroup_sa(in_raster, {number_neighbors}, {zone_connectivity}, {add_link}, {excluded_value})

    For each cell in the output, the identity of the connected region to which that cell belongs is recorded. A unique number is assigned to each region.

    Arguments:
    in_raster -- 
    number_neighbors -- 
    zone_connectivity -- 
    add_link -- 
    excluded_value -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            number_neighbors,
            zone_connectivity,
            add_link,
            excluded_value):
        out_raster = "#"
        result = arcpy.gp.RegionGroup_sa(
            in_raster,
            out_raster,
            number_neighbors,
            zone_connectivity,
            add_link,
            excluded_value)
        return _wrapToolRaster(u"RegionGroup_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        number_neighbors,
        zone_connectivity,
        add_link,
        excluded_value)
RegionGroup.__esri_toolname__ = "RegionGroup_sa"
RegionGroup.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def RemoveRasterSegmentTilingArtifacts(
        in_segmented_raster,
        tileSizeX="#",
        tileSizeY="#"):
    """RemoveRasterSegmentTilingArtifacts_sa(in_segmented_raster, {tileSizeX}, {tileSizeY})

    Corrects segments or objects cut by tile boundaries during the segmentation process performed as a raster function. This tool is helpful for some regional processes, such as image segmentation, that have inconsistencies near image tile boundaries.

    Arguments:
    in_segmented_raster -- 
    tileSizeX -- 
    tileSizeY -- 

    Results:
    out_raster_dataset -- Output Segmented Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_segmented_raster,
            tileSizeX,
            tileSizeY):
        out_raster_dataset = "#"
        result = arcpy.gp.RemoveRasterSegmentTilingArtifacts_sa(
            in_segmented_raster,
            out_raster_dataset,
            tileSizeX,
            tileSizeY)
        return _wrapToolRaster(u"RemoveRasterSegmentTilingArtifacts_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_segmented_raster,
        tileSizeX,
        tileSizeY)
RemoveRasterSegmentTilingArtifacts.__esri_toolname__ = "RemoveRasterSegmentTilingArtifacts_sa"
RemoveRasterSegmentTilingArtifacts.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4"
]


def RescaleByFunction(
        in_raster,
        transformation_function="#",
        from_scale="#",
        to_scale="#"):
    """RescaleByFunction_sa(in_raster, {transformation_function}, {from_scale}, {to_scale})

    Rescales the input raster values by applying a selected transformation function and transforming the resulting values onto a specified continuous evaluation scale.

    Arguments:
    in_raster -- 
    transformation_function -- 
    from_scale -- 
    to_scale -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            transformation_function,
            from_scale,
            to_scale):
        transformation_function = Utils.compoundParameterToString(transformation_function, ParameterClasses._TransformationFunction)
        out_raster = "#"
        result = arcpy.gp.RescaleByFunction_sa(
            in_raster,
            out_raster,
            transformation_function,
            from_scale,
            to_scale)
        return _wrapToolRaster(u"RescaleByFunction_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        transformation_function,
        from_scale,
        to_scale)
RescaleByFunction.__esri_toolname__ = "RescaleByFunction_sa"
RescaleByFunction.__esri_toolinfo__ = [
    "::::1",
    "Python::TfExponential|TfGaussian|TfLarge|TfLinear|TfLogarithm|TfLogisticDecay|TfLogisticGrowth|TfMSLarge|TfMSSmall|TfNear|TfPower|TfSmall|TfSymmetricLinear::",
    "::::4",
    "::::5"
]


def RoundDown(
        in_raster_or_constant):
    """RoundDown_sa(in_raster_or_constant)

    Returns the next lower integer value, just represented as a floating point, for each cell in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"RoundDown_sa",
            ["RoundDown", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
RoundDown.__esri_toolname__ = "RoundDown_sa"
RoundDown.__esri_toolinfo__ = [
    "::::1"
]


def RoundUp(
        in_raster_or_constant):
    """RoundUp_sa(in_raster_or_constant)

    Returns the next higher integer value, just represented as a floating point, for each cell in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"RoundUp_sa",
            ["RoundUp", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
RoundUp.__esri_toolname__ = "RoundUp_sa"
RoundUp.__esri_toolinfo__ = [
    "::::1"
]


def Sample(
        in_rasters,
        in_location_data,
        out_table,
        resampling_type="#",
        unique_id_field="#",
        process_as_multidimensional="#",
        acquisition_definition="#",
        statistics_type="#",
        percentile_value="#",
        buffer_distance="#",
        layout="#",
        generate_feature_class="#"):
    """Sample_sa([in_raster,...], in_location_data, out_table, {resampling_type}, {unique_id_field}, {process_as_multidimensional}, {acquisition_definition}, {statistics_type}, {percentile_value}, {buffer_distance}, {layout}, {generate_feature_class})

    Creates a table or a point feature class that shows the values of cells from a raster, or a set of rasters, for defined locations. The locations are defined by raster cells, points, polylines, or polygons.

    Arguments:
    in_raster -- 
    in_location_data -- 
    out_table -- 
    resampling_type -- 
    unique_id_field -- 
    process_as_multidimensional -- 
    acquisition_definition -- 
    statistics_type -- 
    percentile_value -- 
    buffer_distance -- 
    layout -- 
    generate_feature_class -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_rasters,
            in_location_data,
            out_table,
            resampling_type,
            unique_id_field,
            process_as_multidimensional,
            acquisition_definition,
            statistics_type,
            percentile_value,
            buffer_distance,
            layout,
            generate_feature_class):
        result = arcpy.gp.Sample_sa(
            in_rasters,
            in_location_data,
            out_table,
            resampling_type,
            unique_id_field,
            process_as_multidimensional,
            acquisition_definition,
            statistics_type,
            percentile_value,
            buffer_distance,
            layout,
            generate_feature_class)
        return result
    return Wrapper(
        in_rasters,
        in_location_data,
        out_table,
        resampling_type,
        unique_id_field,
        process_as_multidimensional,
        acquisition_definition,
        statistics_type,
        percentile_value,
        buffer_distance,
        layout,
        generate_feature_class)
Sample.__esri_toolname__ = "Sample_sa"
Sample.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12"
]


def SegmentMeanShift(
        in_raster,
        spectral_detail="#",
        spatial_detail="#",
        min_segment_size="#",
        band_indexes="#",
        max_segment_size="#"):
    """SegmentMeanShift_sa(in_raster, {spectral_detail}, {spatial_detail}, {min_segment_size}, {band_indexes}, {max_segment_size})

    Groups into segments adjacent pixels that have similar spectral characteristics.

    Arguments:
    in_raster -- 
    spectral_detail -- 
    spatial_detail -- 
    min_segment_size -- 
    band_indexes -- 
    max_segment_size -- 

    Results:
    out_raster_dataset -- Output Raster Dataset"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            spectral_detail,
            spatial_detail,
            min_segment_size,
            band_indexes,
            max_segment_size):
        out_raster_dataset = "#"
        result = arcpy.gp.SegmentMeanShift_sa(
            in_raster,
            out_raster_dataset,
            spectral_detail,
            spatial_detail,
            min_segment_size,
            band_indexes,
            max_segment_size)
        return _wrapToolRaster(u"SegmentMeanShift_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        spectral_detail,
        spatial_detail,
        min_segment_size,
        band_indexes,
        max_segment_size)
SegmentMeanShift.__esri_toolname__ = "SegmentMeanShift_sa"
SegmentMeanShift.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def SetNull(
        in_conditional_raster,
        in_false_raster_or_constant,
        where_clause="#"):
    """SetNull_sa(in_conditional_raster, in_false_raster_or_constant, {where_clause})

    Set Null sets identified cell locations to NoData based on a specified criteria. It returns NoData if a conditional evaluation is true, and returns the value specified by another raster if it is false.

    Arguments:
    in_conditional_raster -- 
    in_false_raster_or_constant -- 
    where_clause -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_conditional_raster,
            in_false_raster_or_constant,
            where_clause):
        if Utils.useDefaultArgumentValue(where_clause):
            return _wrapLocalFunctionRaster(u"SetNull_sa",
                ["SetNull", in_conditional_raster, in_false_raster_or_constant])
        out_raster = "#"
        result = arcpy.gp.SetNull_sa(
            in_conditional_raster,
            in_false_raster_or_constant,
            out_raster,
            where_clause)
        return _wrapToolRaster(u"SetNull_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_conditional_raster,
        in_false_raster_or_constant,
        where_clause)
SetNull.__esri_toolname__ = "SetNull_sa"
SetNull.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def Shrink(
        in_raster,
        number_cells,
        zone_values,
        shrink_method="#"):
    """Shrink_sa(in_raster, number_cells, [zone_value,...], {shrink_method})

    Shrinks the selected zones by a specified number of cells by replacing them with the value of the cell that is most frequent in its neighborhood.

    Arguments:
    in_raster -- 
    number_cells -- 
    zone_value -- 
    shrink_method -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            number_cells,
            zone_values,
            shrink_method):
        out_raster = "#"
        result = arcpy.gp.Shrink_sa(
            in_raster,
            out_raster,
            number_cells,
            zone_values,
            shrink_method)
        return _wrapToolRaster(u"Shrink_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        number_cells,
        zone_values,
        shrink_method)
Shrink.__esri_toolname__ = "Shrink_sa"
Shrink.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5"
]


def Sin(
        in_raster_or_constant):
    """Sin_sa(in_raster_or_constant)

    Calculates the sine of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Sin_sa",
            ["Sin", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Sin.__esri_toolname__ = "Sin_sa"
Sin.__esri_toolinfo__ = [
    "::::1"
]


def SinH(
        in_raster_or_constant):
    """SinH_sa(in_raster_or_constant)

    Calculates the hyperbolic sine of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"SinH_sa",
            ["SinH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
SinH.__esri_toolname__ = "SinH_sa"
SinH.__esri_toolinfo__ = [
    "::::1"
]


def Sink(
        in_flow_direction_raster):
    """Sink_sa(in_flow_direction_raster)

    Creates a raster identifying all sinks or areas of internal drainage.

    Arguments:
    in_flow_direction_raster -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_flow_direction_raster):
        out_raster = "#"
        result = arcpy.gp.Sink_sa(
            in_flow_direction_raster,
            out_raster)
        return _wrapToolRaster(u"Sink_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_flow_direction_raster)
Sink.__esri_toolname__ = "Sink_sa"
Sink.__esri_toolinfo__ = [
    "::::1"
]


def Slice(
        in_raster,
        number_zones="#",
        slice_type="#",
        base_output_zone="#",
        nodata_to_value="#",
        class_interval_size="#"):
    """Slice_sa(in_raster, {number_zones}, {slice_type}, {base_output_zone}, {nodata_to_value}, {class_interval_size})

    Slices or reclassifies the range of values of the input cells into zones (classes). The available data classification methods are equal interval, equal area (quantile), natural breaks, standard deviation (mean-centered), standard deviation (mean as a break), defined interval, and geometric interval.

    Arguments:
    in_raster -- 
    number_zones -- 
    slice_type -- 
    base_output_zone -- 
    nodata_to_value -- 
    class_interval_size -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            number_zones,
            slice_type,
            base_output_zone,
            nodata_to_value,
            class_interval_size):
        out_raster = "#"
        result = arcpy.gp.Slice_sa(
            in_raster,
            out_raster,
            number_zones,
            slice_type,
            base_output_zone,
            nodata_to_value,
            class_interval_size)
        return _wrapToolRaster(u"Slice_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        number_zones,
        slice_type,
        base_output_zone,
        nodata_to_value,
        class_interval_size)
Slice.__esri_toolname__ = "Slice_sa"
Slice.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def Slope(
        in_raster,
        output_measurement="#",
        z_factor="#",
        method="#",
        z_unit="#"):
    """Slope_sa(in_raster, {output_measurement}, {z_factor}, {method}, {z_unit})

    Identifies the slope (gradient or steepness) from each cell of a raster.

    Arguments:
    in_raster -- 
    output_measurement -- 
    z_factor -- 
    method -- 
    z_unit -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            output_measurement,
            z_factor,
            method,
            z_unit):
        # in_raster
        in_raster = ApplyEnvironment(in_raster)  # needed for image service input
        rfx_args = {}
        # output_measurement
        if "PERCENT_RISE" in str(output_measurement).upper():
            rfx_args["SlopeType"] = 2  # Percent rise
        else:
            rfx_args["SlopeType"] = 1  # Degrees
        # z_factor
        linear_unit_factors = {
            "INCH": 0.025400050800101603,
            "INCH_US": 0.025400050800101603,
            "POINT": 0.00035277777777777776,
            "FOOT": 0.30480060960121924,
            "FOOT_US": 0.30480060960121924,
            "YARD": 0.91440182880365761,
            "YARD_US": 0.91440182880365761,
            "MILE_US": 1609.3472186944375,
            "NAUTICAL_MILE": 1853.248,
            "NAUTICAL_MILE_US": 1853.248,
            "MILLIMETER": 0.001,
            "CENTIMETER": 0.01,
            "DECIMETER": 0.1,
            "METER": 1,
            "KILOMETER": 1000,
        }
        z_meters_per_unit = None
        in_spatial_reference = None
        try:
            in_spatial_reference = arcpy.Describe(in_raster).spatialReference
            vcs = in_spatial_reference.vcs
            zlu = str(vcs.linearUnitName).upper()
            z_meters_per_unit = linear_unit_factors[zlu]
            try:
                # PCS
                xy_meters_per_unit = float(in_spatial_reference.metersPerUnit)
            except AttributeError:
                # GCS
                radians_per_unit = float(in_spatial_reference.radiansPerUnit)
                extent = arcpy.Raster(in_raster).extent
                extent.projectAs(in_spatial_reference)
                mean_latitude = 0.5 * (extent.YMin + extent.YMax)
                latitude_radians = mean_latitude * radians_per_unit
                a = float(in_spatial_reference.semiMajorAxis)
                b = float(in_spatial_reference.semiMinorAxis)
                e2 = (a**2 - b**2) / a**2  # ellipsoid eccentricity squared
                # Convert using mean Gaussian curvature at extent centroid latitude
                import math
                s = math.sin(latitude_radians)
                gaussian_radius = a * ((1.0 - e2)**0.5) / (1.0 - e2 * s**2)
                xy_meters_per_unit = gaussian_radius * radians_per_unit
            z_factor = z_meters_per_unit / xy_meters_per_unit
        except AttributeError:
            pass
        try:
            rfx_args["ZFactor"] = float(z_factor)
        except ValueError:
            rfx_args["ZFactor"] = 1.0
        # method
        if "GEODESIC" in str(method).upper():
            rfx_name = "GeodesicSlope"
            if in_spatial_reference is None or in_spatial_reference.name == "Unknown":
                msgs = Utils.ParameterErrors()
                msgs.add_id_message("ERROR", 10472)  # The Geodesic method needs a spatial reference but the input dataset does not have one.
                msgs.add_id_message("ERROR", 581)  # Invalid parameters.
                msgs.add_id_message("INFO", 952, "Slope")  # Failed to execute (<tool name>).
                raise arcpy.ExecuteError(msgs.combine())
        else:
            rfx_name = "Slope"
        # z_unit
        zu_str = str(z_unit).upper()
        if zu_str in linear_unit_factors:
            new_zmpu = linear_unit_factors[str(z_unit).upper()]
            if z_meters_per_unit is not None and z_meters_per_unit != new_zmpu:
                msgs = Utils.ParameterErrors()
                msgs.add_id_message("INFO", 583)  # Failed to execute. Parameters are not valid.
                msgs.add_id_message("ERROR", 10515)  # The Z unit parameter is inconsistent with the vertical unit in the input dataset's spatial reference.
                msgs.add_id_message("INFO", 952, "Slope")  # Failed to execute (<tool name>).
                raise arcpy.ExecuteError(msgs.combine())
            z_meters_per_unit = new_zmpu
        if z_meters_per_unit is None:
            z_meters_per_unit = 1.0
        rfx_args["ZMetersPerUnit"] = float(z_meters_per_unit)
        result = arcpy.sa.Apply(in_raster, rfx_name, rfx_args)
        return ApplyEnvironment(result)  # Needed for layer to get added in Pro
    return Wrapper(
        in_raster,
        output_measurement,
        z_factor,
        method,
        z_unit)
Slope.__esri_toolname__ = "Slope_sa"
Slope.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def SnapPourPoint(
        in_pour_point_data,
        in_accumulation_raster,
        snap_distance,
        pour_point_field="#"):
    """SnapPourPoint_sa(in_pour_point_data, in_accumulation_raster, snap_distance, {pour_point_field})

    Snaps pour points to the cell of highest flow accumulation within a specified distance.

    Arguments:
    in_pour_point_data -- 
    in_accumulation_raster -- 
    snap_distance -- 
    pour_point_field -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_pour_point_data,
            in_accumulation_raster,
            snap_distance,
            pour_point_field):
        out_raster = "#"
        result = arcpy.gp.SnapPourPoint_sa(
            in_pour_point_data,
            in_accumulation_raster,
            out_raster,
            snap_distance,
            pour_point_field)
        return _wrapToolRaster(u"SnapPourPoint_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_pour_point_data,
        in_accumulation_raster,
        snap_distance,
        pour_point_field)
SnapPourPoint.__esri_toolname__ = "SnapPourPoint_sa"
SnapPourPoint.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5"
]


def SolarRadiationGraphics(
        in_surface_raster,
        in_points_feature_or_table="#",
        sky_size="#",
        height_offset="#",
        calculation_directions="#",
        latitude="#",
        time_configuration="#",
        day_interval="#",
        hour_interval="#",
        out_sunmap_raster="#",
        zenith_divisions="#",
        azimuth_divisions="#",
        out_skymap_raster="#"):
    """SolarRadiationGraphics_sa(in_surface_raster, {in_points_feature_or_table}, {sky_size}, {height_offset}, {calculation_directions}, {latitude}, {time_configuration}, {day_interval}, {hour_interval}, {out_sunmap_raster}, {zenith_divisions}, {azimuth_divisions}, {out_skymap_raster})

    Derives raster representations of a hemispherical viewshed, sun map, and sky map, which are used in the calculation of direct, diffuse, and global solar radiation.

    Arguments:
    in_surface_raster -- 
    in_points_feature_or_table -- 
    sky_size -- 
    height_offset -- 
    calculation_directions -- 
    latitude -- 
    time_configuration -- 
    day_interval -- 
    hour_interval -- 
    out_sunmap_raster -- 
    zenith_divisions -- 
    azimuth_divisions -- 
    out_skymap_raster -- 

    Results:
    out_viewshed_raster -- Output viewshed raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_surface_raster,
            in_points_feature_or_table,
            sky_size,
            height_offset,
            calculation_directions,
            latitude,
            time_configuration,
            day_interval,
            hour_interval,
            out_sunmap_raster,
            zenith_divisions,
            azimuth_divisions,
            out_skymap_raster):
        time_configuration = Utils.compoundParameterToString(time_configuration, ParameterClasses._Time)
        out_viewshed_raster = "#"
        result = arcpy.gp.SolarRadiationGraphics_sa(
            in_surface_raster,
            out_viewshed_raster,
            in_points_feature_or_table,
            sky_size,
            height_offset,
            calculation_directions,
            latitude,
            time_configuration,
            day_interval,
            hour_interval,
            out_sunmap_raster,
            zenith_divisions,
            azimuth_divisions,
            out_skymap_raster)
        return _wrapToolRaster(u"SolarRadiationGraphics_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_surface_raster,
        in_points_feature_or_table,
        sky_size,
        height_offset,
        calculation_directions,
        latitude,
        time_configuration,
        day_interval,
        hour_interval,
        out_sunmap_raster,
        zenith_divisions,
        azimuth_divisions,
        out_skymap_raster)
SolarRadiationGraphics.__esri_toolname__ = "SolarRadiationGraphics_sa"
SolarRadiationGraphics.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "Python::TimeMultipleDays|TimeSpecialDays|TimeWholeYear|TimeWithinDay::",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14"
]


def Spline(
        in_point_features,
        z_field,
        cell_size="#",
        spline_type="#",
        weight="#",
        number_points="#"):
    """Spline_sa(in_point_features, z_field, {cell_size}, {spline_type}, {weight}, {number_points})

    Interpolates a raster surface from points using a two-dimensional minimum curvature spline technique.

    Arguments:
    in_point_features -- 
    z_field -- 
    cell_size -- 
    spline_type -- 
    weight -- 
    number_points -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_point_features,
            z_field,
            cell_size,
            spline_type,
            weight,
            number_points):
        out_raster = "#"
        result = arcpy.gp.Spline_sa(
            in_point_features,
            z_field,
            out_raster,
            cell_size,
            spline_type,
            weight,
            number_points)
        return _wrapToolRaster(u"Spline_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_point_features,
        z_field,
        cell_size,
        spline_type,
        weight,
        number_points)
Spline.__esri_toolname__ = "Spline_sa"
Spline.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def SplineWithBarriers(
        in_point_features,
        Z_value_field,
        Input_barrier_features="#",
        cell_size="#",
        Smoothing_Factor="#"):
    """SplineWithBarriers_sa(in_point_features, Z_value_field, {Input_barrier_features}, {cell_size}, {Smoothing_Factor})

    Interpolates a raster surface, using barriers, from points using a minimum curvature spline technique. The barriers are entered as either polygon or polyline features.

    Arguments:
    in_point_features -- 
    Z_value_field -- 
    Input_barrier_features -- 
    cell_size -- 
    Smoothing_Factor -- 

    Results:
    Output_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_point_features,
            Z_value_field,
            Input_barrier_features,
            cell_size,
            Smoothing_Factor):
        Output_raster = "#"
        result = arcpy.gp.SplineWithBarriers_sa(
            in_point_features,
            Z_value_field,
            Input_barrier_features,
            cell_size,
            Output_raster,
            Smoothing_Factor)
        return _wrapToolRaster(u"SplineWithBarriers_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_point_features,
        Z_value_field,
        Input_barrier_features,
        cell_size,
        Smoothing_Factor)
SplineWithBarriers.__esri_toolname__ = "SplineWithBarriers_sa"
SplineWithBarriers.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::6"
]


def Square(
        in_raster_or_constant):
    """Square_sa(in_raster_or_constant)

    Calculates the square of the cell values in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Square_sa",
            ["Square", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Square.__esri_toolname__ = "Square_sa"
Square.__esri_toolinfo__ = [
    "::::1"
]


def SquareRoot(
        in_raster_or_constant):
    """SquareRoot_sa(in_raster_or_constant)

    Calculates the square root of the cell values in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"SquareRoot_sa",
            ["SquareRoot", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
SquareRoot.__esri_toolname__ = "SquareRoot_sa"
SquareRoot.__esri_toolinfo__ = [
    "::::1"
]


def StorageCapacity(
        in_surface_raster,
        out_table,
        in_zone_data="#",
        zone_field="#",
        analysis_type="#",
        min_elevation="#",
        max_elevation="#",
        increment_type="#",
        increment="#",
        z_unit="#",
        out_chart="#"):
    """StorageCapacity_sa(in_surface_raster, out_table, {in_zone_data}, {zone_field}, {analysis_type}, {min_elevation}, {max_elevation}, {increment_type}, {increment}, {z_unit}, {out_chart})

    Creates a table and a chart of elevations and corresponding storage capacities for an input surface raster. The tool calculates the surface area and total volume of the underlying region at a series of elevation increments.

    Arguments:
    in_surface_raster -- 
    out_table -- 
    in_zone_data -- 
    zone_field -- 
    analysis_type -- 
    min_elevation -- 
    max_elevation -- 
    increment_type -- 
    increment -- 
    z_unit -- 
    out_chart -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_surface_raster,
            out_table,
            in_zone_data,
            zone_field,
            analysis_type,
            min_elevation,
            max_elevation,
            increment_type,
            increment,
            z_unit,
            out_chart):
        result = arcpy.gp.StorageCapacity_sa(
            in_surface_raster,
            out_table,
            in_zone_data,
            zone_field,
            analysis_type,
            min_elevation,
            max_elevation,
            increment_type,
            increment,
            z_unit,
            out_chart)
        return result
    return Wrapper(
        in_surface_raster,
        out_table,
        in_zone_data,
        zone_field,
        analysis_type,
        min_elevation,
        max_elevation,
        increment_type,
        increment,
        z_unit,
        out_chart)
StorageCapacity.__esri_toolname__ = "StorageCapacity_sa"
StorageCapacity.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11"
]


def StreamLink(
        in_stream_raster,
        in_flow_direction_raster):
    """StreamLink_sa(in_stream_raster, in_flow_direction_raster)

    Assigns unique values to sections of a raster linear network between intersections.

    Arguments:
    in_stream_raster -- 
    in_flow_direction_raster -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_stream_raster,
            in_flow_direction_raster):
        out_raster = "#"
        result = arcpy.gp.StreamLink_sa(
            in_stream_raster,
            in_flow_direction_raster,
            out_raster)
        return _wrapToolRaster(u"StreamLink_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_stream_raster,
        in_flow_direction_raster)
StreamLink.__esri_toolname__ = "StreamLink_sa"
StreamLink.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def StreamOrder(
        in_stream_raster,
        in_flow_direction_raster,
        order_method="#"):
    """StreamOrder_sa(in_stream_raster, in_flow_direction_raster, {order_method})

    Assigns a numeric order to segments of a raster representing branches of a linear network.

    Arguments:
    in_stream_raster -- 
    in_flow_direction_raster -- 
    order_method -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_stream_raster,
            in_flow_direction_raster,
            order_method):
        out_raster = "#"
        result = arcpy.gp.StreamOrder_sa(
            in_stream_raster,
            in_flow_direction_raster,
            out_raster,
            order_method)
        return _wrapToolRaster(u"StreamOrder_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_stream_raster,
        in_flow_direction_raster,
        order_method)
StreamOrder.__esri_toolname__ = "StreamOrder_sa"
StreamOrder.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def StreamToFeature(
        in_stream_raster,
        in_flow_direction_raster,
        out_polyline_features,
        simplify="#"):
    """StreamToFeature_sa(in_stream_raster, in_flow_direction_raster, out_polyline_features, {simplify})

    Converts a raster representing a linear network to features representing the linear network.

    Arguments:
    in_stream_raster -- 
    in_flow_direction_raster -- 
    out_polyline_features -- 
    simplify -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_stream_raster,
            in_flow_direction_raster,
            out_polyline_features,
            simplify):
        result = arcpy.gp.StreamToFeature_sa(
            in_stream_raster,
            in_flow_direction_raster,
            out_polyline_features,
            simplify)
        return result
    return Wrapper(
        in_stream_raster,
        in_flow_direction_raster,
        out_polyline_features,
        simplify)
StreamToFeature.__esri_toolname__ = "StreamToFeature_sa"
StreamToFeature.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4"
]


def SurfaceParameters(
        in_raster,
        parameter_type="#",
        local_surface_type="#",
        neighborhood_distance="#",
        use_adaptive_neighborhood="#",
        z_unit="#",
        output_slope_measurement="#",
        project_geodesic_azimuths="#",
        use_equatorial_aspect="#"):
    """SurfaceParameters_sa(in_raster, {parameter_type}, {local_surface_type}, {neighborhood_distance}, {use_adaptive_neighborhood}, {z_unit}, {output_slope_measurement}, {project_geodesic_azimuths}, {use_equatorial_aspect})

    Determines parameters of a raster surface such as aspect, slope and curvatures.

    Arguments:
    in_raster -- 
    parameter_type -- 
    local_surface_type -- 
    neighborhood_distance -- 
    use_adaptive_neighborhood -- 
    z_unit -- 
    output_slope_measurement -- 
    project_geodesic_azimuths -- 
    use_equatorial_aspect -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            parameter_type,
            local_surface_type,
            neighborhood_distance,
            use_adaptive_neighborhood,
            z_unit,
            output_slope_measurement,
            project_geodesic_azimuths,
            use_equatorial_aspect):
        out_raster = "#"
        result = arcpy.gp.SurfaceParameters_sa(
            in_raster,
            out_raster,
            parameter_type,
            local_surface_type,
            neighborhood_distance,
            use_adaptive_neighborhood,
            z_unit,
            output_slope_measurement,
            project_geodesic_azimuths,
            use_equatorial_aspect)
        return _wrapToolRaster(u"SurfaceParameters_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        parameter_type,
        local_surface_type,
        neighborhood_distance,
        use_adaptive_neighborhood,
        z_unit,
        output_slope_measurement,
        project_geodesic_azimuths,
        use_equatorial_aspect)
SurfaceParameters.__esri_toolname__ = "SurfaceParameters_sa"
SurfaceParameters.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10"
]


def TabulateArea(
        in_zone_data,
        zone_field,
        in_class_data,
        class_field,
        out_table,
        processing_cell_size="#",
        classes_as_rows="#"):
    """TabulateArea_sa(in_zone_data, zone_field, in_class_data, class_field, out_table, {processing_cell_size}, {classes_as_rows})

    Calculates cross-tabulated areas between two datasets and outputs a table.

    Arguments:
    in_zone_data -- 
    zone_field -- 
    in_class_data -- 
    class_field -- 
    out_table -- 
    processing_cell_size -- 
    classes_as_rows -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_zone_data,
            zone_field,
            in_class_data,
            class_field,
            out_table,
            processing_cell_size,
            classes_as_rows):
        result = arcpy.gp.TabulateArea_sa(
            in_zone_data,
            zone_field,
            in_class_data,
            class_field,
            out_table,
            processing_cell_size,
            classes_as_rows)
        return result
    return Wrapper(
        in_zone_data,
        zone_field,
        in_class_data,
        class_field,
        out_table,
        processing_cell_size,
        classes_as_rows)
TabulateArea.__esri_toolname__ = "TabulateArea_sa"
TabulateArea.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def Tan(
        in_raster_or_constant):
    """Tan_sa(in_raster_or_constant)

    Calculates the tangent of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Tan_sa",
            ["Tan", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Tan.__esri_toolname__ = "Tan_sa"
Tan.__esri_toolinfo__ = [
    "::::1"
]


def TanH(
        in_raster_or_constant):
    """TanH_sa(in_raster_or_constant)

    Calculates the hyperbolic tangent of cells in a raster.

    Arguments:
    in_raster_or_constant -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"TanH_sa",
            ["TanH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
TanH.__esri_toolname__ = "TanH_sa"
TanH.__esri_toolinfo__ = [
    "::::1"
]


def Test(
        in_raster,
        where_clause):
    """Test_sa(in_raster, where_clause)

    Performs a Boolean evaluation of the input raster using a logical expression.

    Arguments:
    in_raster -- 
    where_clause -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            where_clause):
        out_raster = "#"
        result = arcpy.gp.Test_sa(
            in_raster,
            where_clause,
            out_raster)
        return _wrapToolRaster(u"Test_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        where_clause)
Test.__esri_toolname__ = "Test_sa"
Test.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def Thin(
        in_raster,
        background_value="#",
        filter="#",
        corners="#",
        maximum_thickness="#"):
    """Thin_sa(in_raster, {background_value}, {filter}, {corners}, {maximum_thickness})

    Thins rasterized linear features by reducing the number of cells representing the width of the features.

    Arguments:
    in_raster -- 
    background_value -- 
    filter -- 
    corners -- 
    maximum_thickness -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            background_value,
            filter,
            corners,
            maximum_thickness):
        out_raster = "#"
        result = arcpy.gp.Thin_sa(
            in_raster,
            out_raster,
            background_value,
            filter,
            corners,
            maximum_thickness)
        return _wrapToolRaster(u"Thin_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        background_value,
        filter,
        corners,
        maximum_thickness)
Thin.__esri_toolname__ = "Thin_sa"
Thin.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def Times(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Times_sa(in_raster_or_constant1, in_raster_or_constant2)

    Multiplies the values of two rasters on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- 
    in_raster_or_constant2 -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Times_sa",
            ["Times", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Times.__esri_toolname__ = "Times_sa"
Times.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def TopoToRaster(
        topo_input,
        cell_size="#",
        extent="#",
        Margin="#",
        minimum_z_value="#",
        maximum_z_value="#",
        enforce="#",
        data_type="#",
        maximum_iterations="#",
        roughness_penalty="#",
        discrete_error_factor="#",
        vertical_standard_error="#",
        tolerance_1="#",
        tolerance_2="#",
        out_stream_features="#",
        out_sink_features="#",
        out_diagnostic_file="#",
        out_parameter_file="#",
        profile_penalty="#",
        out_residual_feature="#",
        out_stream_cliff_error_feature="#",
        out_contour_error_feature="#"):
    """TopoToRaster_sa(topo_input, {cell_size}, {extent}, {Margin}, {minimum_z_value}, {maximum_z_value}, {enforce}, {data_type}, {maximum_iterations}, {roughness_penalty}, {discrete_error_factor}, {vertical_standard_error}, {tolerance_1}, {tolerance_2}, {out_stream_features}, {out_sink_features}, {out_diagnostic_file}, {out_parameter_file}, {profile_penalty}, {out_residual_feature}, {out_stream_cliff_error_feature}, {out_contour_error_feature})

    Interpolates a hydrologically correct raster surface from point, line, and polygon data.

    Arguments:
    topo_input -- 
    cell_size -- 
    extent -- 
    Margin -- 
    minimum_z_value -- 
    maximum_z_value -- 
    enforce -- 
    data_type -- 
    maximum_iterations -- 
    roughness_penalty -- 
    discrete_error_factor -- 
    vertical_standard_error -- 
    tolerance_1 -- 
    tolerance_2 -- 
    out_stream_features -- 
    out_sink_features -- 
    out_diagnostic_file -- 
    out_parameter_file -- 
    profile_penalty -- 
    out_residual_feature -- 
    out_stream_cliff_error_feature -- 
    out_contour_error_feature -- 

    Results:
    out_surface_raster -- Output surface raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            topo_input,
            cell_size,
            extent,
            Margin,
            minimum_z_value,
            maximum_z_value,
            enforce,
            data_type,
            maximum_iterations,
            roughness_penalty,
            discrete_error_factor,
            vertical_standard_error,
            tolerance_1,
            tolerance_2,
            out_stream_features,
            out_sink_features,
            out_diagnostic_file,
            out_parameter_file,
            profile_penalty,
            out_residual_feature,
            out_stream_cliff_error_feature,
            out_contour_error_feature):
        topo_input = Utils.multiValueCompoundParameterToString(topo_input, ParameterClasses._TopoInput)
        extent = Utils.compoundParameterToString(extent, arcpy.Extent)
        out_surface_raster = "#"
        result = arcpy.gp.TopoToRaster_sa(
            topo_input,
            out_surface_raster,
            cell_size,
            extent,
            Margin,
            minimum_z_value,
            maximum_z_value,
            enforce,
            data_type,
            maximum_iterations,
            roughness_penalty,
            discrete_error_factor,
            vertical_standard_error,
            tolerance_1,
            tolerance_2,
            out_stream_features,
            out_sink_features,
            out_diagnostic_file,
            out_parameter_file,
            profile_penalty,
            out_residual_feature,
            out_stream_cliff_error_feature,
            out_contour_error_feature)
        return _wrapToolRaster(u"TopoToRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        topo_input,
        cell_size,
        extent,
        Margin,
        minimum_z_value,
        maximum_z_value,
        enforce,
        data_type,
        maximum_iterations,
        roughness_penalty,
        discrete_error_factor,
        vertical_standard_error,
        tolerance_1,
        tolerance_2,
        out_stream_features,
        out_sink_features,
        out_diagnostic_file,
        out_parameter_file,
        profile_penalty,
        out_residual_feature,
        out_stream_cliff_error_feature,
        out_contour_error_feature)
TopoToRaster.__esri_toolname__ = "TopoToRaster_sa"
TopoToRaster.__esri_toolinfo__ = [
    "Python::TopoBoundary|TopoCliff|TopoCoast|TopoContour|TopoExclusion|TopoLake|TopoPointElevation|TopoSink|TopoStream::",
    "::::3",
    "Python::Extent::",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14",
    "::::15",
    "::::16",
    "::::17",
    "::::18",
    "::::19",
    "::::20",
    "::::21",
    "::::22",
    "::::23"
]


def TopoToRasterByFile(
        in_parameter_file,
        out_stream_features="#",
        out_sink_features="#",
        out_residual_feature="#",
        out_stream_cliff_error_feature="#",
        out_contour_error_feature="#"):
    """TopoToRasterByFile_sa(in_parameter_file, {out_stream_features}, {out_sink_features}, {out_residual_feature}, {out_stream_cliff_error_feature}, {out_contour_error_feature})

    Interpolates a hydrologically correct raster surface from point, line, and polygon data using parameters specified in a file.

    Arguments:
    in_parameter_file -- 
    out_stream_features -- 
    out_sink_features -- 
    out_residual_feature -- 
    out_stream_cliff_error_feature -- 
    out_contour_error_feature -- 

    Results:
    out_surface_raster -- Output surface raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_parameter_file,
            out_stream_features,
            out_sink_features,
            out_residual_feature,
            out_stream_cliff_error_feature,
            out_contour_error_feature):
        out_surface_raster = "#"
        result = arcpy.gp.TopoToRasterByFile_sa(
            in_parameter_file,
            out_surface_raster,
            out_stream_features,
            out_sink_features,
            out_residual_feature,
            out_stream_cliff_error_feature,
            out_contour_error_feature)
        return _wrapToolRaster(u"TopoToRasterByFile_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_parameter_file,
        out_stream_features,
        out_sink_features,
        out_residual_feature,
        out_stream_cliff_error_feature,
        out_contour_error_feature)
TopoToRasterByFile.__esri_toolname__ = "TopoToRasterByFile_sa"
TopoToRasterByFile.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def TrainIsoClusterClassifier(
        in_raster,
        max_classes,
        out_classifier_definition,
        in_additional_raster="#",
        max_iterations="#",
        min_samples_per_cluster="#",
        skip_factor="#",
        used_attributes="#",
        max_merge_per_iter="#",
        max_merge_distance="#"):
    """TrainIsoClusterClassifier_sa(in_raster, max_classes, out_classifier_definition, {in_additional_raster}, {max_iterations}, {min_samples_per_cluster}, {skip_factor}, {[used_attribute,...]}, {max_merge_per_iter}, {max_merge_distance})

    Generates an Esri classifier definition file (.ecd) using the Iso Cluster classification definition.

    Arguments:
    in_raster -- 
    max_classes -- 
    out_classifier_definition -- 
    in_additional_raster -- 
    max_iterations -- 
    min_samples_per_cluster -- 
    skip_factor -- 
    used_attribute -- 
    max_merge_per_iter -- 
    max_merge_distance -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            max_classes,
            out_classifier_definition,
            in_additional_raster,
            max_iterations,
            min_samples_per_cluster,
            skip_factor,
            used_attributes,
            max_merge_per_iter,
            max_merge_distance):
        result = arcpy.gp.TrainIsoClusterClassifier_sa(
            in_raster,
            max_classes,
            out_classifier_definition,
            in_additional_raster,
            max_iterations,
            min_samples_per_cluster,
            skip_factor,
            used_attributes,
            max_merge_per_iter,
            max_merge_distance)
        return result
    return Wrapper(
        in_raster,
        max_classes,
        out_classifier_definition,
        in_additional_raster,
        max_iterations,
        min_samples_per_cluster,
        skip_factor,
        used_attributes,
        max_merge_per_iter,
        max_merge_distance)
TrainIsoClusterClassifier.__esri_toolname__ = "TrainIsoClusterClassifier_sa"
TrainIsoClusterClassifier.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10"
]


def TrainKNearestNeighborClassifier(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster="#",
        kNN="#",
        max_samples_per_class="#",
        used_attributes="#",
        dimension_value_field="#"):
    """TrainKNearestNeighborClassifier_sa(in_raster, in_training_features, out_classifier_definition, {in_additional_raster}, {kNN}, {max_samples_per_class}, {[used_attribute,...]}, {dimension_value_field})

    Generates an Esri classifier definition file (.ecd) using the K-Nearest Neighbor classification method.

    Arguments:
    in_raster -- 
    in_training_features -- 
    out_classifier_definition -- 
    in_additional_raster -- 
    kNN -- 
    max_samples_per_class -- 
    used_attribute -- 
    dimension_value_field -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            kNN,
            max_samples_per_class,
            used_attributes,
            dimension_value_field):
        result = arcpy.gp.TrainKNearestNeighborClassifier_sa(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            kNN,
            max_samples_per_class,
            used_attributes,
            dimension_value_field)
        return result
    return Wrapper(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster,
        kNN,
        max_samples_per_class,
        used_attributes,
        dimension_value_field)
TrainKNearestNeighborClassifier.__esri_toolname__ = "TrainKNearestNeighborClassifier_sa"
TrainKNearestNeighborClassifier.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8"
]


def TrainMaximumLikelihoodClassifier(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster="#",
        used_attributes="#",
        dimension_value_field="#"):
    """TrainMaximumLikelihoodClassifier_sa(in_raster, in_training_features, out_classifier_definition, {in_additional_raster}, {[used_attribute,...]}, {dimension_value_field})

    Generates an Esri classifier definition file (.ecd) using the Maximum Likelihood Classifier (MLC) classification definition.

    Arguments:
    in_raster -- 
    in_training_features -- 
    out_classifier_definition -- 
    in_additional_raster -- 
    used_attribute -- 
    dimension_value_field -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            used_attributes,
            dimension_value_field):
        result = arcpy.gp.TrainMaximumLikelihoodClassifier_sa(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            used_attributes,
            dimension_value_field)
        return result
    return Wrapper(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster,
        used_attributes,
        dimension_value_field)
TrainMaximumLikelihoodClassifier.__esri_toolname__ = "TrainMaximumLikelihoodClassifier_sa"
TrainMaximumLikelihoodClassifier.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def TrainRandomTreesClassifier(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster="#",
        max_num_trees="#",
        max_tree_depth="#",
        max_samples_per_class="#",
        used_attributes="#",
        dimension_value_field="#"):
    """TrainRandomTreesClassifier_sa(in_raster, in_training_features, out_classifier_definition, {in_additional_raster}, {max_num_trees}, {max_tree_depth}, {max_samples_per_class}, {[used_attribute,...]}, {dimension_value_field})

    Generates an Esri classifier definition file (.ecd) using the Random Trees classification method.

    Arguments:
    in_raster -- 
    in_training_features -- 
    out_classifier_definition -- 
    in_additional_raster -- 
    max_num_trees -- 
    max_tree_depth -- 
    max_samples_per_class -- 
    used_attribute -- 
    dimension_value_field -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            max_num_trees,
            max_tree_depth,
            max_samples_per_class,
            used_attributes,
            dimension_value_field):
        result = arcpy.gp.TrainRandomTreesClassifier_sa(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            max_num_trees,
            max_tree_depth,
            max_samples_per_class,
            used_attributes,
            dimension_value_field)
        return result
    return Wrapper(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster,
        max_num_trees,
        max_tree_depth,
        max_samples_per_class,
        used_attributes,
        dimension_value_field)
TrainRandomTreesClassifier.__esri_toolname__ = "TrainRandomTreesClassifier_sa"
TrainRandomTreesClassifier.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9"
]


def TrainSupportVectorMachineClassifier(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster="#",
        max_samples_per_class="#",
        used_attributes="#",
        dimension_value_field="#"):
    """TrainSupportVectorMachineClassifier_sa(in_raster, in_training_features, out_classifier_definition, {in_additional_raster}, {max_samples_per_class}, {[used_attribute,...]}, {dimension_value_field})

    Generates an Esri classifier definition file (.ecd) using the Support Vector Machine (SVM) classification definition.

    Arguments:
    in_raster -- 
    in_training_features -- 
    out_classifier_definition -- 
    in_additional_raster -- 
    max_samples_per_class -- 
    used_attribute -- 
    dimension_value_field -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            max_samples_per_class,
            used_attributes,
            dimension_value_field):
        result = arcpy.gp.TrainSupportVectorMachineClassifier_sa(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            max_samples_per_class,
            used_attributes,
            dimension_value_field)
        return result
    return Wrapper(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster,
        max_samples_per_class,
        used_attributes,
        dimension_value_field)
TrainSupportVectorMachineClassifier.__esri_toolname__ = "TrainSupportVectorMachineClassifier_sa"
TrainSupportVectorMachineClassifier.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def Trend(
        in_point_features,
        z_field,
        cell_size="#",
        order="#",
        regression_type="#",
        out_rms_file="#"):
    """Trend_sa(in_point_features, z_field, {cell_size}, {order}, {regression_type}, {out_rms_file})

    Interpolates a raster surface from points using a trend technique.

    Arguments:
    in_point_features -- 
    z_field -- 
    cell_size -- 
    order -- 
    regression_type -- 
    out_rms_file -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_point_features,
            z_field,
            cell_size,
            order,
            regression_type,
            out_rms_file):
        out_raster = "#"
        result = arcpy.gp.Trend_sa(
            in_point_features,
            z_field,
            out_raster,
            cell_size,
            order,
            regression_type,
            out_rms_file)
        return _wrapToolRaster(u"Trend_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_point_features,
        z_field,
        cell_size,
        order,
        regression_type,
        out_rms_file)
Trend.__esri_toolname__ = "Trend_sa"
Trend.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def UpdateAccuracyAssessmentPoints(
        in_class_data,
        in_points,
        out_points,
        target_field="#",
        polygon_dimension_field="#",
        point_dimension_field="#"):
    """UpdateAccuracyAssessmentPoints_sa(in_class_data, in_points, out_points, {target_field}, {polygon_dimension_field}, {point_dimension_field})

    Updates the Target field in the attribute table to compare reference points to the classified image.

    Arguments:
    in_class_data -- 
    in_points -- 
    out_points -- 
    target_field -- 
    polygon_dimension_field -- 
    point_dimension_field -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_class_data,
            in_points,
            out_points,
            target_field,
            polygon_dimension_field,
            point_dimension_field):
        result = arcpy.gp.UpdateAccuracyAssessmentPoints_sa(
            in_class_data,
            in_points,
            out_points,
            target_field,
            polygon_dimension_field,
            point_dimension_field)
        return result
    return Wrapper(
        in_class_data,
        in_points,
        out_points,
        target_field,
        polygon_dimension_field,
        point_dimension_field)
UpdateAccuracyAssessmentPoints.__esri_toolname__ = "UpdateAccuracyAssessmentPoints_sa"
UpdateAccuracyAssessmentPoints.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def Viewshed(
        in_raster,
        in_observer_features,
        z_factor="#",
        curvature_correction="#",
        refractivity_coefficient="#",
        out_agl_raster="#"):
    """Viewshed_sa(in_raster, in_observer_features, {z_factor}, {curvature_correction}, {refractivity_coefficient}, {out_agl_raster})

    Determines the raster surface locations visible to a set of observer features.

    Arguments:
    in_raster -- 
    in_observer_features -- 
    z_factor -- 
    curvature_correction -- 
    refractivity_coefficient -- 
    out_agl_raster -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_observer_features,
            z_factor,
            curvature_correction,
            refractivity_coefficient,
            out_agl_raster):
        out_raster = "#"
        result = arcpy.gp.Viewshed_sa(
            in_raster,
            in_observer_features,
            out_raster,
            z_factor,
            curvature_correction,
            refractivity_coefficient,
            out_agl_raster)
        return _wrapToolRaster(u"Viewshed_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_observer_features,
        z_factor,
        curvature_correction,
        refractivity_coefficient,
        out_agl_raster)
Viewshed.__esri_toolname__ = "Viewshed_sa"
Viewshed.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def Viewshed2(
        in_raster,
        in_observer_features,
        out_agl_raster="#",
        analysis_type="#",
        vertical_error="#",
        out_observer_region_relationship_table="#",
        refractivity_coefficient="#",
        surface_offset="#",
        observer_elevation="#",
        observer_offset="#",
        inner_radius="#",
        inner_radius_is_3d="#",
        outer_radius="#",
        outer_radius_is_3d="#",
        horizontal_start_angle="#",
        horizontal_end_angle="#",
        vertical_upper_angle="#",
        vertical_lower_angle="#",
        analysis_method="#"):
    """Viewshed2_sa(in_raster, in_observer_features, {out_agl_raster}, {analysis_type}, {vertical_error}, {out_observer_region_relationship_table}, {refractivity_coefficient}, {surface_offset}, {observer_elevation}, {observer_offset}, {inner_radius}, {inner_radius_is_3d}, {outer_radius}, {outer_radius_is_3d}, {horizontal_start_angle}, {horizontal_end_angle}, {vertical_upper_angle}, {vertical_lower_angle}, {analysis_method})

    Determines the raster surface locations visible to a set of observer features using geodesic methods.

    Arguments:
    in_raster -- 
    in_observer_features -- 
    out_agl_raster -- 
    analysis_type -- 
    vertical_error -- 
    out_observer_region_relationship_table -- 
    refractivity_coefficient -- 
    surface_offset -- 
    observer_elevation -- 
    observer_offset -- 
    inner_radius -- 
    inner_radius_is_3d -- 
    outer_radius -- 
    outer_radius_is_3d -- 
    horizontal_start_angle -- 
    horizontal_end_angle -- 
    vertical_upper_angle -- 
    vertical_lower_angle -- 
    analysis_method -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_observer_features,
            out_agl_raster,
            analysis_type,
            vertical_error,
            out_observer_region_relationship_table,
            refractivity_coefficient,
            surface_offset,
            observer_elevation,
            observer_offset,
            inner_radius,
            inner_radius_is_3d,
            outer_radius,
            outer_radius_is_3d,
            horizontal_start_angle,
            horizontal_end_angle,
            vertical_upper_angle,
            vertical_lower_angle,
            analysis_method):
        out_raster = "#"
        result = arcpy.gp.Viewshed2_sa(
            in_raster,
            in_observer_features,
            out_raster,
            out_agl_raster,
            analysis_type,
            vertical_error,
            out_observer_region_relationship_table,
            refractivity_coefficient,
            surface_offset,
            observer_elevation,
            observer_offset,
            inner_radius,
            inner_radius_is_3d,
            outer_radius,
            outer_radius_is_3d,
            horizontal_start_angle,
            horizontal_end_angle,
            vertical_upper_angle,
            vertical_lower_angle,
            analysis_method)
        return _wrapToolRaster(u"Viewshed2_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_observer_features,
        out_agl_raster,
        analysis_type,
        vertical_error,
        out_observer_region_relationship_table,
        refractivity_coefficient,
        surface_offset,
        observer_elevation,
        observer_offset,
        inner_radius,
        inner_radius_is_3d,
        outer_radius,
        outer_radius_is_3d,
        horizontal_start_angle,
        horizontal_end_angle,
        vertical_upper_angle,
        vertical_lower_angle,
        analysis_method)
Viewshed2.__esri_toolname__ = "Viewshed2_sa"
Viewshed2.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14",
    "::::15",
    "::::16",
    "::::17",
    "::::18",
    "::::19",
    "::::20"
]


def Visibility(
        in_raster,
        in_observer_features,
        out_agl_raster="#",
        analysis_type="#",
        nonvisible_cell_value="#",
        z_factor="#",
        curvature_correction="#",
        refractivity_coefficient="#",
        surface_offset="#",
        observer_elevation="#",
        observer_offset="#",
        inner_radius="#",
        outer_radius="#",
        horizontal_start_angle="#",
        horizontal_end_angle="#",
        vertical_upper_angle="#",
        vertical_lower_angle="#"):
    """Visibility_sa(in_raster, in_observer_features, {out_agl_raster}, {analysis_type}, {nonvisible_cell_value}, {z_factor}, {curvature_correction}, {refractivity_coefficient}, {surface_offset}, {observer_elevation}, {observer_offset}, {inner_radius}, {outer_radius}, {horizontal_start_angle}, {horizontal_end_angle}, {vertical_upper_angle}, {vertical_lower_angle})

    Determines the raster surface locations visible to a set of observer features, or identifies which observer points are visible from each raster surface location.

    Arguments:
    in_raster -- 
    in_observer_features -- 
    out_agl_raster -- 
    analysis_type -- 
    nonvisible_cell_value -- 
    z_factor -- 
    curvature_correction -- 
    refractivity_coefficient -- 
    surface_offset -- 
    observer_elevation -- 
    observer_offset -- 
    inner_radius -- 
    outer_radius -- 
    horizontal_start_angle -- 
    horizontal_end_angle -- 
    vertical_upper_angle -- 
    vertical_lower_angle -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_observer_features,
            out_agl_raster,
            analysis_type,
            nonvisible_cell_value,
            z_factor,
            curvature_correction,
            refractivity_coefficient,
            surface_offset,
            observer_elevation,
            observer_offset,
            inner_radius,
            outer_radius,
            horizontal_start_angle,
            horizontal_end_angle,
            vertical_upper_angle,
            vertical_lower_angle):
        out_raster = "#"
        result = arcpy.gp.Visibility_sa(
            in_raster,
            in_observer_features,
            out_raster,
            out_agl_raster,
            analysis_type,
            nonvisible_cell_value,
            z_factor,
            curvature_correction,
            refractivity_coefficient,
            surface_offset,
            observer_elevation,
            observer_offset,
            inner_radius,
            outer_radius,
            horizontal_start_angle,
            horizontal_end_angle,
            vertical_upper_angle,
            vertical_lower_angle)
        return _wrapToolRaster(u"Visibility_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_observer_features,
        out_agl_raster,
        analysis_type,
        nonvisible_cell_value,
        z_factor,
        curvature_correction,
        refractivity_coefficient,
        surface_offset,
        observer_elevation,
        observer_offset,
        inner_radius,
        outer_radius,
        horizontal_start_angle,
        horizontal_end_angle,
        vertical_upper_angle,
        vertical_lower_angle)
Visibility.__esri_toolname__ = "Visibility_sa"
Visibility.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14",
    "::::15",
    "::::16",
    "::::17",
    "::::18"
]


def Watershed(
        in_flow_direction_raster,
        in_pour_point_data,
        pour_point_field="#"):
    """Watershed_sa(in_flow_direction_raster, in_pour_point_data, {pour_point_field})

    Determines the contributing area above a set of cells in a raster.

    Arguments:
    in_flow_direction_raster -- 
    in_pour_point_data -- 
    pour_point_field -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_flow_direction_raster,
            in_pour_point_data,
            pour_point_field):
        out_raster = "#"
        result = arcpy.gp.Watershed_sa(
            in_flow_direction_raster,
            in_pour_point_data,
            out_raster,
            pour_point_field)
        return _wrapToolRaster(u"Watershed_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_flow_direction_raster,
        in_pour_point_data,
        pour_point_field)
Watershed.__esri_toolname__ = "Watershed_sa"
Watershed.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def WeightedOverlay(
        in_weighted_overlay_table):
    """WeightedOverlay_sa(in_weighted_overlay_table)

    Overlays several rasters using a common measurement scale and weights each according to its importance.

    Arguments:
    in_weighted_overlay_table -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_weighted_overlay_table):
        in_weighted_overlay_table = Utils.compoundParameterToString(in_weighted_overlay_table, ParameterClasses.WOTable)
        # Convert classic GP tool parameter signature to raster function arguments
        args = {}
        # parse input parameters
        msgs = Utils.ParameterErrors()
        import re as _re
        # separate eval[from,to] parameters from table argument
        table_eval_pattern = _re.compile(pattern=r"""
            ^                  # beginning of string
            \s*                # any amount of white space
            \(                 # literal parenthesis
            \s*                # any amount of white space
            (?P<table>.*\S)    # table string
            \s*                # any amount of white space
            \)                 # literal parenthesis
            \s*                # any amount of white space
            ;                  # literal semicolon
            \s*                # any amount of white space
            (?P<EvalFrom>\S+)  # EvalFrom argument
            \s+                # one or more spaces
            (?P<EvalTo>\S+)    # EvalTo argument
            (?:\s+\S+)?        # optional increment (ignored)
            \s*                # any amount of white space
            $                  # end of string
        """, flags=_re.VERBOSE)
        m = table_eval_pattern.match(in_weighted_overlay_table)
        assert m is not None
        args["EvalFrom"] = int(m.group("EvalFrom"))
        args["EvalTo"] = int(m.group("EvalTo"))
        table_string = m.group("table")
        # parse raster entries
        cs = r"[^;()]"  # non-punctuation character
        c = r"[^;() ]"  # neither punctuation nor space
        entry_pattern = _re.compile(pattern=fr"""
          \s*
          (?P<raster>{cs}*{c})  # raster
          \s+
          (?P<influence>{c}+)   # influence
          \s+
          (?P<field>{c}+)       # field name
          \s+
          \(                    # literal open parenthesis
          (?P<remap>[^)]+)      # remap
          \)                    # literal close parenthesis
          \s*
        """, flags=_re.VERBOSE)
        rasters = []
        influences = []
        fields = []
        remaps = []
        total_influence = 0.0
        for m in _re.finditer(entry_pattern, table_string):
            r = m.group("raster").strip("'\"").strip()
            if len(r) < 1:
                msgs.add_id_message("INFO", 583)  # Failed to execute. Parameters are not valid.
                msgs.add_id_message("ERROR", 10629, r)  # The input layer name %s is either invalid or is empty
                msgs.add_id_message("INFO", 952, "WeightedOverlay")  # Failed to execute (tool_name).
                raise arcpy.ExecuteError(msgs.combine())
            i = float(m.group("influence"))
            total_influence += i
            #
            f = m.group("field").strip("'\"")
            ras = arcpy.Raster(r)
            if ras.hasRAT:
                try:
                    c = arcpy.da.SearchCursor(str(ras), [f, ])
                    numFields = len(c.fields)
                except RuntimeError as exc:
                    msgs.add_id_message("INFO", 583)  # Failed to execute. Parameters are not valid.
                    msgs.add_id_message("ERROR", 10631, f, r)  # Invalid field name %1 or field does not exist in layer %2
                    msgs.add_id_message("INFO", 952, "WeightedOverlay")  # Failed to execute (tool_name).
                    raise arcpy.ExecuteError(msgs.combine())
            remap = m.group("remap")
            rasters.append(r)
            influences.append(i)
            fields.append(f)
            remap = remap.replace(",", "")  # strip out spurious commas
            remaps.append(remap)
        assert len(rasters) > 0
        # Force influences to sum to 1.0
        if total_influence != 0:
            influences[:] = [i / float(total_influence) for i in influences]
        args["Rasters"] = rasters
        args["Influences"] = influences
        args["Fields"] = fields
        args["Remaps"] = remaps
        args["ExtentType"] = 1  # 1: Intersection of extents
        args["CellsizeType"] = 2  # 2: Maximum of cell sizes
        result = arcpy.sa.Apply(rasters, "WeightedOverlay", args)
        result = ApplyEnvironment(result)
        return result
    return Wrapper(
        in_weighted_overlay_table)
WeightedOverlay.__esri_toolname__ = "WeightedOverlay_sa"
WeightedOverlay.__esri_toolinfo__ = [
    "Python::WOTable::"
]


def WeightedSum(
        in_weighted_sum_table):
    """WeightedSum_sa(in_weighted_sum_table)

    Overlays several rasters, multiplying each by their given weight and summing them together.

    Arguments:
    in_weighted_sum_table -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_weighted_sum_table):
        in_weighted_sum_table = Utils.compoundParameterToString(in_weighted_sum_table, ParameterClasses.WSTable)
        # parse out raster names to use as local function arguments
        import re as _re  # Use underscore to avoid polluting user's namespace
        # Construct a regular expression to parse the string version of a single weighted sum table entry
        # for example: "'landuse.tif' VALUE 0.34"
        pattern = _re.compile(pattern=r"""
            ^                   # beginning of string
            \s*                 # any amount of white space
            (?P<raster>.*\S)    # 1. raster name
            \s+                 # at least one white space
            (?P<field>\S+)      # 2. raster field name
            \s+                 # at least one white space
            (?P<weight>\S+)     # 3. raster weight value
            \s*                 # any amount of white space
            $                   # end of string
        """, flags=_re.VERBOSE)
        rasters = ["WeightedSum", ]  # local functions take a list of op name followed by rasters
        fields = []
        weights = []
        for item in in_weighted_sum_table.split(";"):
            item = item.strip()
            if len(item) < 1:
                continue
            m = pattern.match(item)
            raster_name = m.group("raster")
            raster_field = m.group("field")
            weight = float(m.group("weight"))
            raster_name = raster_name.strip("\"'")  # remove surrounding quotation marks
            rasters.append(raster_name)
            fields.append(raster_field)
            weights.append(weight)
        return _wrapLocalFunctionRaster(
            u"WeightedSum_sa",
            rasters,
            {"fields": fields, "weights": weights, "flattenBands": True},
        )
    return Wrapper(
        in_weighted_sum_table)
WeightedSum.__esri_toolname__ = "WeightedSum_sa"
WeightedSum.__esri_toolinfo__ = [
    "Python::WSTable::"
]


def ZonalFill(
        in_zone_raster,
        in_weight_raster):
    """ZonalFill_sa(in_zone_raster, in_weight_raster)

    Fills zones using the minimum cell value from a weight raster along the zone boundary.

    Arguments:
    in_zone_raster -- 
    in_weight_raster -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_zone_raster,
            in_weight_raster):
        out_raster = "#"
        result = arcpy.gp.ZonalFill_sa(
            in_zone_raster,
            in_weight_raster,
            out_raster)
        return _wrapToolRaster(u"ZonalFill_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_zone_raster,
        in_weight_raster)
ZonalFill.__esri_toolname__ = "ZonalFill_sa"
ZonalFill.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def ZonalGeometry(
        in_zone_data,
        zone_field,
        geometry_type="#",
        cell_size="#"):
    """ZonalGeometry_sa(in_zone_data, zone_field, {geometry_type}, {cell_size})

    Calculates the specified geometry measure (area, perimeter, thickness, or the characteristics of ellipse) for each zone in a dataset.

    Arguments:
    in_zone_data -- 
    zone_field -- 
    geometry_type -- 
    cell_size -- 

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_zone_data,
            zone_field,
            geometry_type,
            cell_size):
        out_raster = "#"
        result = arcpy.gp.ZonalGeometry_sa(
            in_zone_data,
            zone_field,
            out_raster,
            geometry_type,
            cell_size)
        return _wrapToolRaster(u"ZonalGeometry_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_zone_data,
        zone_field,
        geometry_type,
        cell_size)
ZonalGeometry.__esri_toolname__ = "ZonalGeometry_sa"
ZonalGeometry.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5"
]


def ZonalGeometryAsTable(
        in_zone_data,
        zone_field,
        out_table,
        processing_cell_size="#"):
    """ZonalGeometryAsTable_sa(in_zone_data, zone_field, out_table, {processing_cell_size})

    Calculates the geometry measures (area, perimeter, thickness, and the characteristics of ellipse) for each zone in a dataset and reports the results as a table.

    Arguments:
    in_zone_data -- 
    zone_field -- 
    out_table -- 
    processing_cell_size -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_zone_data,
            zone_field,
            out_table,
            processing_cell_size):
        result = arcpy.gp.ZonalGeometryAsTable_sa(
            in_zone_data,
            zone_field,
            out_table,
            processing_cell_size)
        return result
    return Wrapper(
        in_zone_data,
        zone_field,
        out_table,
        processing_cell_size)
ZonalGeometryAsTable.__esri_toolname__ = "ZonalGeometryAsTable_sa"
ZonalGeometryAsTable.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4"
]


def ZonalHistogram(
        in_zone_data,
        zone_field,
        in_value_raster,
        out_table,
        out_graph="#",
        zones_as_rows="#"):
    """ZonalHistogram_sa(in_zone_data, zone_field, in_value_raster, out_table, {out_graph}, {zones_as_rows})

    Creates a table and a histogram graph that show the frequency distribution of cell values on the value input for each unique zone.

    Arguments:
    in_zone_data -- 
    zone_field -- 
    in_value_raster -- 
    out_table -- 
    out_graph -- 
    zones_as_rows -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_zone_data,
            zone_field,
            in_value_raster,
            out_table,
            out_graph,
            zones_as_rows):
        result = arcpy.gp.ZonalHistogram_sa(
            in_zone_data,
            zone_field,
            in_value_raster,
            out_table,
            out_graph,
            zones_as_rows)
        return result
    return Wrapper(
        in_zone_data,
        zone_field,
        in_value_raster,
        out_table,
        out_graph,
        zones_as_rows)
ZonalHistogram.__esri_toolname__ = "ZonalHistogram_sa"
ZonalHistogram.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def ZonalStatistics(
        in_zone_data,
        zone_field,
        in_value_raster,
        statistics_type="#",
        ignore_nodata="#",
        process_as_multidimensional="#",
        percentile_value="#",
        percentile_interpolation_type="#",
        circular_calculation="#",
        circular_wrap_value="#"):
    """ZonalStatistics_sa(in_zone_data, zone_field, in_value_raster, {statistics_type}, {ignore_nodata}, {process_as_multidimensional}, {percentile_value}, {percentile_interpolation_type}, {circular_calculation}, {circular_wrap_value})

    Summarizes the values of a raster within the zones of another dataset.

    Arguments:
    in_zone_data -- 
    zone_field -- 
    in_value_raster -- 
    statistics_type -- 
    ignore_nodata -- 
    process_as_multidimensional -- 
    percentile_value -- 
    percentile_interpolation_type -- 
    circular_calculation -- 
    circular_wrap_value -- 

    Results:
    out_raster -- Output Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_zone_data,
            zone_field,
            in_value_raster,
            statistics_type,
            ignore_nodata,
            process_as_multidimensional,
            percentile_value,
            percentile_interpolation_type,
            circular_calculation,
            circular_wrap_value):
        out_raster = "#"
        result = arcpy.gp.ZonalStatistics_sa(
            in_zone_data,
            zone_field,
            in_value_raster,
            out_raster,
            statistics_type,
            ignore_nodata,
            process_as_multidimensional,
            percentile_value,
            percentile_interpolation_type,
            circular_calculation,
            circular_wrap_value)
        return _wrapToolRaster(u"ZonalStatistics_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_zone_data,
        zone_field,
        in_value_raster,
        statistics_type,
        ignore_nodata,
        process_as_multidimensional,
        percentile_value,
        percentile_interpolation_type,
        circular_calculation,
        circular_wrap_value)
ZonalStatistics.__esri_toolname__ = "ZonalStatistics_sa"
ZonalStatistics.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11"
]


def ZonalStatisticsAsTable(
        in_zone_data,
        zone_field,
        in_value_raster,
        out_table,
        ignore_nodata="#",
        statistics_type="#",
        process_as_multidimensional="#",
        percentile_values="#",
        percentile_interpolation_type="#",
        circular_calculation="#",
        circular_wrap_value="#"):
    """ZonalStatisticsAsTable_sa(in_zone_data, zone_field, in_value_raster, out_table, {ignore_nodata}, {statistics_type}, {process_as_multidimensional}, {[percentile_value,...]}, {percentile_interpolation_type}, {circular_calculation}, {circular_wrap_value})

    Summarizes the values of a raster within the zones of another dataset and reports the results as a table.

    Arguments:
    in_zone_data -- 
    zone_field -- 
    in_value_raster -- 
    out_table -- 
    ignore_nodata -- 
    statistics_type -- 
    process_as_multidimensional -- 
    percentile_value -- 
    percentile_interpolation_type -- 
    circular_calculation -- 
    circular_wrap_value -- """
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_zone_data,
            zone_field,
            in_value_raster,
            out_table,
            ignore_nodata,
            statistics_type,
            process_as_multidimensional,
            percentile_values,
            percentile_interpolation_type,
            circular_calculation,
            circular_wrap_value):
        result = arcpy.gp.ZonalStatisticsAsTable_sa(
            in_zone_data,
            zone_field,
            in_value_raster,
            out_table,
            ignore_nodata,
            statistics_type,
            process_as_multidimensional,
            percentile_values,
            percentile_interpolation_type,
            circular_calculation,
            circular_wrap_value)
        return result
    return Wrapper(
        in_zone_data,
        zone_field,
        in_value_raster,
        out_table,
        ignore_nodata,
        statistics_type,
        process_as_multidimensional,
        percentile_values,
        percentile_interpolation_type,
        circular_calculation,
        circular_wrap_value)
ZonalStatisticsAsTable.__esri_toolname__ = "ZonalStatisticsAsTable_sa"
ZonalStatisticsAsTable.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11"
]

def ApplyEnvironment(
        in_raster):
    """ApplyEnvironment(in_raster)

    Creates a copy of in_raster with environment settings applied.

    Arguments:
    in_raster -- The input that will be copied.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def wrapper(in_raster):
        return _wrapLocalFunctionRaster(u"ApplyEnvironment",
            ["Copy", in_raster])
    return wrapper(
        in_raster)

def FloatDivide(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """FloatDivide(in_raster_or_constant1, in_raster_or_constant2)

    Divides the values of two rasters on a cell-by-cell basis. The result will
    be a true floating point division.

    Arguments:
    in_raster_or_constant1 -- The input whose values will be divided by the second input.
    in_raster_or_constant2 -- The input whose values the first input are to be divided by.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def wrapper(in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Divide_sa",
            ["FloatDivide", in_raster_or_constant1, in_raster_or_constant2])
    return wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)

def FloorDivide(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """FloorDivide(in_raster_or_constant1, in_raster_or_constant2)

    Divides the values of two rasters on a cell-by-cell basis. The result will
    be a floored floating point division.

    Arguments:
    in_raster_or_constant1 -- The input whose values will be divided by the second input.
    in_raster_or_constant2 -- The input whose values the first input are to be divided by.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Divide_sa",
            ["FloorDivide", in_raster_or_constant1, in_raster_or_constant2])
    return wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)